/* SourceList.c generated by valac 0.42.6, the Vala compiler
 * generated from SourceList.vala, do not modify */

/*
 *  Copyright (C) 2012-2014 Victor Martinez <victoreduardm@gmail.com>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/**
         * = WORKING INTERNALS =
         *
         * In order to offer a transparent Item-based API, and avoid the need of providing methods
         * to deal with items directly on the SourceListPatch widget, it was decided to follow a monitor-like
         * implementation, where the source list permanently monitors its root item and any other
         * child item added to it. The task of monitoring the properties of the items has been
         * divided among different objects, as shown below:
         *
         * Monitored by: Object::method that receives the signals indicating the property change.
         * Applied by: Object::method that actually updates the tree to reflect the property changes
         *             (directly or indirectly, as in the case of the tree data model).
         *
         * ---------------------------------------------------------------------------------------------
         *   PROPERTY        |  MONITORED BY                     |  APPLIED BY
         * ---------------------------------------------------------------------------------------------
         * + Item            |                                   |
         *   - parent        | Not monitored                     | N/A
         *   - name          | DataModel::on_item_prop_changed   | Tree::name_cell_data_func
         *   - editable      | DataModel::on_item_prop_changed   | Queried when needed (See Tree::start_editing_item)
         *   - visible       | DataModel::on_item_prop_changed   | DataModel::filter_visible_func
         *   - icon          | DataModel::on_item_prop_changed   | Tree::icon_cell_data_func
         *   - activatable   | Same as @icon                     | Same as @icon
         * + ExpandableItem  |                                   |
         *   - collapsible   | DataModel::on_item_prop_changed   | Tree::update_expansion
         *                   |                                   | Tree::expander_cell_data_func
         *   - expanded      | Same as @collapsible              | Same as @collapsible
         * ---------------------------------------------------------------------------------------------
         * * Only automatic properties are monitored. ExpandableItem's additions/removals are handled by
         *   DataModel::add_item() and DataModel::remove_item()
         *
         * Other features:
         * - Sorting: this happens on the tree-model level (DataModel).
         */


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>
#include <cairo.h>
#include <granite.h>
#include <gobject/gvaluecollector.h>


#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE (granite_widgets_source_list_patch_sortable_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE, GraniteWidgetsSourceListPatchSortable))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_PATCH_SORTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE, GraniteWidgetsSourceListPatchSortableIface))

typedef struct _GraniteWidgetsSourceListPatchSortable GraniteWidgetsSourceListPatchSortable;
typedef struct _GraniteWidgetsSourceListPatchSortableIface GraniteWidgetsSourceListPatchSortableIface;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM (granite_widgets_source_list_patch_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItem))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItemClass))

typedef struct _GraniteWidgetsSourceListPatchItem GraniteWidgetsSourceListPatchItem;
typedef struct _GraniteWidgetsSourceListPatchItemClass GraniteWidgetsSourceListPatchItemClass;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM (granite_widgets_source_list_patch_expandable_item_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItem))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItemClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_EXPANDABLE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_EXPANDABLE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItemClass))

typedef struct _GraniteWidgetsSourceListPatchExpandableItem GraniteWidgetsSourceListPatchExpandableItem;
typedef struct _GraniteWidgetsSourceListPatchExpandableItemClass GraniteWidgetsSourceListPatchExpandableItemClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_USER_MOVED_ITEM_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE (granite_widgets_source_list_patch_drag_source_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE, GraniteWidgetsSourceListPatchDragSource))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_PATCH_DRAG_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE, GraniteWidgetsSourceListPatchDragSourceIface))

typedef struct _GraniteWidgetsSourceListPatchDragSource GraniteWidgetsSourceListPatchDragSource;
typedef struct _GraniteWidgetsSourceListPatchDragSourceIface GraniteWidgetsSourceListPatchDragSourceIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST (granite_widgets_source_list_patch_drag_dest_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST, GraniteWidgetsSourceListPatchDragDest))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_PATCH_DRAG_DEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_DEST_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST, GraniteWidgetsSourceListPatchDragDestIface))

typedef struct _GraniteWidgetsSourceListPatchDragDest GraniteWidgetsSourceListPatchDragDest;
typedef struct _GraniteWidgetsSourceListPatchDragDestIface GraniteWidgetsSourceListPatchDragDestIface;

#define GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH (granite_widgets_source_list_patch_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatch))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatchClass))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_PATCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH))
#define GRANITE_WIDGETS_IS_SOURCE_LIST_PATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatchClass))

typedef struct _GraniteWidgetsSourceListPatch GraniteWidgetsSourceListPatch;
typedef struct _GraniteWidgetsSourceListPatchClass GraniteWidgetsSourceListPatchClass;
typedef struct _GraniteWidgetsSourceListPatchPrivate GraniteWidgetsSourceListPatchPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE (granite_widgets_source_list_patch_tree_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTree))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTreeClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_TREE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_TREE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTreeClass))

typedef struct _GraniteWidgetsSourceListPatchTree GraniteWidgetsSourceListPatchTree;
typedef struct _GraniteWidgetsSourceListPatchTreeClass GraniteWidgetsSourceListPatchTreeClass;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL (granite_widgets_source_list_patch_data_model_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModel))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModelClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_DATA_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_DATA_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModelClass))

typedef struct _GraniteWidgetsSourceListPatchDataModel GraniteWidgetsSourceListPatchDataModel;
typedef struct _GraniteWidgetsSourceListPatchDataModelClass GraniteWidgetsSourceListPatchDataModelClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EDITING_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef gboolean (*GraniteWidgetsSourceListPatchVisibleFunc) (GraniteWidgetsSourceListPatchItem* item, gpointer user_data);
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListPatchItemPrivate GraniteWidgetsSourceListPatchItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTION_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NUM_SIGNALS] = {0};
typedef struct _GraniteWidgetsSourceListPatchExpandableItemPrivate GraniteWidgetsSourceListPatchExpandableItemPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILDREN_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_TOGGLED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_NUM_SIGNALS] = {0};
typedef struct _GraniteWidgetsSourceListPatchDataModelPrivate GraniteWidgetsSourceListPatchDataModelPrivate;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER (granite_widgets_source_list_patch_data_model_node_wrapper_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListPatchDataModelNodeWrapper))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListPatchDataModelNodeWrapperClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_IS_NODE_WRAPPER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_IS_NODE_WRAPPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NODE_WRAPPER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListPatchDataModelNodeWrapperClass))

typedef struct _GraniteWidgetsSourceListPatchDataModelNodeWrapper GraniteWidgetsSourceListPatchDataModelNodeWrapper;
typedef struct _GraniteWidgetsSourceListPatchDataModelNodeWrapperClass GraniteWidgetsSourceListPatchDataModelNodeWrapperClass;

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR (granite_widgets_source_list_patch_data_model_item_monitor_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListPatchDataModelItemMonitor))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListPatchDataModelItemMonitorClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_IS_ITEM_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_IS_ITEM_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListPatchDataModelItemMonitorClass))

typedef struct _GraniteWidgetsSourceListPatchDataModelItemMonitor GraniteWidgetsSourceListPatchDataModelItemMonitor;
typedef struct _GraniteWidgetsSourceListPatchDataModelItemMonitorClass GraniteWidgetsSourceListPatchDataModelItemMonitorClass;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NUM_PROPERTIES];
typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_N_COLUMNS
} GraniteWidgetsSourceListPatchDataModelColumn;


#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_COLUMN (granite_widgets_source_list_patch_data_model_column_get_type ())
#define _granite_widgets_source_list_patch_data_model_node_wrapper_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_patch_data_model_node_wrapper_unref (var), NULL)))
#define _granite_widgets_source_list_patch_data_model_item_monitor_unref0(var) ((var == NULL) ? NULL : (var = (granite_widgets_source_list_patch_data_model_item_monitor_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _GraniteWidgetsSourceListPatchDataModelNodeWrapperPrivate GraniteWidgetsSourceListPatchDataModelNodeWrapperPrivate;
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
typedef struct _GraniteWidgetsSourceListPatchDataModelParamSpecNodeWrapper GraniteWidgetsSourceListPatchDataModelParamSpecNodeWrapper;
typedef struct _GraniteWidgetsSourceListPatchDataModelItemMonitorPrivate GraniteWidgetsSourceListPatchDataModelItemMonitorPrivate;
typedef struct _GraniteWidgetsSourceListPatchDataModelParamSpecItemMonitor GraniteWidgetsSourceListPatchDataModelParamSpecItemMonitor;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_NUM_SIGNALS] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_UPDATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON (granite_widgets_source_list_patch_cell_renderer_icon_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListPatchCellRendererIcon))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListPatchCellRendererIconClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_CELL_RENDERER_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_CELL_RENDERER_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListPatchCellRendererIconClass))

typedef struct _GraniteWidgetsSourceListPatchCellRendererIcon GraniteWidgetsSourceListPatchCellRendererIcon;
typedef struct _GraniteWidgetsSourceListPatchCellRendererIconClass GraniteWidgetsSourceListPatchCellRendererIconClass;
typedef struct _GraniteWidgetsSourceListPatchCellRendererIconPrivate GraniteWidgetsSourceListPatchCellRendererIconPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_cell_renderer_icon_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_NUM_PROPERTIES];
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_ACTIVATED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_NUM_SIGNALS] = {0};

#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER (granite_widgets_source_list_patch_cell_renderer_spacer_get_type ())
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacer))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacerClass))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_CELL_RENDERER_SPACER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_IS_CELL_RENDERER_SPACER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER))
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacerClass))

typedef struct _GraniteWidgetsSourceListPatchCellRendererSpacer GraniteWidgetsSourceListPatchCellRendererSpacer;
typedef struct _GraniteWidgetsSourceListPatchCellRendererSpacerClass GraniteWidgetsSourceListPatchCellRendererSpacerClass;
typedef struct _GraniteWidgetsSourceListPatchCellRendererSpacerPrivate GraniteWidgetsSourceListPatchCellRendererSpacerPrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_NUM_PROPERTIES];
typedef struct _GraniteWidgetsSourceListPatchTreePrivate GraniteWidgetsSourceListPatchTreePrivate;
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_0_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_EDITING_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_NUM_PROPERTIES
};
static GParamSpec* granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_NUM_PROPERTIES];
typedef enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_N_COLS
} GraniteWidgetsSourceListPatchTreeColumn;


#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_TYPE_COLUMN (granite_widgets_source_list_patch_tree_column_get_type ())
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_NUM_SIGNALS] = {0};
enum  {
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTED_SIGNAL,
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_NUM_SIGNALS
};
static guint granite_widgets_source_list_patch_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _GraniteWidgetsSourceListPatchSortableIface {
	GTypeInterface parent_iface;
	gboolean (*allow_dnd_sorting) (GraniteWidgetsSourceListPatchSortable* self);
	gint (*compare) (GraniteWidgetsSourceListPatchSortable* self, GraniteWidgetsSourceListPatchItem* a, GraniteWidgetsSourceListPatchItem* b);
};

struct _GraniteWidgetsSourceListPatchDragSourceIface {
	GTypeInterface parent_iface;
	gboolean (*draggable) (GraniteWidgetsSourceListPatchDragSource* self);
	void (*prepare_selection_data) (GraniteWidgetsSourceListPatchDragSource* self, GtkSelectionData* selection_data);
};

struct _GraniteWidgetsSourceListPatchDragDestIface {
	GTypeInterface parent_iface;
	gboolean (*data_drop_possible) (GraniteWidgetsSourceListPatchDragDest* self, GdkDragContext* context, GtkSelectionData* data);
	GdkDragAction (*data_received) (GraniteWidgetsSourceListPatchDragDest* self, GdkDragContext* context, GtkSelectionData* data);
};

struct _GraniteWidgetsSourceListPatch {
	GtkScrolledWindow parent_instance;
	GraniteWidgetsSourceListPatchPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchClass {
	GtkScrolledWindowClass parent_class;
	void (*item_selected) (GraniteWidgetsSourceListPatch* self, GraniteWidgetsSourceListPatchItem* item);
};

struct _GraniteWidgetsSourceListPatchPrivate {
	GraniteWidgetsSourceListPatchTree* tree;
	GraniteWidgetsSourceListPatchDataModel* data_model;
};

struct _GraniteWidgetsSourceListPatchItem {
	GObject parent_instance;
	GraniteWidgetsSourceListPatchItemPrivate * priv;
	gboolean use_pango_style;
	gboolean force_visible;
};

struct _GraniteWidgetsSourceListPatchItemClass {
	GObjectClass parent_class;
	GtkMenu* (*get_context_menu) (GraniteWidgetsSourceListPatchItem* self);
	void (*edited) (GraniteWidgetsSourceListPatchItem* self, const gchar* new_name);
	void (*action_activated) (GraniteWidgetsSourceListPatchItem* self);
	void (*activated) (GraniteWidgetsSourceListPatchItem* self);
};

struct _GraniteWidgetsSourceListPatchItemPrivate {
	GraniteWidgetsSourceListPatchExpandableItem* _parent;
	gchar* _name;
	gchar* _markup;
	gchar* _badge;
	gboolean _editable;
	gboolean _visible;
	gboolean _selectable;
	GIcon* _icon;
	GIcon* _activatable;
};

struct _GraniteWidgetsSourceListPatchExpandableItem {
	GraniteWidgetsSourceListPatchItem parent_instance;
	GraniteWidgetsSourceListPatchExpandableItemPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchExpandableItemClass {
	GraniteWidgetsSourceListPatchItemClass parent_class;
	void (*toggled) (GraniteWidgetsSourceListPatchExpandableItem* self);
};

struct _GraniteWidgetsSourceListPatchExpandableItemPrivate {
	gboolean _collapsible;
	gboolean _expanded;
	GeeCollection* children_list;
};

struct _GraniteWidgetsSourceListPatchDataModel {
	GtkTreeModelFilter parent_instance;
	GraniteWidgetsSourceListPatchDataModelPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchDataModelClass {
	GtkTreeModelFilterClass parent_class;
};

struct _GraniteWidgetsSourceListPatchDataModelPrivate {
	GraniteWidgetsSourceListPatchExpandableItem* _root;
	GeeHashMap* items;
	GeeHashMap* monitors;
	GtkTreeStore* child_tree;
	GraniteWidgetsSourceListPatchVisibleFunc filter_func;
	gpointer filter_func_target;
};

struct _Block1Data {
	int _ref_count_;
	GraniteWidgetsSourceListPatchDataModel* self;
	GraniteWidgetsSourceListPatchExpandableItem* parent;
};

struct _GraniteWidgetsSourceListPatchDataModelNodeWrapper {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListPatchDataModelNodeWrapperPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchDataModelNodeWrapperClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListPatchDataModelNodeWrapper *self);
};

struct _GraniteWidgetsSourceListPatchDataModelNodeWrapperPrivate {
	GtkTreeRowReference* row_reference;
};

struct _GraniteWidgetsSourceListPatchDataModelParamSpecNodeWrapper {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListPatchDataModelItemMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	GraniteWidgetsSourceListPatchDataModelItemMonitorPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchDataModelItemMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (GraniteWidgetsSourceListPatchDataModelItemMonitor *self);
};

struct _GraniteWidgetsSourceListPatchDataModelItemMonitorPrivate {
	GraniteWidgetsSourceListPatchItem* item;
};

struct _GraniteWidgetsSourceListPatchDataModelParamSpecItemMonitor {
	GParamSpec parent_instance;
};

struct _GraniteWidgetsSourceListPatchCellRendererIcon {
	GtkCellRendererPixbuf parent_instance;
	GraniteWidgetsSourceListPatchCellRendererIconPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchCellRendererIconClass {
	GtkCellRendererPixbufClass parent_class;
};

struct _GraniteWidgetsSourceListPatchCellRendererSpacer {
	GtkCellRenderer parent_instance;
	GraniteWidgetsSourceListPatchCellRendererSpacerPrivate * priv;
};

struct _GraniteWidgetsSourceListPatchCellRendererSpacerClass {
	GtkCellRendererClass parent_class;
};

struct _GraniteWidgetsSourceListPatchCellRendererSpacerPrivate {
	gint _level;
};

struct _GraniteWidgetsSourceListPatchTree {
	GtkTreeView parent_instance;
	GraniteWidgetsSourceListPatchTreePrivate * priv;
};

struct _GraniteWidgetsSourceListPatchTreeClass {
	GtkTreeViewClass parent_class;
};

struct _GraniteWidgetsSourceListPatchTreePrivate {
	GraniteWidgetsSourceListPatchDataModel* _data_model;
	GraniteWidgetsSourceListPatchItem* selected;
	GraniteWidgetsSourceListPatchItem* edited;
	GtkEntry* editable_entry;
	GtkCellRendererText* text_cell;
	GraniteWidgetsSourceListPatchCellRendererIcon* icon_cell;
	GraniteWidgetsSourceListPatchCellRendererIcon* activatable_cell;
	GraniteWidgetsCellRendererBadge* badge_cell;
	GraniteWidgetsCellRendererExpander* primary_expander_cell;
	GraniteWidgetsCellRendererExpander* secondary_expander_cell;
	GeeHashMap* spacer_cells;
	gboolean unselectable_item_clicked;
};


static gint GraniteWidgetsSourceListPatch_private_offset;
static gpointer granite_widgets_source_list_patch_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchItem_private_offset;
static gpointer granite_widgets_source_list_patch_item_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchExpandableItem_private_offset;
static gpointer granite_widgets_source_list_patch_expandable_item_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchDataModel_private_offset;
static gpointer granite_widgets_source_list_patch_data_model_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchDataModelNodeWrapper_private_offset;
static gpointer granite_widgets_source_list_patch_data_model_node_wrapper_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchDataModelItemMonitor_private_offset;
static gpointer granite_widgets_source_list_patch_data_model_item_monitor_parent_class = NULL;
static GtkTreeDragSourceIface * granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_parent_iface = NULL;
static GtkTreeDragDestIface * granite_widgets_source_list_patch_data_model_gtk_tree_drag_dest_parent_iface = NULL;
static gpointer granite_widgets_source_list_patch_cell_renderer_icon_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchCellRendererSpacer_private_offset;
static gpointer granite_widgets_source_list_patch_cell_renderer_spacer_parent_class = NULL;
static gint GraniteWidgetsSourceListPatchTree_private_offset;
static gpointer granite_widgets_source_list_patch_tree_parent_class = NULL;

GType granite_widgets_source_list_patch_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_patch_expandable_item_get_type (void) G_GNUC_CONST;
GType granite_widgets_source_list_patch_sortable_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_patch_sortable_allow_dnd_sorting (GraniteWidgetsSourceListPatchSortable* self);
gint granite_widgets_source_list_patch_sortable_compare (GraniteWidgetsSourceListPatchSortable* self,
                                                         GraniteWidgetsSourceListPatchItem* a,
                                                         GraniteWidgetsSourceListPatchItem* b);
GType granite_widgets_source_list_patch_drag_source_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_patch_drag_source_draggable (GraniteWidgetsSourceListPatchDragSource* self);
void granite_widgets_source_list_patch_drag_source_prepare_selection_data (GraniteWidgetsSourceListPatchDragSource* self,
                                                                           GtkSelectionData* selection_data);
GType granite_widgets_source_list_patch_drag_dest_get_type (void) G_GNUC_CONST;
gboolean granite_widgets_source_list_patch_drag_dest_data_drop_possible (GraniteWidgetsSourceListPatchDragDest* self,
                                                                         GdkDragContext* context,
                                                                         GtkSelectionData* data);
GdkDragAction granite_widgets_source_list_patch_drag_dest_data_received (GraniteWidgetsSourceListPatchDragDest* self,
                                                                         GdkDragContext* context,
                                                                         GtkSelectionData* data);
GType granite_widgets_source_list_patch_get_type (void) G_GNUC_CONST;
static GType granite_widgets_source_list_patch_tree_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_patch_data_model_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GraniteWidgetsSourceListPatchDataModel* granite_widgets_source_list_patch_data_model_new (void);
static GraniteWidgetsSourceListPatchDataModel* granite_widgets_source_list_patch_data_model_construct (GType object_type);
GraniteWidgetsSourceListPatch* granite_widgets_source_list_patch_new (GraniteWidgetsSourceListPatchExpandableItem* root);
GraniteWidgetsSourceListPatch* granite_widgets_source_list_patch_construct (GType object_type,
                                                                            GraniteWidgetsSourceListPatchExpandableItem* root);
void granite_widgets_source_list_patch_set_root (GraniteWidgetsSourceListPatch* self,
                                                 GraniteWidgetsSourceListPatchExpandableItem* value);
gboolean granite_widgets_source_list_patch_has_item (GraniteWidgetsSourceListPatch* self,
                                                     GraniteWidgetsSourceListPatchItem* item);
static gboolean granite_widgets_source_list_patch_data_model_has_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                                GraniteWidgetsSourceListPatchItem* item);
void granite_widgets_source_list_patch_set_filter_func (GraniteWidgetsSourceListPatch* self,
                                                        GraniteWidgetsSourceListPatchVisibleFunc visible_func,
                                                        gpointer visible_func_target,
                                                        gboolean refilter);
static void granite_widgets_source_list_patch_data_model_set_filter_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                                   GraniteWidgetsSourceListPatchVisibleFunc visible_func,
                                                                   gpointer visible_func_target);
void granite_widgets_source_list_patch_refilter (GraniteWidgetsSourceListPatch* self);
gboolean granite_widgets_source_list_patch_is_item_expanded (GraniteWidgetsSourceListPatch* self,
                                                             GraniteWidgetsSourceListPatchItem* item);
static GtkTreePath* granite_widgets_source_list_patch_data_model_get_item_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                                         GraniteWidgetsSourceListPatchItem* item);
static void _vala_GtkTreePath_free (GtkTreePath* self);
gboolean granite_widgets_source_list_patch_start_editing_item (GraniteWidgetsSourceListPatch* self,
                                                               GraniteWidgetsSourceListPatchItem* item);
static gboolean granite_widgets_source_list_patch_tree_start_editing_item (GraniteWidgetsSourceListPatchTree* self,
                                                                    GraniteWidgetsSourceListPatchItem* item);
void granite_widgets_source_list_patch_stop_editing (GraniteWidgetsSourceListPatch* self);
gboolean granite_widgets_source_list_patch_get_editing (GraniteWidgetsSourceListPatch* self);
static void granite_widgets_source_list_patch_tree_stop_editing (GraniteWidgetsSourceListPatchTree* self);
void granite_widgets_source_list_patch_enable_drag_source (GraniteWidgetsSourceListPatch* self,
                                                           GtkTargetEntry* src_entries,
                                                           int src_entries_length1);
static void granite_widgets_source_list_patch_tree_configure_drag_source (GraniteWidgetsSourceListPatchTree* self,
                                                                   GtkTargetEntry* src_entries,
                                                                   int src_entries_length1);
void granite_widgets_source_list_patch_disable_drag_source (GraniteWidgetsSourceListPatch* self);
void granite_widgets_source_list_patch_enable_drag_dest (GraniteWidgetsSourceListPatch* self,
                                                         GtkTargetEntry* dest_entries,
                                                         int dest_entries_length1,
                                                         GdkDragAction actions);
static void granite_widgets_source_list_patch_tree_configure_drag_dest (GraniteWidgetsSourceListPatchTree* self,
                                                                 GtkTargetEntry* dest_entries,
                                                                 int dest_entries_length1,
                                                                 GdkDragAction actions);
void granite_widgets_source_list_patch_disable_drag_dest (GraniteWidgetsSourceListPatch* self);
gboolean granite_widgets_source_list_patch_scroll_to_item (GraniteWidgetsSourceListPatch* self,
                                                           GraniteWidgetsSourceListPatchItem* item,
                                                           gboolean expand_parents,
                                                           gboolean use_align,
                                                           gfloat row_align);
GraniteWidgetsSourceListPatchExpandableItem* granite_widgets_source_list_patch_item_get_parent (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_expandable_item_expand_with_parents (GraniteWidgetsSourceListPatchExpandableItem* self);
static gboolean granite_widgets_source_list_patch_tree_scroll_to_item (GraniteWidgetsSourceListPatchTree* self,
                                                                GraniteWidgetsSourceListPatchItem* item,
                                                                gboolean use_align,
                                                                gfloat row_align);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_previous_item (GraniteWidgetsSourceListPatch* self,
                                                                                        GraniteWidgetsSourceListPatchItem* reference);
static GtkTreeIter* granite_widgets_source_list_patch_data_model_get_item_iter (GraniteWidgetsSourceListPatchDataModel* self,
                                                                         GraniteWidgetsSourceListPatchItem* item);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_data_model_get_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                                                          GtkTreeIter* iter);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_next_item (GraniteWidgetsSourceListPatch* self,
                                                                                    GraniteWidgetsSourceListPatchItem* reference);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_first_child (GraniteWidgetsSourceListPatch* self,
                                                                                      GraniteWidgetsSourceListPatchExpandableItem* parent);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_nth_child (GraniteWidgetsSourceListPatch* self,
                                                                                    GraniteWidgetsSourceListPatchExpandableItem* parent,
                                                                                    gint index);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_last_child (GraniteWidgetsSourceListPatch* self,
                                                                                     GraniteWidgetsSourceListPatchExpandableItem* parent);
guint granite_widgets_source_list_patch_get_n_visible_children (GraniteWidgetsSourceListPatch* self,
                                                                GraniteWidgetsSourceListPatchExpandableItem* parent);
GraniteWidgetsSourceListPatchExpandableItem* granite_widgets_source_list_patch_get_root (GraniteWidgetsSourceListPatch* self);
static GraniteWidgetsSourceListPatchExpandableItem* granite_widgets_source_list_patch_data_model_get_root (GraniteWidgetsSourceListPatchDataModel* self);
static void granite_widgets_source_list_patch_data_model_set_root (GraniteWidgetsSourceListPatchDataModel* self,
                                                            GraniteWidgetsSourceListPatchExpandableItem* value);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_get_selected (GraniteWidgetsSourceListPatch* self);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_tree_get_selected_item (GraniteWidgetsSourceListPatchTree* self);
void granite_widgets_source_list_patch_set_selected (GraniteWidgetsSourceListPatch* self,
                                                     GraniteWidgetsSourceListPatchItem* value);
static void granite_widgets_source_list_patch_tree_set_selected_item (GraniteWidgetsSourceListPatchTree* self,
                                                               GraniteWidgetsSourceListPatchItem* value);
PangoEllipsizeMode granite_widgets_source_list_patch_get_ellipsize_mode (GraniteWidgetsSourceListPatch* self);
static PangoEllipsizeMode granite_widgets_source_list_patch_tree_get_ellipsize_mode (GraniteWidgetsSourceListPatchTree* self);
void granite_widgets_source_list_patch_set_ellipsize_mode (GraniteWidgetsSourceListPatch* self,
                                                           PangoEllipsizeMode value);
static void granite_widgets_source_list_patch_tree_set_ellipsize_mode (GraniteWidgetsSourceListPatchTree* self,
                                                                PangoEllipsizeMode value);
static gboolean granite_widgets_source_list_patch_tree_get_editing (GraniteWidgetsSourceListPatchTree* self);
static void granite_widgets_source_list_patch_real_item_selected (GraniteWidgetsSourceListPatch* self,
                                                           GraniteWidgetsSourceListPatchItem* item);
static GObject * granite_widgets_source_list_patch_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static GraniteWidgetsSourceListPatchTree* granite_widgets_source_list_patch_tree_new (GraniteWidgetsSourceListPatchDataModel* data_model);
static GraniteWidgetsSourceListPatchTree* granite_widgets_source_list_patch_tree_construct (GType object_type,
                                                                                     GraniteWidgetsSourceListPatchDataModel* data_model);
static void _granite_widgets_source_list_patch___lambda21_ (GraniteWidgetsSourceListPatch* self,
                                                     GraniteWidgetsSourceListPatchItem* item);
static void __granite_widgets_source_list_patch___lambda21__granite_widgets_source_list_patch_tree_item_selected (GraniteWidgetsSourceListPatchTree* _sender,
                                                                                                           GraniteWidgetsSourceListPatchItem* item,
                                                                                                           gpointer self);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_item_new (const gchar* name);
GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_item_construct (GType object_type,
                                                                                     const gchar* name);
void granite_widgets_source_list_patch_item_set_name (GraniteWidgetsSourceListPatchItem* self,
                                                      const gchar* value);
GtkMenu* granite_widgets_source_list_patch_item_get_context_menu (GraniteWidgetsSourceListPatchItem* self);
static GtkMenu* granite_widgets_source_list_patch_item_real_get_context_menu (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_parent (GraniteWidgetsSourceListPatchItem* self,
                                                        GraniteWidgetsSourceListPatchExpandableItem* value);
const gchar* granite_widgets_source_list_patch_item_get_name (GraniteWidgetsSourceListPatchItem* self);
const gchar* granite_widgets_source_list_patch_item_get_markup (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_markup (GraniteWidgetsSourceListPatchItem* self,
                                                        const gchar* value);
const gchar* granite_widgets_source_list_patch_item_get_badge (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_badge (GraniteWidgetsSourceListPatchItem* self,
                                                       const gchar* value);
gboolean granite_widgets_source_list_patch_item_get_editable (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_editable (GraniteWidgetsSourceListPatchItem* self,
                                                          gboolean value);
gboolean granite_widgets_source_list_patch_item_get_visible (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_visible (GraniteWidgetsSourceListPatchItem* self,
                                                         gboolean value);
gboolean granite_widgets_source_list_patch_item_get_selectable (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_selectable (GraniteWidgetsSourceListPatchItem* self,
                                                            gboolean value);
GIcon* granite_widgets_source_list_patch_item_get_icon (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_icon (GraniteWidgetsSourceListPatchItem* self,
                                                      GIcon* value);
GIcon* granite_widgets_source_list_patch_item_get_activatable (GraniteWidgetsSourceListPatchItem* self);
void granite_widgets_source_list_patch_item_set_activatable (GraniteWidgetsSourceListPatchItem* self,
                                                             GIcon* value);
static void granite_widgets_source_list_patch_item_real_edited (GraniteWidgetsSourceListPatchItem* self,
                                                         const gchar* new_name);
static void granite_widgets_source_list_patch_item_real_action_activated (GraniteWidgetsSourceListPatchItem* self);
static void granite_widgets_source_list_patch_item_real_activated (GraniteWidgetsSourceListPatchItem* self);
static void granite_widgets_source_list_patch_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_item_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_item_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
GraniteWidgetsSourceListPatchExpandableItem* granite_widgets_source_list_patch_expandable_item_new (const gchar* name);
GraniteWidgetsSourceListPatchExpandableItem* granite_widgets_source_list_patch_expandable_item_construct (GType object_type,
                                                                                                          const gchar* name);
gboolean granite_widgets_source_list_patch_expandable_item_contains (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                     GraniteWidgetsSourceListPatchItem* item);
void granite_widgets_source_list_patch_expandable_item_add (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                            GraniteWidgetsSourceListPatchItem* item);
void granite_widgets_source_list_patch_expandable_item_remove (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                               GraniteWidgetsSourceListPatchItem* item);
void granite_widgets_source_list_patch_expandable_item_clear (GraniteWidgetsSourceListPatchExpandableItem* self);
GeeCollection* granite_widgets_source_list_patch_expandable_item_get_children (GraniteWidgetsSourceListPatchExpandableItem* self);
void granite_widgets_source_list_patch_expandable_item_expand_all (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                   gboolean inclusive,
                                                                   gboolean recursive);
static void granite_widgets_source_list_patch_expandable_item_set_expansion (GraniteWidgetsSourceListPatchExpandableItem* item,
                                                                      gboolean inclusive,
                                                                      gboolean recursive,
                                                                      gboolean expanded);
void granite_widgets_source_list_patch_expandable_item_collapse_all (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                     gboolean inclusive,
                                                                     gboolean recursive);
void granite_widgets_source_list_patch_expandable_item_set_expanded (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                     gboolean value);
void granite_widgets_source_list_patch_expandable_item_collapse_with_parents (GraniteWidgetsSourceListPatchExpandableItem* self);
gboolean granite_widgets_source_list_patch_expandable_item_get_collapsible (GraniteWidgetsSourceListPatchExpandableItem* self);
void granite_widgets_source_list_patch_expandable_item_set_collapsible (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                        gboolean value);
gboolean granite_widgets_source_list_patch_expandable_item_get_expanded (GraniteWidgetsSourceListPatchExpandableItem* self);
guint granite_widgets_source_list_patch_expandable_item_get_n_children (GraniteWidgetsSourceListPatchExpandableItem* self);
static void granite_widgets_source_list_patch_expandable_item_real_toggled (GraniteWidgetsSourceListPatchExpandableItem* self);
static GObject * granite_widgets_source_list_patch_expandable_item_constructor (GType type,
                                                                         guint n_construct_properties,
                                                                         GObjectConstructParam * construct_properties);
static void granite_widgets_source_list_patch_expandable_item_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_expandable_item_get_property (GObject * object,
                                                                           guint property_id,
                                                                           GValue * value,
                                                                           GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_expandable_item_set_property (GObject * object,
                                                                           guint property_id,
                                                                           const GValue * value,
                                                                           GParamSpec * pspec);
static gpointer granite_widgets_source_list_patch_data_model_node_wrapper_ref (gpointer instance);
static void granite_widgets_source_list_patch_data_model_node_wrapper_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_patch_data_model_param_spec_node_wrapper (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_patch_data_model_value_set_node_wrapper (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_patch_data_model_value_take_node_wrapper (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_patch_data_model_value_get_node_wrapper (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_patch_data_model_node_wrapper_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_patch_data_model_item_monitor_ref (gpointer instance);
static void granite_widgets_source_list_patch_data_model_item_monitor_unref (gpointer instance);
static GParamSpec* granite_widgets_source_list_patch_data_model_param_spec_item_monitor (const gchar* name,
                                                                                  const gchar* nick,
                                                                                  const gchar* blurb,
                                                                                  GType object_type,
                                                                                  GParamFlags flags) G_GNUC_UNUSED;
static void granite_widgets_source_list_patch_data_model_value_set_item_monitor (GValue* value,
                                                                          gpointer v_object) G_GNUC_UNUSED;
static void granite_widgets_source_list_patch_data_model_value_take_item_monitor (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED;
static gpointer granite_widgets_source_list_patch_data_model_value_get_item_monitor (const GValue* value) G_GNUC_UNUSED;
static GType granite_widgets_source_list_patch_data_model_item_monitor_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_patch_data_model_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GType granite_widgets_source_list_patch_data_model_column_type (GraniteWidgetsSourceListPatchDataModelColumn self);
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE "item-parent-needs-update"
static void granite_widgets_source_list_patch_data_model_update_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                               GraniteWidgetsSourceListPatchItem* item);
static GtkTreePath* granite_widgets_source_list_patch_data_model_node_wrapper_get_path (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self);
static GtkTreeIter* granite_widgets_source_list_patch_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self);
static void granite_widgets_source_list_patch_data_model_add_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                            GraniteWidgetsSourceListPatchItem* item);
static GtkTreeIter* granite_widgets_source_list_patch_data_model_get_item_child_iter (GraniteWidgetsSourceListPatchDataModel* self,
                                                                               GraniteWidgetsSourceListPatchItem* item);
static GtkTreeIter* _gtk_tree_iter_dup (GtkTreeIter* self);
static GraniteWidgetsSourceListPatchDataModelNodeWrapper* granite_widgets_source_list_patch_data_model_node_wrapper_new (GtkTreeModel* model,
                                                                                                                  GtkTreeIter* iter);
static GraniteWidgetsSourceListPatchDataModelNodeWrapper* granite_widgets_source_list_patch_data_model_node_wrapper_construct (GType object_type,
                                                                                                                        GtkTreeModel* model,
                                                                                                                        GtkTreeIter* iter);
static void granite_widgets_source_list_patch_data_model_add_property_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                        GraniteWidgetsSourceListPatchItem* item);
static void granite_widgets_source_list_patch_data_model_push_parent_update (GraniteWidgetsSourceListPatchDataModel* self,
                                                                      GraniteWidgetsSourceListPatchExpandableItem* parent);
static void granite_widgets_source_list_patch_data_model_add_children_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                        GraniteWidgetsSourceListPatchExpandableItem* item);
static void granite_widgets_source_list_patch_data_model_remove_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                               GraniteWidgetsSourceListPatchItem* item);
static void granite_widgets_source_list_patch_data_model_remove_property_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                           GraniteWidgetsSourceListPatchItem* item);
static void granite_widgets_source_list_patch_data_model_remove_children_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                           GraniteWidgetsSourceListPatchExpandableItem* item);
static GraniteWidgetsSourceListPatchDataModelItemMonitor* granite_widgets_source_list_patch_data_model_item_monitor_new (GraniteWidgetsSourceListPatchItem* item);
static GraniteWidgetsSourceListPatchDataModelItemMonitor* granite_widgets_source_list_patch_data_model_item_monitor_construct (GType object_type,
                                                                                                                        GraniteWidgetsSourceListPatchItem* item);
static void granite_widgets_source_list_patch_data_model_on_item_prop_changed (GraniteWidgetsSourceListPatchDataModel* self,
                                                                        GraniteWidgetsSourceListPatchItem* item,
                                                                        const gchar* prop_name);
static void _granite_widgets_source_list_patch_data_model_on_item_prop_changed_granite_widgets_source_list_patch_data_model_item_monitor_changed (GraniteWidgetsSourceListPatchDataModelItemMonitor* _sender,
                                                                                                                                           GraniteWidgetsSourceListPatchItem* _self_,
                                                                                                                                           const gchar* prop_name,
                                                                                                                                           gpointer self);
static void granite_widgets_source_list_patch_data_model_on_item_child_added (GraniteWidgetsSourceListPatchDataModel* self,
                                                                       GraniteWidgetsSourceListPatchItem* item);
static void _granite_widgets_source_list_patch_data_model_on_item_child_added_granite_widgets_source_list_patch_expandable_item_child_added (GraniteWidgetsSourceListPatchExpandableItem* _sender,
                                                                                                                                      GraniteWidgetsSourceListPatchItem* item,
                                                                                                                                      gpointer self);
static void granite_widgets_source_list_patch_data_model_on_item_child_removed (GraniteWidgetsSourceListPatchDataModel* self,
                                                                         GraniteWidgetsSourceListPatchItem* item);
static void _granite_widgets_source_list_patch_data_model_on_item_child_removed_granite_widgets_source_list_patch_expandable_item_child_removed (GraniteWidgetsSourceListPatchExpandableItem* _sender,
                                                                                                                                          GraniteWidgetsSourceListPatchItem* item,
                                                                                                                                          gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean ___lambda20_ (Block1Data* _data1_);
static gboolean ____lambda20__gsource_func (gpointer self);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_data_model_get_item_from_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                                                                    GtkTreePath* path);
static GtkTreePath* granite_widgets_source_list_patch_data_model_get_item_child_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                                               GraniteWidgetsSourceListPatchItem* item);
static gboolean granite_widgets_source_list_patch_data_model_is_category (GraniteWidgetsSourceListPatchDataModel* self,
                                                                   GraniteWidgetsSourceListPatchItem* item,
                                                                   GtkTreeIter* iter,
                                                                   GtkTreePath* path);
static gboolean granite_widgets_source_list_patch_data_model_is_iter_at_root_level (GraniteWidgetsSourceListPatchDataModel* self,
                                                                             GtkTreeIter* iter);
static gboolean granite_widgets_source_list_patch_data_model_is_path_at_root_level (GraniteWidgetsSourceListPatchDataModel* self,
                                                                             GtkTreePath* path);
static void granite_widgets_source_list_patch_data_model_resort (GraniteWidgetsSourceListPatchDataModel* self);
static gint granite_widgets_source_list_patch_data_model_child_model_sort_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                                         GtkTreeModel* model,
                                                                         GtkTreeIter* a,
                                                                         GtkTreeIter* b);
static gboolean granite_widgets_source_list_patch_data_model_filter_visible_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                                           GtkTreeModel* child_model,
                                                                           GtkTreeIter* iter);
static gboolean granite_widgets_source_list_patch_data_model_real_drag_data_received (GtkTreeDragDest* base,
                                                                               GtkTreePath* dest,
                                                                               GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_patch_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListPatchDataModel* self,
                                                                                     GtkTreePath* dest,
                                                                                     GtkTreePath* src_path);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static void granite_widgets_source_list_patch_data_model_recursive_node_copy (GraniteWidgetsSourceListPatchDataModel* self,
                                                                       GtkTreeIter* src_iter,
                                                                       GtkTreeIter* dest_iter);
static void granite_widgets_source_list_patch_data_model_move_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                             GtkTreeIter* src_iter,
                                                             GtkTreeIter* dest_iter);
static gboolean granite_widgets_source_list_patch_data_model_real_row_drop_possible (GtkTreeDragDest* base,
                                                                              GtkTreePath* dest,
                                                                              GtkSelectionData* selection_data);
static gint* _vala_array_dup1 (gint* self,
                        int length);
static gint* _vala_array_dup2 (gint* self,
                        int length);
static gboolean granite_widgets_source_list_patch_data_model_real_drag_data_get (GtkTreeDragSource* base,
                                                                          GtkTreePath* path,
                                                                          GtkSelectionData* selection_data);
static gboolean granite_widgets_source_list_patch_data_model_real_row_draggable (GtkTreeDragSource* base,
                                                                          GtkTreePath* path);
static GObject * granite_widgets_source_list_patch_data_model_constructor (GType type,
                                                                    guint n_construct_properties,
                                                                    GObjectConstructParam * construct_properties);
static gint _granite_widgets_source_list_patch_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                                                                     GtkTreeIter* a,
                                                                                                     GtkTreeIter* b,
                                                                                                     gpointer self);
static gboolean _granite_widgets_source_list_patch_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                                               GtkTreeIter* iter,
                                                                                                               gpointer self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static gboolean granite_widgets_source_list_patch_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self);
static void granite_widgets_source_list_patch_data_model_node_wrapper_finalize (GraniteWidgetsSourceListPatchDataModelNodeWrapper * obj);
static void granite_widgets_source_list_patch_data_model_item_monitor_on_notify (GraniteWidgetsSourceListPatchDataModelItemMonitor* self,
                                                                          GParamSpec* prop);
static void _granite_widgets_source_list_patch_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender,
                                                                                           GParamSpec* pspec,
                                                                                           gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void granite_widgets_source_list_patch_data_model_item_monitor_finalize (GraniteWidgetsSourceListPatchDataModelItemMonitor * obj);
static void granite_widgets_source_list_patch_data_model_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_data_model_get_property (GObject * object,
                                                                      guint property_id,
                                                                      GValue * value,
                                                                      GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_data_model_set_property (GObject * object,
                                                                      guint property_id,
                                                                      const GValue * value,
                                                                      GParamSpec * pspec);
static GType granite_widgets_source_list_patch_cell_renderer_icon_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_ICON_SIZE GTK_ICON_SIZE_MENU
static GraniteWidgetsSourceListPatchCellRendererIcon* granite_widgets_source_list_patch_cell_renderer_icon_new (void);
static GraniteWidgetsSourceListPatchCellRendererIcon* granite_widgets_source_list_patch_cell_renderer_icon_construct (GType object_type);
static gboolean granite_widgets_source_list_patch_cell_renderer_icon_real_activate (GtkCellRenderer* base,
                                                                             GdkEvent* event,
                                                                             GtkWidget* widget,
                                                                             const gchar* path,
                                                                             GdkRectangle* background_area,
                                                                             GdkRectangle* cell_area,
                                                                             GtkCellRendererState flags);
static GObject * granite_widgets_source_list_patch_cell_renderer_icon_constructor (GType type,
                                                                            guint n_construct_properties,
                                                                            GObjectConstructParam * construct_properties);
static GType granite_widgets_source_list_patch_cell_renderer_spacer_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static GtkSizeRequestMode granite_widgets_source_list_patch_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base);
static void granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base,
                                                                                      GtkWidget* widget,
                                                                                      gint* min_size,
                                                                                      gint* natural_size);
static void granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                                                 GtkWidget* widget,
                                                                                                 gint width,
                                                                                                 gint* min_height,
                                                                                                 gint* natural_height);
static void granite_widgets_source_list_patch_cell_renderer_spacer_real_render (GtkCellRenderer* base,
                                                                         cairo_t* context,
                                                                         GtkWidget* widget,
                                                                         GdkRectangle* bg_area,
                                                                         GdkRectangle* cell_area,
                                                                         GtkCellRendererState flags);
static void granite_widgets_source_list_patch_cell_renderer_spacer_real_get_size (GtkCellRenderer* base,
                                                                           GtkWidget* widget,
                                                                           GdkRectangle* cell_area,
                                                                           gint* x_offset,
                                                                           gint* y_offset,
                                                                           gint* width,
                                                                           gint* height) G_GNUC_DEPRECATED;
static GraniteWidgetsSourceListPatchCellRendererSpacer* granite_widgets_source_list_patch_cell_renderer_spacer_new (void);
static GraniteWidgetsSourceListPatchCellRendererSpacer* granite_widgets_source_list_patch_cell_renderer_spacer_construct (GType object_type);
static gint granite_widgets_source_list_patch_cell_renderer_spacer_get_level (GraniteWidgetsSourceListPatchCellRendererSpacer* self);
static void granite_widgets_source_list_patch_cell_renderer_spacer_set_level (GraniteWidgetsSourceListPatchCellRendererSpacer* self,
                                                                       gint value);
static void granite_widgets_source_list_patch_cell_renderer_spacer_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_cell_renderer_spacer_get_property (GObject * object,
                                                                                guint property_id,
                                                                                GValue * value,
                                                                                GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_cell_renderer_spacer_set_property (GObject * object,
                                                                                guint property_id,
                                                                                const GValue * value,
                                                                                GParamSpec * pspec);
static void granite_widgets_source_list_patch_tree_disable_item_property_monitor (GraniteWidgetsSourceListPatchTree* self);
static GType granite_widgets_source_list_patch_tree_column_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DEFAULT_STYLESHEET "\n" \
"                .source-list.badge {\n" \
"                    border-radius: 10px;\n" \
"                    border-width: 0;\n" \
"                    padding: 1px 2px 1px 2px;\n" \
"                    font-weight: bold;\n" \
"                }\n" \
"            "
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEVEL_INDENTATION "level-indentation"
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEFT_PADDING "left-padding"
#define GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_EXPANDER_SPACING "expander-spacing"
static gboolean granite_widgets_source_list_patch_tree_real_drag_motion (GtkWidget* base,
                                                                  GdkDragContext* context,
                                                                  gint x,
                                                                  gint y,
                                                                  guint time);
static GraniteWidgetsSourceListPatchDataModel* granite_widgets_source_list_patch_tree_get_data_model (GraniteWidgetsSourceListPatchTree* self);
static void granite_widgets_source_list_patch_tree_real_drag_data_received (GtkWidget* base,
                                                                     GdkDragContext* context,
                                                                     gint x,
                                                                     gint y,
                                                                     GtkSelectionData* selection_data,
                                                                     guint info,
                                                                     guint time);
static GtkTargetEntry* granite_widgets_source_list_patch_tree_append_row_target_entry (GtkTargetEntry* orig,
                                                                                int orig_length1,
                                                                                int* result_length1);
static void _vala_array_add1 (GtkTargetEntry* * array,
                       int* length,
                       int* size,
                       const GtkTargetEntry* value);
static void _vala_array_add2 (GtkTargetEntry* * array,
                       int* length,
                       int* size,
                       const GtkTargetEntry* value);
static void granite_widgets_source_list_patch_tree_enable_item_property_monitor (GraniteWidgetsSourceListPatchTree* self);
static void granite_widgets_source_list_patch_tree_on_model_item_updated (GraniteWidgetsSourceListPatchTree* self,
                                                                   GraniteWidgetsSourceListPatchItem* item);
static void _granite_widgets_source_list_patch_tree_on_model_item_updated_granite_widgets_source_list_patch_data_model_item_updated (GraniteWidgetsSourceListPatchDataModel* _sender,
                                                                                                                              GraniteWidgetsSourceListPatchItem* item,
                                                                                                                              gpointer self);
static void granite_widgets_source_list_patch_tree_update_expansion (GraniteWidgetsSourceListPatchTree* self,
                                                              GraniteWidgetsSourceListPatchExpandableItem* expandable_item);
static void granite_widgets_source_list_patch_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListPatchTree* self,
                                                                       gint level,
                                                                       gboolean check_previous);
static void granite_widgets_source_list_patch_tree_spacer_cell_data_func (GtkCellLayout* layout,
                                                                   GtkCellRenderer* renderer,
                                                                   GtkTreeModel* model,
                                                                   GtkTreeIter* iter);
static void _granite_widgets_source_list_patch_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                              GtkCellRenderer* cell,
                                                                                              GtkTreeModel* tree_model,
                                                                                              GtkTreeIter* iter,
                                                                                              gpointer self);
static gboolean granite_widgets_source_list_patch_tree_select_func (GraniteWidgetsSourceListPatchTree* self,
                                                             GtkTreeSelection* selection,
                                                             GtkTreeModel* model,
                                                             GtkTreePath* path,
                                                             gboolean path_currently_selected);
static GtkTreePath* granite_widgets_source_list_patch_tree_get_selected_path (GraniteWidgetsSourceListPatchTree* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static void granite_widgets_source_list_patch_tree_set_selected (GraniteWidgetsSourceListPatchTree* self,
                                                          GraniteWidgetsSourceListPatchItem* item,
                                                          gboolean scroll_to_item);
static void granite_widgets_source_list_patch_tree_real_cursor_changed (GtkTreeView* base);
static void granite_widgets_source_list_patch_tree_on_editing_started (GraniteWidgetsSourceListPatchTree* self,
                                                                GtkCellEditable* editable,
                                                                const gchar* path);
static void granite_widgets_source_list_patch_tree_on_editing_done (GraniteWidgetsSourceListPatchTree* self);
static void _granite_widgets_source_list_patch_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender,
                                                                                             gpointer self);
static void granite_widgets_source_list_patch_tree_on_editing_canceled (GraniteWidgetsSourceListPatchTree* self);
static void granite_widgets_source_list_patch_tree_on_activatable_activated (GraniteWidgetsSourceListPatchTree* self,
                                                                      const gchar* item_path_str);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_tree_get_item_from_path_string (GraniteWidgetsSourceListPatchTree* self,
                                                                                                     const gchar* item_path_str);
static gboolean granite_widgets_source_list_patch_tree_toggle_expansion (GraniteWidgetsSourceListPatchTree* self,
                                                                  GraniteWidgetsSourceListPatchExpandableItem* item);
static void granite_widgets_source_list_patch_tree_real_row_expanded (GtkTreeView* base,
                                                               GtkTreeIter* iter,
                                                               GtkTreePath* path);
static void granite_widgets_source_list_patch_tree_real_row_collapsed (GtkTreeView* base,
                                                                GtkTreeIter* iter,
                                                                GtkTreePath* path);
static void granite_widgets_source_list_patch_tree_real_row_activated (GtkTreeView* base,
                                                                GtkTreePath* path,
                                                                GtkTreeViewColumn* column);
static gboolean granite_widgets_source_list_patch_tree_real_key_release_event (GtkWidget* base,
                                                                        GdkEventKey* event);
static gboolean granite_widgets_source_list_patch_tree_real_button_release_event (GtkWidget* base,
                                                                           GdkEventButton* event);
static gboolean granite_widgets_source_list_patch_tree_real_button_press_event (GtkWidget* base,
                                                                         GdkEventButton* event);
static gboolean granite_widgets_source_list_patch_tree_popup_context_menu (GraniteWidgetsSourceListPatchTree* self,
                                                                    GraniteWidgetsSourceListPatchItem* item,
                                                                    GdkEventButton* event);
static gboolean granite_widgets_source_list_patch_tree_over_cell (GraniteWidgetsSourceListPatchTree* self,
                                                           GtkTreeViewColumn* col,
                                                           GtkTreePath* path,
                                                           GtkCellRenderer* cell,
                                                           gint x);
static gboolean granite_widgets_source_list_patch_tree_over_primary_expander (GraniteWidgetsSourceListPatchTree* self,
                                                                       GtkTreeViewColumn* col,
                                                                       GtkTreePath* path,
                                                                       gint x);
static void granite_widgets_source_list_patch_tree_expander_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                                     GtkCellLayout* layout,
                                                                     GtkCellRenderer* renderer,
                                                                     GtkTreeModel* model,
                                                                     GtkTreeIter* iter);
static gint granite_widgets_source_list_patch_tree_get_cell_width (GraniteWidgetsSourceListPatchTree* self,
                                                            GtkCellRenderer* cell_renderer);
static gboolean granite_widgets_source_list_patch_tree_real_popup_menu (GtkWidget* base);
static GraniteWidgetsSourceListPatchItem* granite_widgets_source_list_patch_tree_get_item_from_model (GtkTreeModel* model,
                                                                                               GtkTreeIter* iter);
static void granite_widgets_source_list_patch_tree_name_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                                 GtkCellLayout* layout,
                                                                 GtkCellRenderer* renderer,
                                                                 GtkTreeModel* model,
                                                                 GtkTreeIter* iter);
static void granite_widgets_source_list_patch_tree_badge_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                                  GtkCellLayout* layout,
                                                                  GtkCellRenderer* renderer,
                                                                  GtkTreeModel* model,
                                                                  GtkTreeIter* iter);
static void granite_widgets_source_list_patch_tree_icon_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                                 GtkCellLayout* layout,
                                                                 GtkCellRenderer* renderer,
                                                                 GtkTreeModel* model,
                                                                 GtkTreeIter* iter);
static void granite_widgets_source_list_patch_tree_set_data_model (GraniteWidgetsSourceListPatchTree* self,
                                                            GraniteWidgetsSourceListPatchDataModel* value);
static GObject * granite_widgets_source_list_patch_tree_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties);
static void _granite_widgets_source_list_patch_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                                GtkCellRenderer* cell,
                                                                                                GtkTreeModel* tree_model,
                                                                                                GtkTreeIter* iter,
                                                                                                gpointer self);
static void _granite_widgets_source_list_patch_tree_on_activatable_activated_granite_widgets_source_list_patch_cell_renderer_icon_activated (GraniteWidgetsSourceListPatchCellRendererIcon* _sender,
                                                                                                                                      const gchar* path,
                                                                                                                                      gpointer self);
static void _granite_widgets_source_list_patch_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                            GtkCellRenderer* cell,
                                                                                            GtkTreeModel* tree_model,
                                                                                            GtkTreeIter* iter,
                                                                                            gpointer self);
static void _granite_widgets_source_list_patch_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                             GtkCellRenderer* cell,
                                                                                             GtkTreeModel* tree_model,
                                                                                             GtkTreeIter* iter,
                                                                                             gpointer self);
static void _granite_widgets_source_list_patch_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                                   GtkCellEditable* editable,
                                                                                                   const gchar* path,
                                                                                                   gpointer self);
static void _granite_widgets_source_list_patch_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                                     gpointer self);
static void _granite_widgets_source_list_patch_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                            GtkCellRenderer* cell,
                                                                                            GtkTreeModel* tree_model,
                                                                                            GtkTreeIter* iter,
                                                                                            gpointer self);
static gboolean _granite_widgets_source_list_patch_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection,
                                                                                      GtkTreeModel* model,
                                                                                      GtkTreePath* path,
                                                                                      gboolean path_currently_selected,
                                                                                      gpointer self);
static void granite_widgets_source_list_patch_tree_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_tree_get_property (GObject * object,
                                                                guint property_id,
                                                                GValue * value,
                                                                GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_tree_set_property (GObject * object,
                                                                guint property_id,
                                                                const GValue * value,
                                                                GParamSpec * pspec);
static void granite_widgets_source_list_patch_finalize (GObject * obj);
static void _vala_granite_widgets_source_list_patch_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec);
static void _vala_granite_widgets_source_list_patch_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec);


/**
     * Whether this item will allow users to re-arrange its children via DnD.
     *
     * This feature can co-exist with a sort algorithm (implemented
     * by {@link Granite.Widgets.SourceListPatchSortable.compare}), but
     * the actual order of the items in the list will always
     * honor that method. The sort function has to be compatible with
     * the kind of DnD reordering the item wants to allow, since the user can
     * only reorder those items for which //compare// returns 0.
     *
     * @return Whether the item's children can be re-arranged by users.
     * @since 0.3
     */
gboolean
granite_widgets_source_list_patch_sortable_allow_dnd_sorting (GraniteWidgetsSourceListPatchSortable* self)
{
#line 43 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 43 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_GET_INTERFACE (self)->allow_dnd_sorting (self);
#line 1164 "SourceList.c"
}


/**
     * Should return a negative integer, zero, or a positive integer if ''a''
     * sorts //before// ''b'', ''a'' sorts //with// ''b'', or ''a'' sorts
     * //after// ''b'' respectively. If two items compare as equal, their
     * order in the sorted source list is undefined.
     *
     * In order to ensure that the source list behaves as expected, this
     * method must define a partial order on the source list tree; i.e. it
     * must be reflexive, antisymmetric and transitive. Not complying with
     * those requirements could make the program fall into an infinite loop
     * and freeze the user interface.
     *
     * Should return //0// to allow any pair of items to be sortable via DnD.
     *
     * @param a First item.
     * @param b Second item.
     * @return A //negative// integer if //a// sorts before //b//,
     *         //zero// if //a// equals //b//, or a //positive//
     *         integer if //a// sorts after //b//.
     * @since 0.3
     */
gint
granite_widgets_source_list_patch_sortable_compare (GraniteWidgetsSourceListPatchSortable* self,
                                                    GraniteWidgetsSourceListPatchItem* a,
                                                    GraniteWidgetsSourceListPatchItem* b)
{
#line 66 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_GET_INTERFACE (self)->compare (self, a, b);
#line 1198 "SourceList.c"
}


static void
granite_widgets_source_list_patch_sortable_default_init (GraniteWidgetsSourceListPatchSortableIface * iface)
{
	/**
	     * Emitted after a user has re-ordered an item via DnD.
	     *
	     * @param moved The item that was moved to a different position by the user.
	     * @since 0.3
	     */
#line 21 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_USER_MOVED_ITEM_SIGNAL] = g_signal_new ("user-moved-item", GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 1213 "SourceList.c"
}


GType
granite_widgets_source_list_patch_sortable_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_sortable_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_sortable_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchSortableIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_sortable_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_patch_sortable_type_id;
		granite_widgets_source_list_patch_sortable_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListPatchSortable", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_patch_sortable_type_id, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_patch_sortable_type_id__volatile, granite_widgets_source_list_patch_sortable_type_id);
	}
	return granite_widgets_source_list_patch_sortable_type_id__volatile;
}


/**
     * Determines whether this item can be dragged outside the source list widget.
     *
     * Even if this method returns //false//, the item could still be dragged around
     * within the source list if its parent allows DnD reordering. This only happens
     * when the parent implements {@link Granite.Widgets.SourceListPatchSortable}.
     *
     * @return //true// if the item can be dragged; //false// otherwise.
     * @since 0.3
     * @see Granite.Widgets.SourceListPatchSortable
     */
gboolean
granite_widgets_source_list_patch_drag_source_draggable (GraniteWidgetsSourceListPatchDragSource* self)
{
#line 86 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_SOURCE_GET_INTERFACE (self)->draggable (self);
#line 1250 "SourceList.c"
}


/**
     * This method is called when the drop site requests the data which is dragged.
     *
     * It is the responsibility of this method to fill //selection_data// with the
     * data in the format which is indicated by {@link Gtk.SelectionData.get_target}.
     *
     * @param selection_data {@link Gtk.SelectionData} containing source data.
     * @since 0.3
     * @see Gtk.SelectionData.set
     * @see Gtk.SelectionData.set_uris
     * @see Gtk.SelectionData.set_text
     */
void
granite_widgets_source_list_patch_drag_source_prepare_selection_data (GraniteWidgetsSourceListPatchDragSource* self,
                                                                      GtkSelectionData* selection_data)
{
#line 100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_SOURCE_GET_INTERFACE (self)->prepare_selection_data (self, selection_data);
#line 1274 "SourceList.c"
}


static void
granite_widgets_source_list_patch_drag_source_default_init (GraniteWidgetsSourceListPatchDragSourceIface * iface)
{
}


/**
 * An interface for dragging items out of the source list widget.
 *
 * @since 0.3
 */
GType
granite_widgets_source_list_patch_drag_source_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_drag_source_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_drag_source_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchDragSourceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_drag_source_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_patch_drag_source_type_id;
		granite_widgets_source_list_patch_drag_source_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListPatchDragSource", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_patch_drag_source_type_id, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_patch_drag_source_type_id__volatile, granite_widgets_source_list_patch_drag_source_type_id);
	}
	return granite_widgets_source_list_patch_drag_source_type_id__volatile;
}


/**
     * Determines whether //data// can be dropped into this item.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return //true// if the drop is possible; //false// otherwise.
     * @since 0.3
     */
gboolean
granite_widgets_source_list_patch_drag_dest_data_drop_possible (GraniteWidgetsSourceListPatchDragDest* self,
                                                                GdkDragContext* context,
                                                                GtkSelectionData* data)
{
#line 117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_DEST_GET_INTERFACE (self)->data_drop_possible (self, context, data);
#line 1321 "SourceList.c"
}


/**
     * If a data drop is deemed possible, then this method is called
     * when the data is actually dropped into this item. Any actions
     * consequence of the data received should be handled here.
     *
     * @param context The drag context.
     * @param data {@link Gtk.SelectionData} containing source data.
     * @return The action taken, or //0// to indicate that the dropped data was not accepted.
     * @since 0.3
     */
GdkDragAction
granite_widgets_source_list_patch_drag_dest_data_received (GraniteWidgetsSourceListPatchDragDest* self,
                                                           GdkDragContext* context,
                                                           GtkSelectionData* data)
{
#line 129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_DRAG_DEST_GET_INTERFACE (self)->data_received (self, context, data);
#line 1344 "SourceList.c"
}


static void
granite_widgets_source_list_patch_drag_dest_default_init (GraniteWidgetsSourceListPatchDragDestIface * iface)
{
}


/**
 * An interface for receiving data from other widgets via drag-and-drop.
 *
 * @since 0.3
 */
GType
granite_widgets_source_list_patch_drag_dest_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_drag_dest_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_drag_dest_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchDragDestIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_drag_dest_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType granite_widgets_source_list_patch_drag_dest_type_id;
		granite_widgets_source_list_patch_drag_dest_type_id = g_type_register_static (G_TYPE_INTERFACE, "GraniteWidgetsSourceListPatchDragDest", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (granite_widgets_source_list_patch_drag_dest_type_id, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
		g_once_init_leave (&granite_widgets_source_list_patch_drag_dest_type_id__volatile, granite_widgets_source_list_patch_drag_dest_type_id);
	}
	return granite_widgets_source_list_patch_drag_dest_type_id__volatile;
}


static inline gpointer
granite_widgets_source_list_patch_get_instance_private (GraniteWidgetsSourceListPatch* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatch_private_offset);
}


/**
         * Creates a new {@link Granite.Widgets.SourceListPatch}.
         *
         * @return A new {@link Granite.Widgets.SourceListPatch}.
         * @since 0.2
         */
GraniteWidgetsSourceListPatch*
granite_widgets_source_list_patch_construct (GType object_type,
                                             GraniteWidgetsSourceListPatchExpandableItem* root)
{
	GraniteWidgetsSourceListPatch * self = NULL;
#line 2450 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (root != NULL, NULL);
#line 2450 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatch*) g_object_new (object_type, NULL);
#line 2451 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_set_root (self, root);
#line 2450 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 1400 "SourceList.c"
}


GraniteWidgetsSourceListPatch*
granite_widgets_source_list_patch_new (GraniteWidgetsSourceListPatchExpandableItem* root)
{
#line 2450 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_construct (GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, root);
#line 1409 "SourceList.c"
}


/**
         * Checks whether //item// is part of the source list.
         *
         * @param item The item to query.
         * @return //true// if the item belongs to the source list; //false// otherwise.
         * @since 0.2
         */
gboolean
granite_widgets_source_list_patch_has_item (GraniteWidgetsSourceListPatch* self,
                                            GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 2471 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2471 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2472 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2472 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = granite_widgets_source_list_patch_data_model_has_item (_tmp0_, item);
#line 2472 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1436 "SourceList.c"
}


/**
         * Sets the method used for filtering out items.
         *
         * @param visible_func The method to use for filtering items.
         * @param refilter Whether to call {@link Granite.Widgets.SourceListPatch.refilter} using the new function.
         * @see Granite.Widgets.SourceListPatch.VisibleFunc
         * @see Granite.Widgets.SourceListPatch.refilter
         * @since 0.2
         */
void
granite_widgets_source_list_patch_set_filter_func (GraniteWidgetsSourceListPatch* self,
                                                   GraniteWidgetsSourceListPatchVisibleFunc visible_func,
                                                   gpointer visible_func_target,
                                                   gboolean refilter)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 2484 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2485 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2485 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_set_filter_func (_tmp0_, visible_func, visible_func_target);
#line 2486 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (refilter) {
#line 2487 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_refilter (self);
#line 1466 "SourceList.c"
	}
}


/**
         * Applies the filter method set by {@link Granite.Widgets.SourceListPatch.set_filter_func}
         * to all the items that are part of the current tree.
         *
         * @see Granite.Widgets.SourceListPatch.VisibleFunc
         * @see Granite.Widgets.SourceListPatch.set_filter_func
         * @since 0.2
         */
void
granite_widgets_source_list_patch_refilter (GraniteWidgetsSourceListPatch* self)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 2498 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2499 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2499 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_filter_refilter ((GtkTreeModelFilter*) _tmp0_);
#line 1489 "SourceList.c"
}


/**
         * Queries the actual expansion state of //item//.
         *
         * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
         * @return Whether //item// is expanded or not.
         * @since 0.2
         */
static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 1505 "SourceList.c"
}


gboolean
granite_widgets_source_list_patch_is_item_expanded (GraniteWidgetsSourceListPatch* self,
                                                    GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkTreePath* _tmp3_;
#line 2509 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2509 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2509 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_patch_has_item (self, item), "has_item (item)", FALSE);
#line 2510 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2510 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp0_, item);
#line 2510 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp1_;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = path;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 1535 "SourceList.c"
		GraniteWidgetsSourceListPatchTree* _tmp4_;
		GtkTreePath* _tmp5_;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = self->priv->tree;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = path;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = gtk_tree_view_row_expanded ((GtkTreeView*) _tmp4_, _tmp5_);
#line 1544 "SourceList.c"
	} else {
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = FALSE;
#line 1548 "SourceList.c"
	}
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1556 "SourceList.c"
}


/**
         * If //item// is editable, this activates the editor; otherwise, it does nothing.
         * If an item was already being edited, this will fail.
         *
         * @param item Item to edit.
         * @see Granite.Widgets.SourceListPatch.Item.editable
         * @see Granite.Widgets.SourceListPatch.editing
         * @see Granite.Widgets.SourceListPatch.stop_editing
         * @return true if the editing started successfully; false otherwise.
         * @since 0.2
         */
gboolean
granite_widgets_source_list_patch_start_editing_item (GraniteWidgetsSourceListPatch* self,
                                                      GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2525 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2525 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2525 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_patch_has_item (self, item), "has_item (item)", FALSE);
#line 2526 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2526 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = granite_widgets_source_list_patch_tree_start_editing_item (_tmp0_, item);
#line 2526 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1589 "SourceList.c"
}


/**
         * Cancels any editing operation going on.
         *
         * @see Granite.Widgets.SourceListPatch.editing
         * @see Granite.Widgets.SourceListPatch.start_editing_item
         * @since 0.2
         */
void
granite_widgets_source_list_patch_stop_editing (GraniteWidgetsSourceListPatch* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 2536 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2537 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_get_editing (self);
#line 2537 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2537 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 1613 "SourceList.c"
		GraniteWidgetsSourceListPatchTree* _tmp2_;
#line 2538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = self->priv->tree;
#line 2538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_stop_editing (_tmp2_);
#line 1619 "SourceList.c"
	}
}


/**
         * Turns Source List into a //drag source//.
         *
         * This enables items that implement {@link Granite.Widgets.SourceListPatchDragSource}
         * to be dragged outside the Source List and drop data into external widgets.
         *
         * @param src_entries an array of {@link Gtk.TargetEntry}s indicating the targets
         * that the drag will support.
         * @see Granite.Widgets.SourceListPatchDragSource
         * @see Granite.Widgets.SourceListPatch.disable_drag_source
         * @since 0.3
         */
void
granite_widgets_source_list_patch_enable_drag_source (GraniteWidgetsSourceListPatch* self,
                                                      GtkTargetEntry* src_entries,
                                                      int src_entries_length1)
{
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2553 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2554 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2554 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_source (_tmp0_, src_entries, src_entries_length1);
#line 1648 "SourceList.c"
}


/**
         * Undoes the effect of {@link Granite.Widgets.SourceListPatch.enable_drag_source}
         *
         * @see Granite.Widgets.SourceListPatch.enable_drag_source
         * @since 0.3
         */
void
granite_widgets_source_list_patch_disable_drag_source (GraniteWidgetsSourceListPatch* self)
{
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2563 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_source (_tmp0_, NULL, 0);
#line 1668 "SourceList.c"
}


/**
         * Turns Source List into a //drop destination//.
         *
         * This enables items that implement {@link Granite.Widgets.SourceListPatchDragDest}
         * to receive data from external widgets via drag-and-drop.
         *
         * @param dest_entries an array of {@link Gtk.TargetEntry}s indicating the drop
         * types that Source List items will accept.
         * @param actions a bitmask of possible actions for a drop onto Source List items.
         * @see Granite.Widgets.SourceListPatchDragDest
         * @see Granite.Widgets.SourceListPatch.disable_drag_dest
         * @since 0.3
         */
void
granite_widgets_source_list_patch_enable_drag_dest (GraniteWidgetsSourceListPatch* self,
                                                    GtkTargetEntry* dest_entries,
                                                    int dest_entries_length1,
                                                    GdkDragAction actions)
{
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2580 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2581 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2581 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_dest (_tmp0_, dest_entries, dest_entries_length1, actions);
#line 1698 "SourceList.c"
}


/**
         * Undoes the effect of {@link Granite.Widgets.SourceListPatch.enable_drag_dest}
         *
         * @see Granite.Widgets.SourceListPatch.enable_drag_dest
         * @since 0.3
         */
void
granite_widgets_source_list_patch_disable_drag_dest (GraniteWidgetsSourceListPatch* self)
{
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2590 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2591 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2591 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_dest (_tmp0_, NULL, 0, 0);
#line 1718 "SourceList.c"
}


/**
         * Scrolls the source list tree to make //item// visible.
         *
         * {@link Granite.Widgets.SourceListPatch.ExpandableItem.expand_with_parents} is called
         * for the item's parent if //expand_parents// is //true//, to make sure it's not
         * hidden behind a collapsed row.
         *
         * If use_align is //false//, then the row_align argument is ignored, and the tree
         * does the minimum amount of work to scroll the item onto the screen. This means that
         * the item will be scrolled to the edge closest to its current position. If the item
         * is currently visible on the screen, nothing is done.
         *
         * @param item Item to scroll to.
         * @param expand_parents Whether to recursively expand item's parent in case they are collapsed.
         * @param use_align Whether to use the //row_align// argument.
         * @param row_align The vertical alignment of //item//. 0.0 means top, 0.5 center, and 1.0 bottom.
         * @return //true// if successful; //false// otherwise.
         * @since 0.2
         */
gboolean
granite_widgets_source_list_patch_scroll_to_item (GraniteWidgetsSourceListPatch* self,
                                                  GraniteWidgetsSourceListPatchItem* item,
                                                  gboolean expand_parents,
                                                  gboolean use_align,
                                                  gfloat row_align)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListPatchTree* _tmp5_;
#line 2613 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2613 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 2613 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_patch_has_item (self, item), "has_item (item)", FALSE);
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (expand_parents) {
#line 1759 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 1768 "SourceList.c"
	} else {
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 1772 "SourceList.c"
	}
#line 2616 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 1776 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp4_;
#line 2617 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 2617 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 2617 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_expand_with_parents (_tmp4_);
#line 1785 "SourceList.c"
	}
#line 2619 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = self->priv->tree;
#line 2619 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = granite_widgets_source_list_patch_tree_scroll_to_item (_tmp5_, item, use_align, row_align);
#line 2619 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1793 "SourceList.c"
}


/**
         * Gets the previous item with respect to //reference//.
         *
         * @param reference Item to use as reference.
         * @return The item that appears before //reference//, or //null// if there's none.
         * @since 0.2
         */
GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_previous_item (GraniteWidgetsSourceListPatch* self,
                                                     GraniteWidgetsSourceListPatchItem* reference)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter* _tmp2_;
#line 2629 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2629 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (reference != NULL, NULL);
#line 2629 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_patch_has_item (self, reference), "has_item (reference)", NULL);
#line 2631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_iter (_tmp0_, reference);
#line 2631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iter = _tmp1_;
#line 2632 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = iter;
#line 2632 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 1829 "SourceList.c"
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp3_;
		GraniteWidgetsSourceListPatchDataModel* _tmp4_;
		gboolean _tmp5_;
#line 2633 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = iter;
#line 2633 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		new_iter = *_tmp3_;
#line 2634 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = self->priv->data_model;
#line 2634 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = gtk_tree_model_iter_previous ((GtkTreeModel*) _tmp4_, &new_iter);
#line 2634 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 1844 "SourceList.c"
			GraniteWidgetsSourceListPatchDataModel* _tmp6_;
			GtkTreeIter _tmp7_;
			GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = self->priv->data_model;
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = new_iter;
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = granite_widgets_source_list_patch_data_model_get_item (_tmp6_, &_tmp7_);
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = _tmp8_;
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (iter);
#line 2635 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 1860 "SourceList.c"
		}
	}
#line 2638 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 2638 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (iter);
#line 2638 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1869 "SourceList.c"
}


/**
         * Gets the next item with respect to //reference//.
         *
         * @param reference Item to use as reference.
         * @return The item that appears after //reference//, or //null// if there's none.
         * @since 0.2
         */
GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_next_item (GraniteWidgetsSourceListPatch* self,
                                                 GraniteWidgetsSourceListPatchItem* reference)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GtkTreeIter* iter = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter* _tmp2_;
#line 2648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (reference != NULL, NULL);
#line 2648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (granite_widgets_source_list_patch_has_item (self, reference), "has_item (reference)", NULL);
#line 2650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_iter (_tmp0_, reference);
#line 2650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iter = _tmp1_;
#line 2651 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = iter;
#line 2651 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 1905 "SourceList.c"
		GtkTreeIter new_iter = {0};
		GtkTreeIter* _tmp3_;
		GraniteWidgetsSourceListPatchDataModel* _tmp4_;
		gboolean _tmp5_;
#line 2652 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = iter;
#line 2652 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		new_iter = *_tmp3_;
#line 2653 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = self->priv->data_model;
#line 2653 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &new_iter);
#line 2653 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 1920 "SourceList.c"
			GraniteWidgetsSourceListPatchDataModel* _tmp6_;
			GtkTreeIter _tmp7_;
			GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = self->priv->data_model;
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = new_iter;
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = granite_widgets_source_list_patch_data_model_get_item (_tmp6_, &_tmp7_);
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = _tmp8_;
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (iter);
#line 2654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 1936 "SourceList.c"
		}
	}
#line 2657 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 2657 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (iter);
#line 2657 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1945 "SourceList.c"
}


/**
         * Gets the first visible child of an expandable item.
         *
         * @param parent Parent of the child to look up.
         * @return The first visible child of //parent//, or null if it was not found.
         * @since 0.2
         */
GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_first_child (GraniteWidgetsSourceListPatch* self,
                                                   GraniteWidgetsSourceListPatchExpandableItem* parent)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
#line 2667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2668 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_get_nth_child (self, parent, 0);
#line 2668 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 2668 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1972 "SourceList.c"
}


/**
         * Gets the last visible child of an expandable item.
         *
         * @param parent Parent of the child to look up.
         * @return The last visible child of //parent//, or null if it was not found.
         * @since 0.2
         */
GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_last_child (GraniteWidgetsSourceListPatch* self,
                                                  GraniteWidgetsSourceListPatchExpandableItem* parent)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
#line 2678 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2678 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2679 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_get_nth_child (self, parent, ((gint) granite_widgets_source_list_patch_get_n_visible_children (self, parent)) - 1);
#line 2679 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 2679 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 1999 "SourceList.c"
}


/**
         * Gets the number of visible children of an expandable item.
         *
         * @param parent Item to query.
         * @return Number of visible children of //parent//.
         * @since 0.2
         */
guint
granite_widgets_source_list_patch_get_n_visible_children (GraniteWidgetsSourceListPatch* self,
                                                          GraniteWidgetsSourceListPatchExpandableItem* parent)
{
	guint result = 0U;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GraniteWidgetsSourceListPatchDataModel* _tmp2_;
#line 2689 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 2689 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (parent != NULL, 0U);
#line 2691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_iter (_tmp0_, (GraniteWidgetsSourceListPatchItem*) parent);
#line 2691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_iter = _tmp1_;
#line 2692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->data_model;
#line 2692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = (guint) gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp2_, parent_iter);
#line 2692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (parent_iter);
#line 2692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2037 "SourceList.c"
}


static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_nth_child (GraniteWidgetsSourceListPatch* self,
                                                 GraniteWidgetsSourceListPatchExpandableItem* parent,
                                                 gint index)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GtkTreeIter* parent_iter = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter* _tmp1_;
	GtkTreeIter child_iter = {0};
	GraniteWidgetsSourceListPatchDataModel* _tmp2_;
	GtkTreeIter* _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
#line 2695 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2695 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 2696 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (index < 0) {
#line 2697 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = NULL;
#line 2697 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 2065 "SourceList.c"
	}
#line 2700 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2700 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_iter (_tmp0_, (GraniteWidgetsSourceListPatchItem*) parent);
#line 2700 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_iter = _tmp1_;
#line 2703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->data_model;
#line 2703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = parent_iter;
#line 2703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp2_, &_tmp4_, _tmp3_, index);
#line 2703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_iter = _tmp4_;
#line 2703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_) {
#line 2083 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModel* _tmp6_;
		GtkTreeIter _tmp7_;
		GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = self->priv->data_model;
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = child_iter;
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = granite_widgets_source_list_patch_data_model_get_item (_tmp6_, &_tmp7_);
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = _tmp8_;
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (parent_iter);
#line 2704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 2099 "SourceList.c"
	}
#line 2706 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 2706 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (parent_iter);
#line 2706 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2107 "SourceList.c"
}


GraniteWidgetsSourceListPatchExpandableItem*
granite_widgets_source_list_patch_get_root (GraniteWidgetsSourceListPatch* self)
{
	GraniteWidgetsSourceListPatchExpandableItem* result;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_root (_tmp0_);
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2399 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2130 "SourceList.c"
}


void
granite_widgets_source_list_patch_set_root (GraniteWidgetsSourceListPatch* self,
                                            GraniteWidgetsSourceListPatchExpandableItem* value)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 2400 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2400 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2400 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_set_root (_tmp0_, value);
#line 2400 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY]);
#line 2147 "SourceList.c"
}


GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_get_selected (GraniteWidgetsSourceListPatch* self)
{
	GraniteWidgetsSourceListPatchItem* result;
	GraniteWidgetsSourceListPatchTree* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_get_selected_item (_tmp0_);
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2413 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2170 "SourceList.c"
}


void
granite_widgets_source_list_patch_set_selected (GraniteWidgetsSourceListPatch* self,
                                                GraniteWidgetsSourceListPatchItem* value)
{
	gboolean _tmp0_ = FALSE;
	GraniteWidgetsSourceListPatchTree* _tmp5_;
#line 2414 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (value != NULL) {
#line 2184 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = granite_widgets_source_list_patch_item_get_parent (value);
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 2193 "SourceList.c"
	} else {
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 2197 "SourceList.c"
	}
#line 2415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 2201 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp4_;
#line 2416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_patch_item_get_parent (value);
#line 2416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 2416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_expand_with_parents (_tmp4_);
#line 2210 "SourceList.c"
	}
#line 2417 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = self->priv->tree;
#line 2417 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_set_selected_item (_tmp5_, value);
#line 2414 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY]);
#line 2218 "SourceList.c"
}


PangoEllipsizeMode
granite_widgets_source_list_patch_get_ellipsize_mode (GraniteWidgetsSourceListPatch* self)
{
	PangoEllipsizeMode result;
	GraniteWidgetsSourceListPatchTree* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_get_ellipsize_mode (_tmp0_);
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2427 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2241 "SourceList.c"
}


void
granite_widgets_source_list_patch_set_ellipsize_mode (GraniteWidgetsSourceListPatch* self,
                                                      PangoEllipsizeMode value)
{
	GraniteWidgetsSourceListPatchTree* _tmp0_;
#line 2428 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2428 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2428 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_set_ellipsize_mode (_tmp0_, value);
#line 2428 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY]);
#line 2258 "SourceList.c"
}


gboolean
granite_widgets_source_list_patch_get_editing (GraniteWidgetsSourceListPatch* self)
{
	gboolean result;
	GraniteWidgetsSourceListPatchTree* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->tree;
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_get_editing (_tmp0_);
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2438 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2281 "SourceList.c"
}


static void
granite_widgets_source_list_patch_real_item_selected (GraniteWidgetsSourceListPatch* self,
                                                      GraniteWidgetsSourceListPatchItem* item)
{
}


static void
_granite_widgets_source_list_patch___lambda21_ (GraniteWidgetsSourceListPatch* self,
                                                GraniteWidgetsSourceListPatchItem* item)
{
#line 2461 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTED_SIGNAL], 0, item);
#line 2298 "SourceList.c"
}


static void
__granite_widgets_source_list_patch___lambda21__granite_widgets_source_list_patch_tree_item_selected (GraniteWidgetsSourceListPatchTree* _sender,
                                                                                                      GraniteWidgetsSourceListPatchItem* item,
                                                                                                      gpointer self)
{
#line 2461 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch___lambda21_ ((GraniteWidgetsSourceListPatch*) self, item);
#line 2309 "SourceList.c"
}


static GObject *
granite_widgets_source_list_patch_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListPatch * self;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GraniteWidgetsSourceListPatchTree* _tmp1_;
	GraniteWidgetsSourceListPatchTree* _tmp2_;
	GraniteWidgetsSourceListPatchTree* _tmp3_;
#line 2454 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_patch_parent_class);
#line 2454 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2454 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatch);
#line 2455 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->data_model;
#line 2455 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_new (_tmp0_);
#line 2455 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp1_);
#line 2455 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->tree);
#line 2455 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->tree = _tmp1_;
#line 2457 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 2458 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->tree;
#line 2458 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp2_);
#line 2459 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 2461 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = self->priv->tree;
#line 2461 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (_tmp3_, "item-selected", (GCallback) __granite_widgets_source_list_patch___lambda21__granite_widgets_source_list_patch_tree_item_selected, self, 0);
#line 2454 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return obj;
#line 2355 "SourceList.c"
}


static inline gpointer
granite_widgets_source_list_patch_item_get_instance_private (GraniteWidgetsSourceListPatchItem* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchItem_private_offset);
}


/**
             * Creates a new {@link Granite.Widgets.SourceListPatch.Item}.
             *
             * @param name Name of the item.
             * @return (transfer full) A new {@link Granite.Widgets.SourceListPatch.Item}.
             * @since 0.2
             */
GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_item_construct (GType object_type,
                                                  const gchar* name)
{
	GraniteWidgetsSourceListPatchItem * self = NULL;
#line 316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchItem*) g_object_new (object_type, NULL);
#line 317 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_set_name (self, name);
#line 316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 2386 "SourceList.c"
}


GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_item_new (const gchar* name)
{
#line 316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_item_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, name);
#line 2395 "SourceList.c"
}


/**
             * Invoked when the item is secondary-clicked or when the usual menu keys are pressed.
             *
             * Note that since Granite 5.0, right clicking on an item no longer selects/activates it, so
             * any context menu items should be actioned on the item instance rather than the selected item
             * in the SourceListPatch
             *
             * @return A {@link Gtk.Menu} or //null// if nothing should be displayed.
             * @since 0.2
             */
static GtkMenu*
granite_widgets_source_list_patch_item_real_get_context_menu (GraniteWidgetsSourceListPatchItem* self)
{
	GtkMenu* result = NULL;
#line 331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2417 "SourceList.c"
}


GtkMenu*
granite_widgets_source_list_patch_item_get_context_menu (GraniteWidgetsSourceListPatchItem* self)
{
#line 330 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 330 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_GET_CLASS (self)->get_context_menu (self);
#line 2428 "SourceList.c"
}


GraniteWidgetsSourceListPatchExpandableItem*
granite_widgets_source_list_patch_item_get_parent (GraniteWidgetsSourceListPatchItem* self)
{
	GraniteWidgetsSourceListPatchExpandableItem* result;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_parent;
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2445 "SourceList.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self ? g_object_ref (self) : NULL;
#line 2454 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_parent (GraniteWidgetsSourceListPatchItem* self,
                                                   GraniteWidgetsSourceListPatchExpandableItem* value)
{
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_parent (self) != value) {
#line 2466 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->_parent);
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_parent = _tmp0_;
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY]);
#line 2476 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_patch_item_get_name (GraniteWidgetsSourceListPatchItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_name;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2494 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_name (GraniteWidgetsSourceListPatchItem* self,
                                                 const gchar* value)
{
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_patch_item_get_name (self)) != 0) {
#line 2506 "SourceList.c"
		gchar* _tmp0_;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (self->priv->_name);
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_name = _tmp0_;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY]);
#line 2516 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_patch_item_get_markup (GraniteWidgetsSourceListPatchItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_markup;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2534 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_markup (GraniteWidgetsSourceListPatchItem* self,
                                                   const gchar* value)
{
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_patch_item_get_markup (self)) != 0) {
#line 2546 "SourceList.c"
		gchar* _tmp0_;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (self->priv->_markup);
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_markup = _tmp0_;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY]);
#line 2556 "SourceList.c"
	}
}


const gchar*
granite_widgets_source_list_patch_item_get_badge (GraniteWidgetsSourceListPatchItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_badge;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2574 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_badge (GraniteWidgetsSourceListPatchItem* self,
                                                  const gchar* value)
{
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_strcmp0 (value, granite_widgets_source_list_patch_item_get_badge (self)) != 0) {
#line 2586 "SourceList.c"
		gchar* _tmp0_;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = g_strdup (value);
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (self->priv->_badge);
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_badge = _tmp0_;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY]);
#line 2596 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_patch_item_get_editable (GraniteWidgetsSourceListPatchItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_editable;
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2614 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_editable (GraniteWidgetsSourceListPatchItem* self,
                                                     gboolean value)
{
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_editable (self) != value) {
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_editable = value;
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY]);
#line 2630 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_patch_item_get_visible (GraniteWidgetsSourceListPatchItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_visible;
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2648 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_visible (GraniteWidgetsSourceListPatchItem* self,
                                                    gboolean value)
{
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_visible (self) != value) {
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_visible = value;
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY]);
#line 2664 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_patch_item_get_selectable (GraniteWidgetsSourceListPatchItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_selectable;
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2682 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_selectable (GraniteWidgetsSourceListPatchItem* self,
                                                       gboolean value)
{
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_selectable (self) != value) {
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_selectable = value;
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY]);
#line 2698 "SourceList.c"
	}
}


GIcon*
granite_widgets_source_list_patch_item_get_icon (GraniteWidgetsSourceListPatchItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_icon;
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2716 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_icon (GraniteWidgetsSourceListPatchItem* self,
                                                 GIcon* value)
{
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_icon (self) != value) {
#line 2728 "SourceList.c"
		GIcon* _tmp0_;
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->_icon);
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_icon = _tmp0_;
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY]);
#line 2738 "SourceList.c"
	}
}


GIcon*
granite_widgets_source_list_patch_item_get_activatable (GraniteWidgetsSourceListPatchItem* self)
{
	GIcon* result;
	GIcon* _tmp0_;
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_activatable;
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 2756 "SourceList.c"
}


void
granite_widgets_source_list_patch_item_set_activatable (GraniteWidgetsSourceListPatchItem* self,
                                                        GIcon* value)
{
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_item_get_activatable (self) != value) {
#line 2768 "SourceList.c"
		GIcon* _tmp0_;
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->_activatable);
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_activatable = _tmp0_;
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY]);
#line 2778 "SourceList.c"
	}
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 2804 "SourceList.c"
}


static void
granite_widgets_source_list_patch_item_real_edited (GraniteWidgetsSourceListPatchItem* self,
                                                    const gchar* new_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 195 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (new_name != NULL);
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->_editable;
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 2820 "SourceList.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = string_strip (new_name);
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, "") != 0;
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (_tmp3_);
#line 2831 "SourceList.c"
	} else {
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 2835 "SourceList.c"
	}
#line 196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 197 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_name (self, new_name);
#line 2841 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_item_real_action_activated (GraniteWidgetsSourceListPatchItem* self)
{
}


static void
granite_widgets_source_list_patch_item_real_activated (GraniteWidgetsSourceListPatchItem* self)
{
}


static void
granite_widgets_source_list_patch_item_class_init (GraniteWidgetsSourceListPatchItemClass * klass)
{
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_parent_class = g_type_class_peek_parent (klass);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchItem_private_offset);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchItemClass *) klass)->get_context_menu = (GtkMenu* (*) (GraniteWidgetsSourceListPatchItem*)) granite_widgets_source_list_patch_item_real_get_context_menu;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchItemClass *) klass)->edited = granite_widgets_source_list_patch_item_real_edited;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchItemClass *) klass)->action_activated = granite_widgets_source_list_patch_item_real_action_activated;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchItemClass *) klass)->activated = granite_widgets_source_list_patch_item_real_activated;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_item_get_property;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_item_set_property;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_item_finalize;
#line 2879 "SourceList.c"
	/**
	             * Parent {@link Granite.Widgets.SourceListPatch.ExpandableItem} of the item.
	             * ''Must not'' be modified.
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY] = g_param_spec_object ("parent", "parent", "parent", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2888 "SourceList.c"
	/**
	             * The item's name. Primary and most important information.
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2896 "SourceList.c"
	/**
	             * Markup to be used instead of {@link Granite.Widgets.SourceListPatch.ExpandableItem.name}
	             * This would mean that &, <, etc have to be escaped in the text, but basic formatting
	             * can be done on the item with HTML style tags.
	             *
	             * Note: Only the {@link Granite.Widgets.SourceListPatch.ExpandableItem.name} property
	             * is modified for editable items. So this property will be need to updated and
	             * reformatted with editable items.
	             *
	             * @since 5.0
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY] = g_param_spec_string ("markup", "markup", "markup", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2910 "SourceList.c"
	/**
	             * A badge shown next to the item's name.
	             *
	             * It can be used for displaying the number of unread messages in the "Inbox" item,
	             * for instance.
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY] = g_param_spec_string ("badge", "badge", "badge", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2921 "SourceList.c"
	/**
	             * Whether the item's name can be edited from within the source list.
	             *
	             * When this property is set to //true//, users can edit the item by pressing
	             * the F2 key, or by double-clicking its name.
	             *
	             * ''This property only works for selectable items''.
	             *
	             * @see Granite.Widgets.SourceListPatch.Item.selectable
	             * @see Granite.Widgets.SourceListPatch.start_editing_item
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2936 "SourceList.c"
	/**
	             * Whether the item should appear in the source list's tree or not.
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY] = g_param_spec_boolean ("visible", "visible", "visible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2944 "SourceList.c"
	/**
	             * Whether the item can be selected or not.
	             *
	             * Setting this property to true doesn't guarantee that the item will actually be
	             * selectable, since there are other external factors to take into account, like the
	             * item's {@link Granite.Widgets.SourceListPatch.Item.visible} property; whether the item is
	             * a category; the parent item is collapsed, etc.
	             *
	             * @see Granite.Widgets.SourceListPatch.Item.visible
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2958 "SourceList.c"
	/**
	             * Primary icon.
	             *
	             * This property should be used to give the user an idea of what the item represents
	             * (i.e. content type.)
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2969 "SourceList.c"
	/**
	             * An activatable icon that works like a button.
	             *
	             * It can be used for e.g. showing an //"eject"// icon on a device's item.
	             *
	             * @see Granite.Widgets.SourceListPatch.Item.action_activated
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY, granite_widgets_source_list_patch_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY] = g_param_spec_object ("activatable", "activatable", "activatable", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2980 "SourceList.c"
	/**
	             * Emitted when the user has finished editing the item's name.
	             *
	             * By default, if the name doesn't consist of white space, it is automatically assigned
	             * to the {@link Granite.Widgets.SourceListPatch.Item.name} property. The default behavior can
	             * be changed by overriding this signal.
	             * @param new_name The item's new name (result of editing.)
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITED_SIGNAL] = g_signal_new ("edited", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListPatchItemClass, edited), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 2992 "SourceList.c"
	/**
	             * The {@link Granite.Widgets.SourceListPatch.Item.activatable} icon was activated.
	             *
	             * @see Granite.Widgets.SourceListPatch.Item.activatable
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTION_ACTIVATED_SIGNAL] = g_signal_new ("action-activated", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListPatchItemClass, action_activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3001 "SourceList.c"
	/**
	             * Emitted when the item is double-clicked or when it is selected and one of the keys:
	             * Space, Shift+Space, Return or Enter is pressed. This signal is //also// for
	             * editable items.
	             *
	             * @since 0.2
	             */
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListPatchItemClass, activated), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3011 "SourceList.c"
}


static void
granite_widgets_source_list_patch_item_instance_init (GraniteWidgetsSourceListPatchItem * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_item_get_instance_private (self);
#line 182 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->use_pango_style = TRUE;
#line 183 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->force_visible = FALSE;
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = g_strdup ("");
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_name = _tmp0_;
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_markup = NULL;
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = g_strdup ("");
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_badge = _tmp1_;
#line 267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_editable = FALSE;
#line 274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_visible = TRUE;
#line 287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_selectable = TRUE;
#line 3042 "SourceList.c"
}


static void
granite_widgets_source_list_patch_item_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatchItem * self;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItem);
#line 223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_parent);
#line 230 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (self->priv->_name);
#line 243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (self->priv->_markup);
#line 253 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (self->priv->_badge);
#line 297 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_icon);
#line 307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_activatable);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_item_parent_class)->finalize (obj);
#line 3066 "SourceList.c"
}


/**
         * A source list entry.
         *
         * Any change made to any of its properties will be ''automatically'' reflected
         * by the {@link Granite.Widgets.SourceListPatch} widget.
         *
         * @since 0.2
         */
GType
granite_widgets_source_list_patch_item_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchItem), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_item_instance_init, NULL };
		GType granite_widgets_source_list_patch_item_type_id;
		granite_widgets_source_list_patch_item_type_id = g_type_register_static (G_TYPE_OBJECT, "GraniteWidgetsSourceListPatchItem", &g_define_type_info, 0);
		GraniteWidgetsSourceListPatchItem_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_item_type_id, sizeof (GraniteWidgetsSourceListPatchItemPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_item_type_id__volatile, granite_widgets_source_list_patch_item_type_id);
	}
	return granite_widgets_source_list_patch_item_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_item_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItem);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_item_get_parent (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_patch_item_get_name (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_patch_item_get_markup (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_string (value, granite_widgets_source_list_patch_item_get_badge (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_item_get_editable (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_item_get_visible (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_item_get_selectable (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_item_get_icon (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_item_get_activatable (self));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 3157 "SourceList.c"
		default:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 3163 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_item_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, GraniteWidgetsSourceListPatchItem);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_PARENT_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_parent (self, g_value_get_object (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_NAME_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_name (self, g_value_get_string (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_MARKUP_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_markup (self, g_value_get_string (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_BADGE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_badge (self, g_value_get_string (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_editable (self, g_value_get_boolean (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_VISIBLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_visible (self, g_value_get_boolean (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_selectable (self, g_value_get_boolean (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ICON_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_icon (self, g_value_get_object (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATABLE_PROPERTY:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_item_set_activatable (self, g_value_get_object (value));
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 3232 "SourceList.c"
		default:
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 3238 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_patch_expandable_item_get_instance_private (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchExpandableItem_private_offset);
}


/**
             * Creates a new {@link Granite.Widgets.SourceListPatch.ExpandableItem}
             *
             * @param name Title of the item.
             * @return (transfer full) A new {@link Granite.Widgets.SourceListPatch.ExpandableItem}.
             * @since 0.2
             */
GraniteWidgetsSourceListPatchExpandableItem*
granite_widgets_source_list_patch_expandable_item_construct (GType object_type,
                                                             const gchar* name)
{
	GraniteWidgetsSourceListPatchExpandableItem * self = NULL;
#line 462 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 463 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchExpandableItem*) granite_widgets_source_list_patch_item_construct (object_type, name);
#line 462 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 3268 "SourceList.c"
}


GraniteWidgetsSourceListPatchExpandableItem*
granite_widgets_source_list_patch_expandable_item_new (const gchar* name)
{
#line 462 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_expandable_item_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, name);
#line 3277 "SourceList.c"
}


/**
             * Checks whether the item contains the specified child.
             *
             * This method only considers the item's immediate children.
             *
             * @param item Item to search.
             * @return Whether the item was found or not.
             * @since 0.2
             */
gboolean
granite_widgets_source_list_patch_expandable_item_contains (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                            GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	GeeCollection* _tmp0_;
#line 479 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 479 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 480 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->children_list;
#line 480 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = gee_collection_contains (_tmp0_, item);
#line 480 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 3306 "SourceList.c"
}


/**
             * Adds an item.
             *
             * {@link Granite.Widgets.SourceListPatch.ExpandableItem.child_added} is fired after the item is added.
             *
             * While adding a child item, //the item it's being added to will set itself as the parent//.
             * Please note that items are required to have their //parent// property set to //null// before
             * being added, so make sure the item is removed from its previous parent before attempting
             * to add it to another item. For instance:
             * {{{
             * if (item.parent != null)
             *     item.parent.remove (item); // this will set item's parent to null
             * new_parent.add (item);
             * }}}
             *
             * @param item The item to add. Its parent __must__ be //null//.
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.child_added
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.remove
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_add (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                       GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GeeCollection* _tmp2_;
#line 503 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 503 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 503 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 503 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 503 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (_tmp1_ == NULL, "item.parent == null");
#line 504 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_set_parent (item, self);
#line 505 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->children_list;
#line 505 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_collection_add (_tmp2_, item);
#line 506 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL], 0, item);
#line 3355 "SourceList.c"
}


/**
             * Removes an item.
             *
             * The {@link Granite.Widgets.SourceListPatch.ExpandableItem.child_removed} signal is fired
             * //after removing the item//. Finally (i.e. after all the handlers have been invoked),
             * the item's {@link Granite.Widgets.SourceListPatch.Item.parent} property is set to //null//.
             * This has the advantage of letting signal handlers know the parent from which //item//
             * is being removed.
             *
             * @param item The item to remove. This will fail if item has a different parent.
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.child_removed
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.clear
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_remove (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                          GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GeeCollection* _tmp2_;
#line 523 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 523 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 523 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 523 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 523 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (_tmp1_ == self, "item.parent == this");
#line 524 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->children_list;
#line 524 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_collection_remove (_tmp2_, item);
#line 525 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL], 0, item);
#line 526 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_set_parent (item, NULL);
#line 3398 "SourceList.c"
}


/**
             * Removes all the items contained by the item. It works similarly to
             * {@link Granite.Widgets.SourceListPatch.ExpandableItem.remove}.
             *
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.remove
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.child_removed
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_clear (GraniteWidgetsSourceListPatchExpandableItem* self)
{
#line 537 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 3415 "SourceList.c"
	{
		GeeIterator* _item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_patch_expandable_item_get_children (self);
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_item_it = _tmp4_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		while (TRUE) {
#line 3439 "SourceList.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListPatchItem* item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = _item_it;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 3451 "SourceList.c"
			}
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = _item_it;
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			item = (GraniteWidgetsSourceListPatchItem*) _tmp7_;
#line 539 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = item;
#line 539 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			granite_widgets_source_list_patch_expandable_item_remove (self, _tmp8_);
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (item);
#line 3465 "SourceList.c"
		}
#line 538 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_item_it);
#line 3469 "SourceList.c"
	}
}


/**
             * Expands the item and/or its children.
             *
             * @param inclusive Whether to also expand this item (true), or only its children (false).
             * @param recursive Whether to recursively expand all the children (true), or only
             * immediate children (false).
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_expand_all (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                              gboolean inclusive,
                                                              gboolean recursive)
{
#line 551 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 552 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expansion (self, inclusive, recursive, TRUE);
#line 3492 "SourceList.c"
}


/**
             * Collapses the item and/or its children.
             *
             * @param inclusive Whether to also collapse this item (true), or only its children (false).
             * @param recursive Whether to recursively collapse all the children (true), or only
             * immediate children (false).
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_collapse_all (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                gboolean inclusive,
                                                                gboolean recursive)
{
#line 564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 565 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expansion (self, inclusive, recursive, FALSE);
#line 3514 "SourceList.c"
}


static void
granite_widgets_source_list_patch_expandable_item_set_expansion (GraniteWidgetsSourceListPatchExpandableItem* item,
                                                                 gboolean inclusive,
                                                                 gboolean recursive,
                                                                 gboolean expanded)
{
#line 568 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 569 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (inclusive) {
#line 570 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_set_expanded (item, expanded);
#line 3530 "SourceList.c"
	}
	{
		GeeIterator* _child_item_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_patch_expandable_item_get_children (item);
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = _tmp1_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = gee_iterable_iterator ((GeeIterable*) _tmp2_);
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_child_item_it = _tmp4_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		while (TRUE) {
#line 3555 "SourceList.c"
			GeeIterator* _tmp5_;
			GraniteWidgetsSourceListPatchItem* child_item = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			GraniteWidgetsSourceListPatchExpandableItem* child_expandable_item = NULL;
			GraniteWidgetsSourceListPatchItem* _tmp8_;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp9_;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp10_;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = _child_item_it;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 3570 "SourceList.c"
			}
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = _child_item_it;
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			child_item = (GraniteWidgetsSourceListPatchItem*) _tmp7_;
#line 573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = child_item;
#line 573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp8_) : NULL);
#line 573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			child_expandable_item = _tmp9_;
#line 574 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = child_expandable_item;
#line 574 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp10_ != NULL) {
#line 575 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (recursive) {
#line 3590 "SourceList.c"
					GraniteWidgetsSourceListPatchExpandableItem* _tmp11_;
#line 576 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp11_ = child_expandable_item;
#line 576 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					granite_widgets_source_list_patch_expandable_item_set_expansion (_tmp11_, TRUE, TRUE, expanded);
#line 3596 "SourceList.c"
				} else {
					GraniteWidgetsSourceListPatchExpandableItem* _tmp12_;
#line 578 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp12_ = child_expandable_item;
#line 578 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					granite_widgets_source_list_patch_expandable_item_set_expanded (_tmp12_, expanded);
#line 3603 "SourceList.c"
				}
			}
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (child_expandable_item);
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (child_item);
#line 3610 "SourceList.c"
		}
#line 572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_child_item_it);
#line 3614 "SourceList.c"
	}
}


/**
             * Recursively expands the item along with its parent(s).
             *
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_expand_with_parents (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
#line 589 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 594 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_item_get_parent ((GraniteWidgetsSourceListPatchItem*) self);
#line 594 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 594 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 3638 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
#line 595 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_item_get_parent ((GraniteWidgetsSourceListPatchItem*) self);
#line 595 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 595 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_expand_with_parents (_tmp3_);
#line 3647 "SourceList.c"
	}
#line 596 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expanded (self, TRUE);
#line 3651 "SourceList.c"
}


/**
             * Recursively collapses the item along with its parent(s).
             *
             * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
             * @since 0.2
             */
void
granite_widgets_source_list_patch_expandable_item_collapse_with_parents (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
#line 605 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 606 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_item_get_parent ((GraniteWidgetsSourceListPatchItem*) self);
#line 606 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 606 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 3674 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
#line 607 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_item_get_parent ((GraniteWidgetsSourceListPatchItem*) self);
#line 607 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 607 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_collapse_with_parents (_tmp3_);
#line 3683 "SourceList.c"
	}
#line 608 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expanded (self, FALSE);
#line 3687 "SourceList.c"
}


gboolean
granite_widgets_source_list_patch_expandable_item_get_collapsible (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_collapsible;
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 3704 "SourceList.c"
}


void
granite_widgets_source_list_patch_expandable_item_set_collapsible (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                   gboolean value)
{
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_expandable_item_get_collapsible (self) != value) {
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_collapsible = value;
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY]);
#line 3720 "SourceList.c"
	}
}


gboolean
granite_widgets_source_list_patch_expandable_item_get_expanded (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->_expanded;
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = TRUE;
#line 3739 "SourceList.c"
	} else {
		gboolean _tmp2_;
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = self->priv->_collapsible;
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = !_tmp2_;
#line 3746 "SourceList.c"
	}
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 416 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 3752 "SourceList.c"
}


void
granite_widgets_source_list_patch_expandable_item_set_expanded (GraniteWidgetsSourceListPatchExpandableItem* self,
                                                                gboolean value)
{
	gboolean _tmp0_;
#line 417 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_expanded;
#line 418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (value != _tmp0_) {
#line 419 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_expanded = value;
#line 420 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_TOGGLED_SIGNAL], 0);
#line 3771 "SourceList.c"
	}
#line 417 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY]);
#line 3775 "SourceList.c"
}


guint
granite_widgets_source_list_patch_expandable_item_get_n_children (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	guint result;
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->children_list;
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = (guint) _tmp2_;
#line 431 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 3798 "SourceList.c"
}


GeeCollection*
granite_widgets_source_list_patch_expandable_item_get_children (GraniteWidgetsSourceListPatchExpandableItem* self)
{
	GeeCollection* result;
	GeeArrayList* children_list_copy = NULL;
	GeeArrayList* _tmp0_;
	GeeCollection* _tmp1_;
#line 444 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	children_list_copy = _tmp0_;
#line 448 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->children_list;
#line 448 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_array_list_add_all (children_list_copy, _tmp1_);
#line 449 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = (GeeCollection*) children_list_copy;
#line 449 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 3823 "SourceList.c"
}


static void
granite_widgets_source_list_patch_expandable_item_real_toggled (GraniteWidgetsSourceListPatchExpandableItem* self)
{
}


static GObject *
granite_widgets_source_list_patch_expandable_item_constructor (GType type,
                                                               guint n_construct_properties,
                                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListPatchExpandableItem * self;
#line 466 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_patch_expandable_item_parent_class);
#line 466 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 466 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItem);
#line 467 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_item_set_editable ((GraniteWidgetsSourceListPatchItem*) self, FALSE);
#line 466 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return obj;
#line 3851 "SourceList.c"
}


static void
granite_widgets_source_list_patch_expandable_item_class_init (GraniteWidgetsSourceListPatchExpandableItemClass * klass)
{
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_parent_class = g_type_class_peek_parent (klass);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchExpandableItem_private_offset);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchExpandableItemClass *) klass)->toggled = granite_widgets_source_list_patch_expandable_item_real_toggled;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_expandable_item_get_property;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_expandable_item_set_property;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_patch_expandable_item_constructor;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_expandable_item_finalize;
#line 3872 "SourceList.c"
	/**
	             * Whether the item is collapsible or not.
	             *
	             * When set to //false//, the item is //always// expanded and the expander is
	             * not shown. Please note that this will also affect the value returned by the
	             * {@link Granite.Widgets.SourceListPatch.ExpandableItem.expanded} property.
	             *
	             * @see Granite.Widgets.SourceListPatch.ExpandableItem.expanded
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY] = g_param_spec_boolean ("collapsible", "collapsible", "collapsible", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY] = g_param_spec_boolean ("expanded", "expanded", "expanded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3887 "SourceList.c"
	/**
	             * Number of children contained by the item.
	             *
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY] = g_param_spec_uint ("n-children", "n-children", "n-children", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3895 "SourceList.c"
	/**
	             * The item's children.
	             *
	             * This returns a newly-created list containing the children.
	             * It's safe to iterate it while removing items with
	             * {@link Granite.Widgets.SourceListPatch.ExpandableItem.remove}
	             *
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILDREN_PROPERTY, granite_widgets_source_list_patch_expandable_item_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILDREN_PROPERTY] = g_param_spec_object ("children", "children", "children", GEE_TYPE_COLLECTION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 3907 "SourceList.c"
	/**
	             * Emitted when an item is added.
	             *
	             * @param item Item added.
	             * @see Granite.Widgets.SourceListPatch.ExpandableItem.add
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_ADDED_SIGNAL] = g_signal_new ("child-added", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 3917 "SourceList.c"
	/**
	             * Emitted when an item is removed.
	             *
	             * @param item Item removed.
	             * @see Granite.Widgets.SourceListPatch.ExpandableItem.remove
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILD_REMOVED_SIGNAL] = g_signal_new ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 3927 "SourceList.c"
	/**
	             * Emitted when the item is expanded or collapsed.
	             *
	             * @since 0.2
	             */
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_TOGGLED_SIGNAL] = g_signal_new ("toggled", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListPatchExpandableItemClass, toggled), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 3935 "SourceList.c"
}


static void
granite_widgets_source_list_patch_expandable_item_instance_init (GraniteWidgetsSourceListPatchExpandableItem * self)
{
	GeeArrayList* _tmp0_;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_expandable_item_get_instance_private (self);
#line 392 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_collapsible = TRUE;
#line 414 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_expanded = FALSE;
#line 453 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gee_array_list_new (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 453 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->children_list = (GeeCollection*) _tmp0_;
#line 3953 "SourceList.c"
}


static void
granite_widgets_source_list_patch_expandable_item_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatchExpandableItem * self;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItem);
#line 453 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->children_list);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_expandable_item_parent_class)->finalize (obj);
#line 3967 "SourceList.c"
}


/**
         * An item that can contain more items.
         *
         * It supports all the properties inherited from {@link Granite.Widgets.SourceListPatch.Item},
         * and behaves like a normal item, except when it is located at the root level; in that case,
         * the following properties are ignored by the widget:
         *
         * * {@link Granite.Widgets.SourceListPatch.Item.selectable}
         * * {@link Granite.Widgets.SourceListPatch.Item.editable}
         * * {@link Granite.Widgets.SourceListPatch.Item.icon}
         * * {@link Granite.Widgets.SourceListPatch.Item.activatable}
         * * {@link Granite.Widgets.SourceListPatch.Item.badge}
         *
         * Root-level expandable items (i.e. Main Categories) are ''not'' displayed when they contain
         * zero visible children.
         *
         * @since 0.2
         */
GType
granite_widgets_source_list_patch_expandable_item_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_expandable_item_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_expandable_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchExpandableItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_expandable_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchExpandableItem), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_expandable_item_instance_init, NULL };
		GType granite_widgets_source_list_patch_expandable_item_type_id;
		granite_widgets_source_list_patch_expandable_item_type_id = g_type_register_static (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, "GraniteWidgetsSourceListPatchExpandableItem", &g_define_type_info, 0);
		GraniteWidgetsSourceListPatchExpandableItem_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_expandable_item_type_id, sizeof (GraniteWidgetsSourceListPatchExpandableItemPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_expandable_item_type_id__volatile, granite_widgets_source_list_patch_expandable_item_type_id);
	}
	return granite_widgets_source_list_patch_expandable_item_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_expandable_item_get_property (GObject * object,
                                                                      guint property_id,
                                                                      GValue * value,
                                                                      GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItem);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_expandable_item_get_collapsible (self));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_expandable_item_get_expanded (self));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_N_CHILDREN_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_uint (value, granite_widgets_source_list_patch_expandable_item_get_n_children (self));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_CHILDREN_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_take_object (value, granite_widgets_source_list_patch_expandable_item_get_children (self));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 4038 "SourceList.c"
		default:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 4044 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_expandable_item_set_property (GObject * object,
                                                                      guint property_id,
                                                                      const GValue * value,
                                                                      GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchExpandableItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, GraniteWidgetsSourceListPatchExpandableItem);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_COLLAPSIBLE_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_set_collapsible (self, g_value_get_boolean (value));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EXPANDABLE_ITEM_EXPANDED_PROPERTY:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_set_expanded (self, g_value_get_boolean (value));
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 4071 "SourceList.c"
		default:
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 4077 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_patch_data_model_get_instance_private (GraniteWidgetsSourceListPatchDataModel* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchDataModel_private_offset);
}


static GType
granite_widgets_source_list_patch_data_model_column_type (GraniteWidgetsSourceListPatchDataModelColumn self)
{
	GType result = 0UL;
#line 704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (self) {
#line 704 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM:
#line 4097 "SourceList.c"
		{
#line 706 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM;
#line 706 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 4103 "SourceList.c"
		}
		default:
		{
#line 709 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_assert_not_reached ();
#line 4109 "SourceList.c"
		}
	}
}


static GType
granite_widgets_source_list_patch_data_model_column_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_data_model_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_data_model_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_N_COLUMNS, "GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_N_COLUMNS", "n-columns"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_patch_data_model_column_type_id;
		granite_widgets_source_list_patch_data_model_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListPatchDataModelColumn", values);
		g_once_init_leave (&granite_widgets_source_list_patch_data_model_column_type_id__volatile, granite_widgets_source_list_patch_data_model_column_type_id);
	}
	return granite_widgets_source_list_patch_data_model_column_type_id__volatile;
}


static GraniteWidgetsSourceListPatchDataModel*
granite_widgets_source_list_patch_data_model_construct (GType object_type)
{
	GraniteWidgetsSourceListPatchDataModel * self = NULL;
#line 756 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModel*) g_object_new (object_type, NULL);
#line 756 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 4137 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModel*
granite_widgets_source_list_patch_data_model_new (void)
{
#line 756 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_data_model_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL);
#line 4146 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_has_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                       GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
#line 771 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 771 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 772 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 772 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, item);
#line 772 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 4166 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_update_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                          GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* node_reference = NULL;
	GeeHashMap* _tmp2_;
	gpointer _tmp3_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp4_;
#line 775 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 775 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 775 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (granite_widgets_source_list_patch_data_model_has_item (self, item), "has_item (item)");
#line 776 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_root (self);
#line 776 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 776 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->items;
#line 781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, item);
#line 781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	node_reference = (GraniteWidgetsSourceListPatchDataModelNodeWrapper*) _tmp3_;
#line 782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = node_reference;
#line 782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 4202 "SourceList.c"
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreePath* _tmp7_;
		GtkTreeIter* iter = NULL;
		GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp8_;
		GtkTreeIter* _tmp9_;
		GtkTreeIter* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GtkTreePath* _tmp12_;
#line 783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = node_reference;
#line 783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_path (_tmp5_);
#line 783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = _tmp6_;
#line 783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp7_;
#line 784 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = node_reference;
#line 784 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_iter (_tmp8_);
#line 784 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = _tmp9_;
#line 784 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		iter = _tmp10_;
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = path;
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp12_ != NULL) {
#line 4233 "SourceList.c"
			GtkTreeIter* _tmp13_;
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = iter;
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 4239 "SourceList.c"
		} else {
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = FALSE;
#line 4243 "SourceList.c"
		}
#line 785 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp11_) {
#line 4247 "SourceList.c"
			GtkTreeStore* _tmp14_;
			GtkTreePath* _tmp15_;
			GtkTreeIter* _tmp16_;
			GtkTreeIter _tmp17_;
#line 786 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = self->priv->child_tree;
#line 786 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp15_ = path;
#line 786 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = iter;
#line 786 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = *_tmp16_;
#line 786 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_model_row_changed ((GtkTreeModel*) _tmp14_, _tmp15_, &_tmp17_);
#line 787 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_signal_emit (self, granite_widgets_source_list_patch_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, item);
#line 4264 "SourceList.c"
		}
#line 782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (iter);
#line 782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 4270 "SourceList.c"
	}
#line 775 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_node_wrapper_unref0 (node_reference);
#line 4274 "SourceList.c"
}


static GtkTreeIter*
_gtk_tree_iter_dup (GtkTreeIter* self)
{
	GtkTreeIter* dup;
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	dup = g_new0 (GtkTreeIter, 1);
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	memcpy (dup, self, sizeof (GtkTreeIter));
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return dup;
#line 4288 "SourceList.c"
}


static gpointer
__gtk_tree_iter_dup0 (gpointer self)
{
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self ? _gtk_tree_iter_dup (self) : NULL;
#line 4297 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_add_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                       GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GtkTreeIter* parent_child_iter = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListPatchExpandableItem* parent = NULL;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp4_;
	gboolean _tmp5_ = FALSE;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp6_;
	GtkTreeStore* _tmp15_;
	GtkTreeIter* _tmp16_;
	GtkTreeIter _tmp17_ = {0};
	GtkTreeIter _tmp18_;
	GtkTreeIter* _tmp19_;
	GtkTreeStore* _tmp20_;
	GtkTreeIter* _tmp21_;
	GtkTreeIter _tmp22_;
	GeeHashMap* _tmp23_;
	GtkTreeStore* _tmp24_;
	GtkTreeIter* _tmp25_;
	GtkTreeIter _tmp26_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp27_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp28_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp29_;
	GraniteWidgetsSourceListPatchExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp30_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp31_;
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (!granite_widgets_source_list_patch_data_model_has_item (self, item), "!has_item (item)");
#line 793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_root (self);
#line 793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 796 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_child_iter = NULL;
#line 797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent = _tmp4_;
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = parent;
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp6_ != NULL) {
#line 4359 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp7_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp8_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp9_;
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = parent;
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = granite_widgets_source_list_patch_data_model_get_root (self);
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = _tmp8_;
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp7_ != _tmp9_;
#line 4371 "SourceList.c"
	} else {
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = FALSE;
#line 4375 "SourceList.c"
	}
#line 799 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_) {
#line 4379 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp10_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp12_;
		GtkTreeIter* _tmp13_;
		GtkTreeIter* _tmp14_;
#line 801 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = parent;
#line 801 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (!granite_widgets_source_list_patch_data_model_has_item (self, (GraniteWidgetsSourceListPatchItem*) _tmp10_)) {
#line 4388 "SourceList.c"
			GraniteWidgetsSourceListPatchExpandableItem* _tmp11_;
#line 802 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = parent;
#line 802 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			granite_widgets_source_list_patch_data_model_add_item (self, (GraniteWidgetsSourceListPatchItem*) _tmp11_);
#line 4394 "SourceList.c"
		}
#line 805 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = parent;
#line 805 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = granite_widgets_source_list_patch_data_model_get_item_child_iter (self, (GraniteWidgetsSourceListPatchItem*) _tmp12_);
#line 805 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (parent_child_iter);
#line 805 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		parent_child_iter = _tmp13_;
#line 808 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = parent_child_iter;
#line 808 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_vala_assert (_tmp14_ != NULL, "parent_child_iter != null");
#line 4408 "SourceList.c"
	}
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp15_ = self->priv->child_tree;
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp16_ = parent_child_iter;
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_store_append (_tmp15_, &_tmp17_, _tmp16_);
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (child_iter);
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp18_ = _tmp17_;
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp19_ = __gtk_tree_iter_dup0 (&_tmp18_);
#line 811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_iter = _tmp19_;
#line 812 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp20_ = self->priv->child_tree;
#line 812 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp21_ = child_iter;
#line 812 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp22_ = *_tmp21_;
#line 812 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_store_set (_tmp20_, &_tmp22_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, item, -1, -1);
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp23_ = self->priv->items;
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp24_ = self->priv->child_tree;
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp25_ = child_iter;
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp26_ = *_tmp25_;
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp27_ = granite_widgets_source_list_patch_data_model_node_wrapper_new ((GtkTreeModel*) _tmp24_, &_tmp26_);
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp28_ = _tmp27_;
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp23_, item, _tmp28_);
#line 814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_node_wrapper_unref0 (_tmp28_);
#line 818 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_UPDATED_SIGNAL], 0, item);
#line 820 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_add_property_monitor (self, item);
#line 822 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp29_ = parent;
#line 822 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_push_parent_update (self, _tmp29_);
#line 825 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp30_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) item) : NULL);
#line 825 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	expandable = _tmp30_;
#line 826 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp31_ = expandable;
#line 826 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp31_ != NULL) {
#line 4464 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp42_;
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp32_;
			GeeCollection* _tmp33_;
			GeeCollection* _tmp34_;
			GeeCollection* _tmp35_;
			GeeIterator* _tmp36_;
			GeeIterator* _tmp37_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp32_ = expandable;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp33_ = granite_widgets_source_list_patch_expandable_item_get_children (_tmp32_);
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp34_ = _tmp33_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp35_ = _tmp34_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp36_ = gee_iterable_iterator ((GeeIterable*) _tmp35_);
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp37_ = _tmp36_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_tmp35_);
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_child_item_it = _tmp37_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			while (TRUE) {
#line 4492 "SourceList.c"
				GeeIterator* _tmp38_;
				GraniteWidgetsSourceListPatchItem* child_item = NULL;
				GeeIterator* _tmp39_;
				gpointer _tmp40_;
				GraniteWidgetsSourceListPatchItem* _tmp41_;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp38_ = _child_item_it;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (!gee_iterator_next (_tmp38_)) {
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					break;
#line 4504 "SourceList.c"
				}
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp39_ = _child_item_it;
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp40_ = gee_iterator_get (_tmp39_);
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				child_item = (GraniteWidgetsSourceListPatchItem*) _tmp40_;
#line 828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp41_ = child_item;
#line 828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_data_model_add_item (self, _tmp41_);
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (child_item);
#line 4518 "SourceList.c"
			}
#line 827 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_child_item_it);
#line 4522 "SourceList.c"
		}
#line 831 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp42_ = expandable;
#line 831 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_add_children_monitor (self, _tmp42_);
#line 4528 "SourceList.c"
	}
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (expandable);
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (parent);
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (child_iter);
#line 792 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (parent_child_iter);
#line 4538 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_remove_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                          GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
	GtkTreeIter* child_iter = NULL;
	GtkTreeIter* _tmp2_;
	GeeHashMap* _tmp3_;
	GtkTreeIter* _tmp4_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp6_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp7_;
	GraniteWidgetsSourceListPatchExpandableItem* expandable = NULL;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp8_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp9_;
#line 835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (granite_widgets_source_list_patch_data_model_has_item (self, item), "has_item (item)");
#line 836 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_root (self);
#line 836 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 836 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "root != null");
#line 838 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_remove_property_monitor (self, item);
#line 843 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_data_model_get_item_child_iter (self, item);
#line 843 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_iter = _tmp2_;
#line 849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = self->priv->items;
#line 849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp3_, item, NULL);
#line 851 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = child_iter;
#line 851 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 4583 "SourceList.c"
		GtkTreeStore* _tmp5_;
#line 852 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = self->priv->child_tree;
#line 852 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_store_remove (_tmp5_, child_iter);
#line 4589 "SourceList.c"
	}
#line 854 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = granite_widgets_source_list_patch_item_get_parent (item);
#line 854 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = _tmp6_;
#line 854 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_push_parent_update (self, _tmp7_);
#line 857 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) item) : NULL);
#line 857 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	expandable = _tmp8_;
#line 858 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = expandable;
#line 858 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp9_ != NULL) {
#line 4605 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp10_;
#line 860 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = expandable;
#line 860 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_remove_children_monitor (self, _tmp10_);
#line 4611 "SourceList.c"
		{
			GeeIterator* _child_item_it = NULL;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp11_;
			GeeCollection* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
			GeeIterator* _tmp15_;
			GeeIterator* _tmp16_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = expandable;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = granite_widgets_source_list_patch_expandable_item_get_children (_tmp11_);
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = _tmp12_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = _tmp13_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp15_ = gee_iterable_iterator ((GeeIterable*) _tmp14_);
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = _tmp15_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_tmp14_);
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_child_item_it = _tmp16_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			while (TRUE) {
#line 4638 "SourceList.c"
				GeeIterator* _tmp17_;
				GraniteWidgetsSourceListPatchItem* child_item = NULL;
				GeeIterator* _tmp18_;
				gpointer _tmp19_;
				GraniteWidgetsSourceListPatchItem* _tmp20_;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp17_ = _child_item_it;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (!gee_iterator_next (_tmp17_)) {
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					break;
#line 4650 "SourceList.c"
				}
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp18_ = _child_item_it;
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp19_ = gee_iterator_get (_tmp18_);
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				child_item = (GraniteWidgetsSourceListPatchItem*) _tmp19_;
#line 863 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp20_ = child_item;
#line 863 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_data_model_remove_item (self, _tmp20_);
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (child_item);
#line 4664 "SourceList.c"
			}
#line 862 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_child_item_it);
#line 4668 "SourceList.c"
		}
	}
#line 835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (expandable);
#line 835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (child_iter);
#line 4675 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_data_model_on_item_prop_changed_granite_widgets_source_list_patch_data_model_item_monitor_changed (GraniteWidgetsSourceListPatchDataModelItemMonitor* _sender,
                                                                                                                                      GraniteWidgetsSourceListPatchItem* _self_,
                                                                                                                                      const gchar* prop_name,
                                                                                                                                      gpointer self)
{
#line 870 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_on_item_prop_changed ((GraniteWidgetsSourceListPatchDataModel*) self, _self_, prop_name);
#line 4687 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_add_property_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                   GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor* wrapper = NULL;
	GraniteWidgetsSourceListPatchDataModelItemMonitor* _tmp0_;
	GeeHashMap* _tmp1_;
#line 867 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 867 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 868 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_item_monitor_new (item);
#line 868 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	wrapper = _tmp0_;
#line 869 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->monitors;
#line 869 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, item, wrapper);
#line 870 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (wrapper, "changed", (GCallback) _granite_widgets_source_list_patch_data_model_on_item_prop_changed_granite_widgets_source_list_patch_data_model_item_monitor_changed, self, 0);
#line 867 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_item_monitor_unref0 (wrapper);
#line 4714 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_remove_property_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                      GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor* wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListPatchDataModelItemMonitor* _tmp2_;
	GeeHashMap* _tmp5_;
#line 873 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 873 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 874 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->monitors;
#line 874 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 874 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	wrapper = (GraniteWidgetsSourceListPatchDataModelItemMonitor*) _tmp1_;
#line 875 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = wrapper;
#line 875 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 4741 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModelItemMonitor* _tmp3_;
		guint _tmp4_;
#line 876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = wrapper;
#line 876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_parse_name ("changed", GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, &_tmp4_, NULL, FALSE);
#line 876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_data_model_on_item_prop_changed_granite_widgets_source_list_patch_data_model_item_monitor_changed, self);
#line 4750 "SourceList.c"
	}
#line 877 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = self->priv->monitors;
#line 877 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_abstract_map_unset ((GeeAbstractMap*) _tmp5_, item, NULL);
#line 873 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_item_monitor_unref0 (wrapper);
#line 4758 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_data_model_on_item_child_added_granite_widgets_source_list_patch_expandable_item_child_added (GraniteWidgetsSourceListPatchExpandableItem* _sender,
                                                                                                                                 GraniteWidgetsSourceListPatchItem* item,
                                                                                                                                 gpointer self)
{
#line 881 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_on_item_child_added ((GraniteWidgetsSourceListPatchDataModel*) self, item);
#line 4769 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_data_model_on_item_child_removed_granite_widgets_source_list_patch_expandable_item_child_removed (GraniteWidgetsSourceListPatchExpandableItem* _sender,
                                                                                                                                     GraniteWidgetsSourceListPatchItem* item,
                                                                                                                                     gpointer self)
{
#line 882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_on_item_child_removed ((GraniteWidgetsSourceListPatchDataModel*) self, item);
#line 4780 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_add_children_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                   GraniteWidgetsSourceListPatchExpandableItem* item)
{
#line 880 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 880 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 881 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (item, "child-added", (GCallback) _granite_widgets_source_list_patch_data_model_on_item_child_added_granite_widgets_source_list_patch_expandable_item_child_added, self, G_CONNECT_AFTER);
#line 882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (item, "child-removed", (GCallback) _granite_widgets_source_list_patch_data_model_on_item_child_removed_granite_widgets_source_list_patch_expandable_item_child_removed, self, G_CONNECT_AFTER);
#line 4796 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_remove_children_monitor (GraniteWidgetsSourceListPatchDataModel* self,
                                                                      GraniteWidgetsSourceListPatchExpandableItem* item)
{
	guint _tmp0_;
	guint _tmp1_;
#line 885 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 885 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 886 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_parse_name ("child-added", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, &_tmp0_, NULL, FALSE);
#line 886 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_disconnect_matched (item, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_data_model_on_item_child_added_granite_widgets_source_list_patch_expandable_item_child_added, self);
#line 887 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_parse_name ("child-removed", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, &_tmp1_, NULL, FALSE);
#line 887 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_disconnect_matched (item, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_data_model_on_item_child_removed_granite_widgets_source_list_patch_expandable_item_child_removed, self);
#line 4818 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_on_item_child_added (GraniteWidgetsSourceListPatchDataModel* self,
                                                                  GraniteWidgetsSourceListPatchItem* item)
{
#line 890 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 890 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 891 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_add_item (self, item);
#line 4832 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_on_item_child_removed (GraniteWidgetsSourceListPatchDataModel* self,
                                                                    GraniteWidgetsSourceListPatchItem* item)
{
#line 894 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 894 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 895 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_remove_item (self, item);
#line 4846 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_on_item_prop_changed (GraniteWidgetsSourceListPatchDataModel* self,
                                                                   GraniteWidgetsSourceListPatchItem* item,
                                                                   const gchar* prop_name)
{
#line 898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (prop_name != NULL);
#line 899 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_strcmp0 (prop_name, "parent") != 0) {
#line 900 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_update_item (self, item);
#line 4865 "SourceList.c"
	}
}


/**
             * Pushes a call to update_item() if //parent// is not //null//.
             *
             * This is needed because the visibility of categories depends on their n_children property,
             * and also because item expansion should be updated after adding or removing items.
             * If many updates are pushed, and the item has still not been updated, only one is processed.
             * This guarantees efficiency as updating a category item could trigger expensive actions.
             */
static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return _data1_;
#line 4885 "SourceList.c"
}


static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 4896 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModel* self;
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self = _data1_->self;
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_data1_->parent);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_slice_free (Block1Data, _data1_);
#line 4906 "SourceList.c"
	}
}


static gboolean
___lambda20_ (Block1Data* _data1_)
{
	GraniteWidgetsSourceListPatchDataModel* self;
	gboolean result = FALSE;
#line 928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = _data1_->self;
#line 929 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_data1_->parent != NULL) {
#line 930 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_update_item (self, (GraniteWidgetsSourceListPatchItem*) _data1_->parent);
#line 933 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set_data_full ((GObject*) _data1_->parent, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) FALSE), NULL);
#line 4924 "SourceList.c"
	}
#line 936 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 936 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 4930 "SourceList.c"
}


static gboolean
____lambda20__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda20_ (self);
#line 928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 4941 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_push_parent_update (GraniteWidgetsSourceListPatchDataModel* self,
                                                                 GraniteWidgetsSourceListPatchExpandableItem* parent)
{
	Block1Data* _data1_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	gboolean needs_update = FALSE;
	gconstpointer _tmp1_;
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_data1_->_ref_count_ = 1;
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_data1_->self = g_object_ref (self);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (_data1_->parent);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_data1_->parent = _tmp0_;
#line 912 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_data1_->parent == NULL) {
#line 913 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		block1_data_unref (_data1_);
#line 913 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_data1_ = NULL;
#line 913 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return;
#line 4979 "SourceList.c"
	}
#line 915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = g_object_get_data ((GObject*) _data1_->parent, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE);
#line 915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	needs_update = (gboolean) ((gintptr) _tmp1_);
#line 919 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = needs_update;
#line 919 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_) {
#line 920 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		block1_data_unref (_data1_);
#line 920 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_data1_ = NULL;
#line 920 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return;
#line 4995 "SourceList.c"
	}
#line 922 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_patch_data_model_get_item_path (self, (GraniteWidgetsSourceListPatchItem*) _data1_->parent);
#line 922 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp3_;
#line 924 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = path;
#line 924 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 926 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set_data_full ((GObject*) _data1_->parent, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_PARENT_NEEDS_UPDATE, (gpointer) ((gintptr) TRUE), NULL);
#line 928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda20__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 5009 "SourceList.c"
	}
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	block1_data_unref (_data1_);
#line 911 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_data1_ = NULL;
#line 5017 "SourceList.c"
}


/**
             * Returns the Item pointed by iter, or null if the iter doesn't refer to a valid item.
             */
static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_data_model_get_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                       GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeIter _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_ = NULL;
#line 944 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 944 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = *iter;
#line 946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) self, &_tmp0_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp1_, -1, -1);
#line 946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp1_;
#line 947 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = item;
#line 947 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5048 "SourceList.c"
}


/**
             * Returns the Item pointed by path, or null if the path doesn't refer to a valid item.
             */
static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_data_model_get_item_from_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                                 GtkTreePath* path)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GtkTreeIter iter = {0};
	GtkTreeIter _tmp0_ = {0};
	gboolean _tmp1_;
#line 953 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 953 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 955 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_iter ((GtkTreeModel*) self, &_tmp0_, path);
#line 955 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iter = _tmp0_;
#line 955 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 5073 "SourceList.c"
		GtkTreeIter _tmp2_;
		GraniteWidgetsSourceListPatchItem* _tmp3_;
#line 956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = iter;
#line 956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_patch_data_model_get_item (self, &_tmp2_);
#line 956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = _tmp3_;
#line 956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 5084 "SourceList.c"
	}
#line 958 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 958 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5090 "SourceList.c"
}


/**
             * Returns a newly-created path pointing to the item, or null in case a valid path
             * is not found.
             */
static GtkTreePath*
granite_widgets_source_list_patch_data_model_get_item_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                            GraniteWidgetsSourceListPatchItem* item)
{
	GtkTreePath* result = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* child_path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
#line 965 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 965 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 966 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = NULL;
#line 966 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_item_child_path (self, item);
#line 966 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_path = _tmp0_;
#line 969 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = child_path;
#line 969 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 5121 "SourceList.c"
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
#line 970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = child_path;
#line 970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp2_);
#line 970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp3_;
#line 5132 "SourceList.c"
	}
#line 972 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = path;
#line 972 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (child_path);
#line 972 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5140 "SourceList.c"
}


/**
             * Returns a newly-created iterator pointing to the item, or null in case a valid iter
             * was not found.
             */
static GtkTreeIter*
granite_widgets_source_list_patch_data_model_get_item_iter (GraniteWidgetsSourceListPatchDataModel* self,
                                                            GraniteWidgetsSourceListPatchItem* item)
{
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GtkTreeIter* _tmp0_;
	GtkTreeIter* _tmp1_;
#line 979 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 979 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 980 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_item_child_iter (self, item);
#line 980 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_iter = _tmp0_;
#line 982 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = child_iter;
#line 982 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 5168 "SourceList.c"
		GtkTreeIter iter = {0};
		GtkTreeIter* _tmp2_;
		GtkTreeIter _tmp3_ = {0};
		GtkTreeIter _tmp4_;
		gboolean _tmp5_;
#line 984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = child_iter;
#line 984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = *_tmp2_;
#line 984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = gtk_tree_model_filter_convert_child_iter_to_iter ((GtkTreeModelFilter*) self, &_tmp3_, &_tmp4_);
#line 984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		iter = _tmp3_;
#line 984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 5184 "SourceList.c"
			GtkTreeIter* _tmp6_;
#line 985 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = __gtk_tree_iter_dup0 (&iter);
#line 985 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = _tmp6_;
#line 985 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (child_iter);
#line 985 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 5194 "SourceList.c"
		}
	}
#line 988 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = NULL;
#line 988 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (child_iter);
#line 988 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5203 "SourceList.c"
}


/**
             * External "extra" filter method.
             */
static void
granite_widgets_source_list_patch_data_model_set_filter_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                              GraniteWidgetsSourceListPatchVisibleFunc visible_func,
                                                              gpointer visible_func_target)
{
#line 994 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 995 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->filter_func = visible_func;
#line 995 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->filter_func_target = visible_func_target;
#line 5221 "SourceList.c"
}


/**
             * Checks whether an item is a category (i.e. a root-level expandable item).
             * The caller must pass an iter or path pointing to the item, but not both
             * (one of them must be null.)
             *
             * TODO: instead of checking the position of the iter or path, we should simply
             * check whether the item's parent is the root item and whether the item is
             * expandable. We don't do so right now because vala still allows client code
             * to access the Item.parent property, even though its setter is defined as internal.
             */
static gboolean
granite_widgets_source_list_patch_data_model_is_category (GraniteWidgetsSourceListPatchDataModel* self,
                                                          GraniteWidgetsSourceListPatchItem* item,
                                                          GtkTreeIter* iter,
                                                          GtkTreePath* path)
{
	gboolean result = FALSE;
	gboolean is_category = FALSE;
#line 1008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1009 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	is_category = FALSE;
#line 1012 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (iter != NULL) {
#line 5251 "SourceList.c"
		GtkTreeIter _tmp0_;
#line 1013 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_vala_assert (path == NULL, "path == null");
#line 1014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = *iter;
#line 1014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		is_category = granite_widgets_source_list_patch_data_model_is_iter_at_root_level (self, &_tmp0_);
#line 5259 "SourceList.c"
	} else {
#line 1016 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_vala_assert (iter == NULL, "iter == null");
#line 1017 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		is_category = granite_widgets_source_list_patch_data_model_is_path_at_root_level (self, path);
#line 5265 "SourceList.c"
	}
#line 1020 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = is_category;
#line 1020 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5271 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_is_iter_at_root_level (GraniteWidgetsSourceListPatchDataModel* self,
                                                                    GtkTreeIter* iter)
{
	gboolean result = FALSE;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	gboolean _tmp3_;
#line 1023 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1023 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = *iter;
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_path ((GtkTreeModel*) self, &_tmp0_);
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_patch_data_model_is_path_at_root_level (self, _tmp2_);
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp3_;
#line 1024 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5302 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_is_path_at_root_level (GraniteWidgetsSourceListPatchDataModel* self,
                                                                    GtkTreePath* path)
{
	gboolean result = FALSE;
#line 1027 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1027 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1028 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = gtk_tree_path_get_depth (path) == 1;
#line 1028 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5319 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_resort (GraniteWidgetsSourceListPatchDataModel* self)
{
	GtkTreeStore* _tmp0_;
	GtkTreeStore* _tmp1_;
#line 1031 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1032 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1032 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp0_, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
#line 1033 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->child_tree;
#line 1033 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp1_, GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID, GTK_SORT_ASCENDING);
#line 5338 "SourceList.c"
}


static gint
granite_widgets_source_list_patch_data_model_child_model_sort_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                                    GtkTreeModel* model,
                                                                    GtkTreeIter* a,
                                                                    GtkTreeIter* b)
{
	gint result = 0;
	gint order = 0;
	GraniteWidgetsSourceListPatchItem* item_a = NULL;
	GraniteWidgetsSourceListPatchItem* item_b = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_ = NULL;
	GtkTreeStore* _tmp3_;
	GtkTreeIter _tmp4_;
	GraniteWidgetsSourceListPatchItem* _tmp5_ = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp6_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp7_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp8_;
	GraniteWidgetsSourceListPatchItem* _tmp9_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp10_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp11_;
	GraniteWidgetsSourceListPatchSortable* parent = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp12_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp13_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp14_;
	GraniteWidgetsSourceListPatchSortable* _tmp15_;
	GraniteWidgetsSourceListPatchSortable* _tmp16_;
#line 1036 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1036 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (model != NULL, 0);
#line 1036 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 1036 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 1037 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	order = 0;
#line 1040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *a;
#line 1040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item_a);
#line 1040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item_a = _tmp2_;
#line 1041 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = self->priv->child_tree;
#line 1041 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = *b;
#line 1041 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp5_, -1, -1);
#line 1041 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item_b);
#line 1041 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item_b = _tmp5_;
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = item_a;
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = granite_widgets_source_list_patch_item_get_parent (_tmp6_);
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = _tmp7_;
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = item_b;
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = granite_widgets_source_list_patch_item_get_parent (_tmp9_);
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp11_ = _tmp10_;
#line 1044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp8_ == _tmp11_, "item_a.parent == item_b.parent");
#line 1046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = item_a;
#line 1046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp13_ = granite_widgets_source_list_patch_item_get_parent (_tmp12_);
#line 1046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp14_ = _tmp13_;
#line 1046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE) ? ((GraniteWidgetsSourceListPatchSortable*) _tmp14_) : NULL);
#line 1046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent = _tmp15_;
#line 1047 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp16_ = parent;
#line 1047 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp16_ != NULL) {
#line 5428 "SourceList.c"
		GraniteWidgetsSourceListPatchSortable* _tmp17_;
		GraniteWidgetsSourceListPatchItem* _tmp18_;
		GraniteWidgetsSourceListPatchItem* _tmp19_;
#line 1048 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = parent;
#line 1048 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = item_a;
#line 1048 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = item_b;
#line 1048 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		order = granite_widgets_source_list_patch_sortable_compare (_tmp17_, _tmp18_, _tmp19_);
#line 5440 "SourceList.c"
	}
#line 1050 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = order;
#line 1050 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (parent);
#line 1050 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item_b);
#line 1050 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item_a);
#line 1050 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5452 "SourceList.c"
}


static GtkTreeIter*
granite_widgets_source_list_patch_data_model_get_item_child_iter (GraniteWidgetsSourceListPatchDataModel* self,
                                                                  GraniteWidgetsSourceListPatchItem* item)
{
	GtkTreeIter* result = NULL;
	GtkTreeIter* child_iter = NULL;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp2_;
#line 1053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1054 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_iter = NULL;
#line 1056 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 1056 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 1056 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_node_wrapper = (GraniteWidgetsSourceListPatchDataModelNodeWrapper*) _tmp1_;
#line 1057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = child_node_wrapper;
#line 1057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 5482 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp3_;
		GtkTreeIter* _tmp4_;
		GtkTreeIter* _tmp5_;
#line 1058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = child_node_wrapper;
#line 1058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_iter (_tmp3_);
#line 1058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (child_iter);
#line 1058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		child_iter = _tmp5_;
#line 5496 "SourceList.c"
	}
#line 1060 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = child_iter;
#line 1060 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_node_wrapper_unref0 (child_node_wrapper);
#line 1060 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5504 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_patch_data_model_get_item_child_path (GraniteWidgetsSourceListPatchDataModel* self,
                                                                  GraniteWidgetsSourceListPatchItem* item)
{
	GtkTreePath* result = NULL;
	GtkTreePath* child_path = NULL;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* child_node_wrapper = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp2_;
#line 1063 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1063 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 1064 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_path = NULL;
#line 1066 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->items;
#line 1066 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, item);
#line 1066 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_node_wrapper = (GraniteWidgetsSourceListPatchDataModelNodeWrapper*) _tmp1_;
#line 1067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = child_node_wrapper;
#line 1067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 5534 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp3_;
		GtkTreePath* _tmp4_;
		GtkTreePath* _tmp5_;
#line 1068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = child_node_wrapper;
#line 1068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_path (_tmp3_);
#line 1068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_path);
#line 1068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		child_path = _tmp5_;
#line 5548 "SourceList.c"
	}
#line 1070 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = child_path;
#line 1070 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_node_wrapper_unref0 (child_node_wrapper);
#line 1070 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5556 "SourceList.c"
}


/**
             * Filters the child-tree items based on their "visible" property.
             */
static gboolean
granite_widgets_source_list_patch_data_model_filter_visible_func (GraniteWidgetsSourceListPatchDataModel* self,
                                                                  GtkTreeModel* child_model,
                                                                  GtkTreeIter* iter)
{
	gboolean result = FALSE;
	gboolean item_visible = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_ = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp3_;
	GraniteWidgetsSourceListPatchVisibleFunc _tmp28_;
	void* _tmp28__target;
#line 1076 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1076 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (child_model != NULL, FALSE);
#line 1076 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 1077 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item_visible = FALSE;
#line 1080 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1080 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *iter;
#line 1080 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1080 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 1080 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp2_;
#line 1082 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = item;
#line 1082 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 5599 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		GraniteWidgetsSourceListPatchExpandableItem* expandable = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp7_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp8_;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_ = FALSE;
		GraniteWidgetsSourceListPatchItem* _tmp11_;
		gboolean _tmp12_;
#line 1083 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = item;
#line 1083 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = granite_widgets_source_list_patch_item_get_visible (_tmp4_);
#line 1083 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = _tmp5_;
#line 1083 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item_visible = _tmp6_;
#line 1087 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = item;
#line 1087 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp7_) : NULL);
#line 1087 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		expandable = _tmp8_;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp11_ = item;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = _tmp11_->force_visible;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (!_tmp12_) {
#line 5630 "SourceList.c"
			GraniteWidgetsSourceListPatchExpandableItem* _tmp13_;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = expandable;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = _tmp13_ != NULL;
#line 5636 "SourceList.c"
		} else {
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = FALSE;
#line 5640 "SourceList.c"
		}
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp10_) {
#line 5644 "SourceList.c"
			GtkTreeStore* _tmp14_;
			GtkTreeIter _tmp15_;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = self->priv->child_tree;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp15_ = *iter;
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = gtk_tree_store_iter_depth (_tmp14_, &_tmp15_) == 0;
#line 5653 "SourceList.c"
		} else {
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = FALSE;
#line 5657 "SourceList.c"
		}
#line 1088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp9_) {
#line 1089 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			item_visible = FALSE;
#line 5663 "SourceList.c"
			{
				GeeIterator* _child_item_it = NULL;
				GraniteWidgetsSourceListPatchExpandableItem* _tmp16_;
				GeeCollection* _tmp17_;
				GeeCollection* _tmp18_;
				GeeCollection* _tmp19_;
				GeeIterator* _tmp20_;
				GeeIterator* _tmp21_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp16_ = expandable;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp17_ = granite_widgets_source_list_patch_expandable_item_get_children (_tmp16_);
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp18_ = _tmp17_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp19_ = _tmp18_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp20_ = gee_iterable_iterator ((GeeIterable*) _tmp19_);
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp21_ = _tmp20_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_tmp19_);
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_child_item_it = _tmp21_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				while (TRUE) {
#line 5690 "SourceList.c"
					GeeIterator* _tmp22_;
					GraniteWidgetsSourceListPatchItem* child_item = NULL;
					GeeIterator* _tmp23_;
					gpointer _tmp24_;
					GraniteWidgetsSourceListPatchItem* _tmp25_;
					gboolean _tmp26_;
					gboolean _tmp27_;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp22_ = _child_item_it;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (!gee_iterator_next (_tmp22_)) {
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						break;
#line 5704 "SourceList.c"
					}
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp23_ = _child_item_it;
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp24_ = gee_iterator_get (_tmp23_);
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					child_item = (GraniteWidgetsSourceListPatchItem*) _tmp24_;
#line 1091 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp25_ = child_item;
#line 1091 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp26_ = granite_widgets_source_list_patch_item_get_visible (_tmp25_);
#line 1091 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp27_ = _tmp26_;
#line 1091 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp27_) {
#line 1092 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						item_visible = TRUE;
#line 1093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_g_object_unref0 (child_item);
#line 1093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						break;
#line 5726 "SourceList.c"
					}
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_g_object_unref0 (child_item);
#line 5730 "SourceList.c"
				}
#line 1090 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_child_item_it);
#line 5734 "SourceList.c"
			}
		}
#line 1082 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (expandable);
#line 5739 "SourceList.c"
	}
#line 1099 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp28_ = self->priv->filter_func;
#line 1099 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp28__target = self->priv->filter_func_target;
#line 1099 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp28_ != NULL) {
#line 5747 "SourceList.c"
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp30_ = item_visible;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp30_) {
#line 5754 "SourceList.c"
			GraniteWidgetsSourceListPatchVisibleFunc _tmp31_;
			void* _tmp31__target;
			GraniteWidgetsSourceListPatchItem* _tmp32_;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp31_ = self->priv->filter_func;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp31__target = self->priv->filter_func_target;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp32_ = item;
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp29_ = _tmp31_ (_tmp32_, _tmp31__target);
#line 5766 "SourceList.c"
		} else {
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp29_ = FALSE;
#line 5770 "SourceList.c"
		}
#line 1100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item_visible = _tmp29_;
#line 5774 "SourceList.c"
	}
#line 1102 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = item_visible;
#line 1102 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 1102 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5782 "SourceList.c"
}


/**
             * TreeDragDest implementation
             */
static gboolean
granite_widgets_source_list_patch_data_model_real_drag_data_received (GtkTreeDragDest* base,
                                                                      GtkTreePath* dest,
                                                                      GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreePath* _tmp2_ = NULL;
	gboolean _tmp3_;
	GtkTreeModel* _tmp4_;
#line 1109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModel*) base;
#line 1109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gtk_tree_get_row_drag_data (selection_data, &_tmp1_, &_tmp2_);
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (model);
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	model = _tmp4_;
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	src_path = _tmp2_;
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_) {
#line 5823 "SourceList.c"
		GtkTreeModel* _tmp5_;
		GtkTreeStore* _tmp6_;
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = model;
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = self->priv->child_tree;
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp5_ == _tmp6_;
#line 5832 "SourceList.c"
	} else {
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 5836 "SourceList.c"
	}
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 5840 "SourceList.c"
		GtkTreePath* child_dest = NULL;
		GtkTreePath* _tmp7_;
		GtkTreePath* _tmp8_;
#line 1119 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, dest);
#line 1119 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		child_dest = _tmp7_;
#line 1121 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = child_dest;
#line 1121 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp8_ != NULL) {
#line 5852 "SourceList.c"
			GtkTreePath* _tmp9_;
			GtkTreePath* _tmp10_;
#line 1123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = child_dest;
#line 1123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = src_path;
#line 1123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (granite_widgets_source_list_patch_data_model_child_tree_drag_data_received (self, _tmp9_, _tmp10_)) {
#line 1124 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				result = TRUE;
#line 1124 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				__vala_GtkTreePath_free0 (child_dest);
#line 1124 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				__vala_GtkTreePath_free0 (src_path);
#line 1124 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (model);
#line 1124 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				return result;
#line 5871 "SourceList.c"
			}
		}
#line 1117 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 5876 "SourceList.c"
	}
#line 1129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 1129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (model);
#line 1129 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 5886 "SourceList.c"
}


static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 1139 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 5895 "SourceList.c"
}


static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 1139 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 5904 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_child_tree_drag_data_received (GraniteWidgetsSourceListPatchDataModel* self,
                                                                            GtkTreePath* dest,
                                                                            GtkTreePath* src_path)
{
	gboolean result = FALSE;
	gboolean retval = FALSE;
	GtkTreeIter src_iter = {0};
	GtkTreeIter dest_iter = {0};
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreePath* prev = NULL;
	GtkTreePath* _tmp3_;
	GtkTreePath* _tmp4_;
	gboolean _tmp25_;
#line 1132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (src_path != NULL, FALSE);
#line 1133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	retval = FALSE;
#line 1136 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1136 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp0_, &_tmp1_, src_path);
#line 1136 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	src_iter = _tmp1_;
#line 1136 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!_tmp2_) {
#line 1137 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1137 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 5944 "SourceList.c"
	}
#line 1139 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = __vala_GtkTreePath_copy0 (dest);
#line 1139 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	prev = _tmp3_;
#line 1142 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = prev;
#line 1142 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!gtk_tree_path_prev (_tmp4_)) {
#line 5954 "SourceList.c"
		GtkTreePath* parent = NULL;
		GtkTreePath* _tmp5_;
		GtkTreeIter* dest_parent = NULL;
		gboolean _tmp6_ = FALSE;
		GtkTreePath* _tmp7_;
		GtkTreeStore* _tmp14_;
		GtkTreeIter* _tmp15_;
		GtkTreeIter _tmp16_ = {0};
#line 1146 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = __vala_GtkTreePath_copy0 (dest);
#line 1146 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		parent = _tmp5_;
#line 1147 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_parent = NULL;
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = parent;
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (gtk_tree_path_up (_tmp7_)) {
#line 5973 "SourceList.c"
			GtkTreePath* _tmp8_;
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = parent;
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = gtk_tree_path_get_depth (_tmp8_) > 0;
#line 5979 "SourceList.c"
		} else {
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = FALSE;
#line 5983 "SourceList.c"
		}
#line 1149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp6_) {
#line 5987 "SourceList.c"
			GtkTreeStore* _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreeIter _tmp11_ = {0};
			GtkTreeIter _tmp12_;
			GtkTreeIter* _tmp13_;
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = self->priv->child_tree;
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = parent;
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_model_get_iter ((GtkTreeModel*) _tmp9_, &_tmp11_, _tmp10_);
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (dest_parent);
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = _tmp11_;
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = __gtk_tree_iter_dup0 (&_tmp12_);
#line 1150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dest_parent = _tmp13_;
#line 6007 "SourceList.c"
		}
#line 1152 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = self->priv->child_tree;
#line 1152 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = dest_parent;
#line 1152 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_store_prepend (_tmp14_, &_tmp16_, _tmp15_);
#line 1152 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_iter = _tmp16_;
#line 1153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		retval = TRUE;
#line 1142 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_free0 (dest_parent);
#line 1142 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (parent);
#line 6023 "SourceList.c"
	} else {
		GtkTreeStore* _tmp17_;
		GtkTreePath* _tmp18_;
		GtkTreeIter _tmp19_ = {0};
		gboolean _tmp20_;
#line 1154 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = self->priv->child_tree;
#line 1154 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = prev;
#line 1154 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp20_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp17_, &_tmp19_, _tmp18_);
#line 1154 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_iter = _tmp19_;
#line 1154 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp20_) {
#line 6039 "SourceList.c"
			GtkTreeIter tmp_iter = {0};
			GtkTreeIter _tmp21_;
			GtkTreeStore* _tmp22_;
			GtkTreeIter _tmp23_;
			GtkTreeIter _tmp24_ = {0};
#line 1155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = dest_iter;
#line 1155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			tmp_iter = _tmp21_;
#line 1156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp22_ = self->priv->child_tree;
#line 1156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp23_ = tmp_iter;
#line 1156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_store_insert_after (_tmp22_, &_tmp24_, NULL, &_tmp23_);
#line 1156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dest_iter = _tmp24_;
#line 1157 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			retval = TRUE;
#line 6059 "SourceList.c"
		}
	}
#line 1162 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp25_ = retval;
#line 1162 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp25_) {
#line 6066 "SourceList.c"
		GtkTreeIter _tmp26_;
		GtkTreeIter _tmp27_;
		GraniteWidgetsSourceListPatchItem* item = NULL;
		GtkTreeStore* _tmp28_;
		GtkTreeIter _tmp29_;
		GraniteWidgetsSourceListPatchItem* _tmp30_ = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp31_;
		gboolean _tmp32_;
		GraniteWidgetsSourceListPatchItem* _tmp33_;
		GraniteWidgetsSourceListPatchSortable* parent = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp34_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp35_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp36_;
		GraniteWidgetsSourceListPatchSortable* _tmp37_;
		GraniteWidgetsSourceListPatchSortable* _tmp38_;
		gboolean _tmp39_;
		GraniteWidgetsSourceListPatchSortable* _tmp40_;
		GraniteWidgetsSourceListPatchItem* _tmp41_;
#line 1163 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp26_ = src_iter;
#line 1163 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp27_ = dest_iter;
#line 1163 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_recursive_node_copy (self, &_tmp26_, &_tmp27_);
#line 1167 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp28_ = self->priv->child_tree;
#line 1167 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp29_ = src_iter;
#line 1167 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp28_, &_tmp29_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp30_, -1, -1);
#line 1167 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (item);
#line 1167 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item = _tmp30_;
#line 1168 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp31_ = item;
#line 1168 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp32_ = retval;
#line 1168 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_val_if_fail (_tmp31_ != NULL, _tmp32_);
#line 1177 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp33_ = item;
#line 1177 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_update_item (self, _tmp33_);
#line 1179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp34_ = item;
#line 1179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp35_ = granite_widgets_source_list_patch_item_get_parent (_tmp34_);
#line 1179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp36_ = _tmp35_;
#line 1179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp37_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE) ? ((GraniteWidgetsSourceListPatchSortable*) _tmp36_) : NULL);
#line 1179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		parent = _tmp37_;
#line 1180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp38_ = parent;
#line 1180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp39_ = retval;
#line 1180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_val_if_fail (_tmp38_ != NULL, _tmp39_);
#line 1182 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp40_ = parent;
#line 1182 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp41_ = item;
#line 1182 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (_tmp40_, granite_widgets_source_list_patch_sortable_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_SORTABLE_USER_MOVED_ITEM_SIGNAL], 0, _tmp41_);
#line 1162 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1162 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (item);
#line 6137 "SourceList.c"
	}
#line 1185 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = retval;
#line 1185 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (prev);
#line 1185 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 6145 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_recursive_node_copy (GraniteWidgetsSourceListPatchDataModel* self,
                                                                  GtkTreeIter* src_iter,
                                                                  GtkTreeIter* dest_iter)
{
	GtkTreeIter _tmp0_;
	GtkTreeIter _tmp1_;
	GtkTreeIter child = {0};
	GtkTreeStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GtkTreeIter _tmp4_ = {0};
	gboolean _tmp5_;
#line 1188 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1188 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (src_iter != NULL);
#line 1188 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (dest_iter != NULL);
#line 1189 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = *src_iter;
#line 1189 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *dest_iter;
#line 1189 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_move_item (self, &_tmp0_, &_tmp1_);
#line 1192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->child_tree;
#line 1192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = *src_iter;
#line 1192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = gtk_tree_model_iter_children ((GtkTreeModel*) _tmp2_, &_tmp4_, &_tmp3_);
#line 1192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child = _tmp4_;
#line 1192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_) {
#line 6183 "SourceList.c"
		{
			gboolean _tmp6_ = FALSE;
#line 1195 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = TRUE;
#line 1195 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			while (TRUE) {
#line 6190 "SourceList.c"
				GtkTreeIter copy = {0};
				GtkTreeStore* _tmp9_;
				GtkTreeIter _tmp10_;
				GtkTreeIter _tmp11_ = {0};
				GtkTreeIter _tmp12_;
				GtkTreeIter _tmp13_;
#line 1195 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (!_tmp6_) {
#line 6199 "SourceList.c"
					GtkTreeStore* _tmp7_;
					gboolean _tmp8_;
#line 1199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp7_ = self->priv->child_tree;
#line 1199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp8_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp7_, &child);
#line 1199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (!_tmp8_) {
#line 1199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						break;
#line 6210 "SourceList.c"
					}
				}
#line 1195 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp6_ = FALSE;
#line 1197 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp9_ = self->priv->child_tree;
#line 1197 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = *dest_iter;
#line 1197 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_tree_store_append (_tmp9_, &_tmp11_, &_tmp10_);
#line 1197 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				copy = _tmp11_;
#line 1198 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp12_ = child;
#line 1198 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp13_ = copy;
#line 1198 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_data_model_recursive_node_copy (self, &_tmp12_, &_tmp13_);
#line 6229 "SourceList.c"
			}
		}
	}
}


static void
granite_widgets_source_list_patch_data_model_move_item (GraniteWidgetsSourceListPatchDataModel* self,
                                                        GtkTreeIter* src_iter,
                                                        GtkTreeIter* dest_iter)
{
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_ = NULL;
	GtkTreeStore* _tmp3_;
	GtkTreeIter _tmp4_;
	GeeHashMap* _tmp5_;
	GtkTreeStore* _tmp6_;
	GtkTreeIter _tmp7_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp8_;
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* _tmp9_;
#line 1203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (src_iter != NULL);
#line 1203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (dest_iter != NULL);
#line 1205 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->child_tree;
#line 1205 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *src_iter;
#line 1205 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, &_tmp2_, -1, -1);
#line 1205 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 1205 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp2_;
#line 1206 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 1209 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = self->priv->child_tree;
#line 1209 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = *dest_iter;
#line 1209 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_store_set (_tmp3_, &_tmp4_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM, item, -1, -1);
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = self->priv->items;
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = self->priv->child_tree;
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = *dest_iter;
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = granite_widgets_source_list_patch_data_model_node_wrapper_new ((GtkTreeModel*) _tmp6_, &_tmp7_);
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = _tmp8_;
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, item, _tmp9_);
#line 1210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_granite_widgets_source_list_patch_data_model_node_wrapper_unref0 (_tmp9_);
#line 1203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 6292 "SourceList.c"
}


static gint*
_vala_array_dup1 (gint* self,
                  int length)
{
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return g_memdup (self, length * sizeof (gint));
#line 6302 "SourceList.c"
}


static gint*
_vala_array_dup2 (gint* self,
                  int length)
{
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return g_memdup (self, length * sizeof (gint));
#line 6312 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_real_row_drop_possible (GtkTreeDragDest* base,
                                                                     GtkTreePath* dest,
                                                                     GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	gboolean result = FALSE;
	GtkTreeModel* model = NULL;
	GtkTreePath* src_path = NULL;
	gboolean _tmp0_ = FALSE;
	GtkTreeModel* _tmp1_ = NULL;
	GtkTreePath* _tmp2_ = NULL;
	gboolean _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreePath* child_dest = NULL;
	GtkTreePath* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GtkTreePath* _tmp9_;
	gint src_depth = 0;
	GtkTreePath* _tmp12_;
	gint dest_depth = 0;
	GtkTreePath* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	GraniteWidgetsSourceListPatchItem* parent = NULL;
	gint _tmp17_;
	GraniteWidgetsSourceListPatchSortable* sortable = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp44_;
	GraniteWidgetsSourceListPatchSortable* _tmp45_;
	gboolean _tmp46_ = FALSE;
	GraniteWidgetsSourceListPatchSortable* _tmp47_;
	GraniteWidgetsSourceListPatchItem* dest_item = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp49_;
	GraniteWidgetsSourceListPatchItem* _tmp50_;
	GraniteWidgetsSourceListPatchItem* source_item = NULL;
	GtkTreePath* filter_src_path = NULL;
	GtkTreePath* _tmp51_;
	GtkTreePath* _tmp52_;
	GtkTreePath* _tmp53_;
	GraniteWidgetsSourceListPatchItem* _tmp56_;
	GraniteWidgetsSourceListPatchSortable* _tmp57_;
	GraniteWidgetsSourceListPatchItem* _tmp58_;
	GraniteWidgetsSourceListPatchItem* _tmp59_;
#line 1213 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModel*) base;
#line 1213 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 1213 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gtk_tree_get_row_drag_data (selection_data, &_tmp1_, &_tmp2_);
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (model);
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = _g_object_ref0 (_tmp1_);
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	model = _tmp4_;
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	src_path = _tmp2_;
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!_tmp3_) {
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = TRUE;
#line 6382 "SourceList.c"
	} else {
		GtkTreeModel* _tmp5_;
		GtkTreeStore* _tmp6_;
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = model;
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = self->priv->child_tree;
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp5_ != _tmp6_;
#line 6392 "SourceList.c"
	}
#line 1220 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 1221 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1221 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1221 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1221 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6404 "SourceList.c"
	}
#line 1224 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = gtk_tree_model_filter_convert_path_to_child_path ((GtkTreeModelFilter*) self, dest);
#line 1224 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	child_dest = _tmp7_;
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = child_dest;
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp9_ == NULL) {
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = TRUE;
#line 6416 "SourceList.c"
	} else {
		GtkTreePath* _tmp10_;
		GtkTreePath* _tmp11_;
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = src_path;
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp11_ = child_dest;
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = gtk_tree_path_compare (_tmp10_, _tmp11_) == 0;
#line 6426 "SourceList.c"
	}
#line 1227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp8_) {
#line 1228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6440 "SourceList.c"
	}
#line 1232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = src_path;
#line 1232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	src_depth = gtk_tree_path_get_depth (_tmp12_);
#line 1233 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp13_ = child_dest;
#line 1233 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	dest_depth = gtk_tree_path_get_depth (_tmp13_);
#line 1235 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp14_ = src_depth;
#line 1235 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp15_ = dest_depth;
#line 1235 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp14_ != _tmp15_) {
#line 1236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6466 "SourceList.c"
	}
#line 1239 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp16_ = src_depth;
#line 1239 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp16_ < 1) {
#line 1240 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1240 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1240 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1240 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1240 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6482 "SourceList.c"
	}
#line 1242 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent = NULL;
#line 1247 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp17_ = src_depth;
#line 1247 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp17_ == 1) {
#line 6490 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp18_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp19_;
		GraniteWidgetsSourceListPatchItem* _tmp20_;
#line 1248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = granite_widgets_source_list_patch_data_model_get_root (self);
#line 1248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = _tmp18_;
#line 1248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp20_ = _g_object_ref0 ((GraniteWidgetsSourceListPatchItem*) _tmp19_);
#line 1248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		parent = _tmp20_;
#line 6504 "SourceList.c"
	} else {
		gint _tmp21_;
		gint* src_indices = NULL;
		GtkTreePath* _tmp22_;
		gint _tmp23_ = 0;
		gint* _tmp24_;
		gint* _tmp25_;
		gint _tmp25__length1;
		gint src_indices_length1;
		gint _src_indices_size_;
		gint* dest_indices = NULL;
		GtkTreePath* _tmp26_;
		gint _tmp27_ = 0;
		gint* _tmp28_;
		gint* _tmp29_;
		gint _tmp29__length1;
		gint dest_indices_length1;
		gint _dest_indices_size_;
		gint src_parent_index = 0;
		gint* _tmp30_;
		gint _tmp30__length1;
		gint _tmp31_;
		gint _tmp32_;
		gint dest_parent_index = 0;
		gint* _tmp33_;
		gint _tmp33__length1;
		gint _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		GtkTreePath* dest_parent = NULL;
		GtkTreePath* _tmp38_;
		gboolean _tmp39_ = FALSE;
		GtkTreePath* _tmp40_;
		GtkTreePath* _tmp42_;
		GraniteWidgetsSourceListPatchItem* _tmp43_;
#line 1251 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp21_ = dest_depth;
#line 1251 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_vala_assert (_tmp21_ > 1, "dest_depth > 1");
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp22_ = src_path;
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp24_ = gtk_tree_path_get_indices_with_depth (_tmp22_, &_tmp23_);
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp25_ = (_tmp24_ != NULL) ? _vala_array_dup1 (_tmp24_, _tmp23_) : ((gpointer) _tmp24_);
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp25__length1 = _tmp23_;
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		src_indices = _tmp25_;
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		src_indices_length1 = _tmp25__length1;
#line 1257 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_src_indices_size_ = src_indices_length1;
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp26_ = child_dest;
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp28_ = gtk_tree_path_get_indices_with_depth (_tmp26_, &_tmp27_);
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp29_ = (_tmp28_ != NULL) ? _vala_array_dup2 (_tmp28_, _tmp27_) : ((gpointer) _tmp28_);
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp29__length1 = _tmp27_;
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_indices = _tmp29_;
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_indices_length1 = _tmp29__length1;
#line 1258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_dest_indices_size_ = dest_indices_length1;
#line 1261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp30_ = src_indices;
#line 1261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp30__length1 = src_indices_length1;
#line 1261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp31_ = src_depth;
#line 1261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp32_ = _tmp30_[_tmp31_ - 2];
#line 1261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		src_parent_index = _tmp32_;
#line 1262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp33_ = dest_indices;
#line 1262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp33__length1 = dest_indices_length1;
#line 1262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp34_ = dest_depth;
#line 1262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp35_ = _tmp33_[_tmp34_ - 2];
#line 1262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_parent_index = _tmp35_;
#line 1264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp36_ = src_parent_index;
#line 1264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp37_ = dest_parent_index;
#line 1264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp36_ != _tmp37_) {
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = FALSE;
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dest_indices = (g_free (dest_indices), NULL);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			src_indices = (g_free (src_indices), NULL);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (parent);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (model);
#line 1265 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 6615 "SourceList.c"
		}
#line 1268 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp38_ = __vala_GtkTreePath_copy0 (dest);
#line 1268 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_parent = _tmp38_;
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp40_ = dest_parent;
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (!gtk_tree_path_up (_tmp40_)) {
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp39_ = TRUE;
#line 6627 "SourceList.c"
		} else {
			GtkTreePath* _tmp41_;
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp41_ = dest_parent;
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp39_ = gtk_tree_path_get_depth (_tmp41_) < 1;
#line 6634 "SourceList.c"
		}
#line 1270 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp39_) {
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = FALSE;
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (dest_parent);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dest_indices = (g_free (dest_indices), NULL);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			src_indices = (g_free (src_indices), NULL);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (parent);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (model);
#line 1271 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 6656 "SourceList.c"
		}
#line 1273 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp42_ = dest_parent;
#line 1273 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp43_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, _tmp42_);
#line 1273 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1273 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		parent = _tmp43_;
#line 1247 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (dest_parent);
#line 1247 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_indices = (g_free (dest_indices), NULL);
#line 1247 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		src_indices = (g_free (src_indices), NULL);
#line 6672 "SourceList.c"
	}
#line 1276 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp44_ = parent;
#line 1276 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp45_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE) ? ((GraniteWidgetsSourceListPatchSortable*) _tmp44_) : NULL);
#line 1276 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	sortable = _tmp45_;
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp47_ = sortable;
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp47_ == NULL) {
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp46_ = TRUE;
#line 6686 "SourceList.c"
	} else {
		GraniteWidgetsSourceListPatchSortable* _tmp48_;
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp48_ = sortable;
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp46_ = !granite_widgets_source_list_patch_sortable_allow_dnd_sorting (_tmp48_);
#line 6693 "SourceList.c"
	}
#line 1278 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp46_) {
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1279 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6711 "SourceList.c"
	}
#line 1281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp49_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, dest);
#line 1281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	dest_item = _tmp49_;
#line 1283 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp50_ = dest_item;
#line 1283 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp50_ == NULL) {
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = TRUE;
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6737 "SourceList.c"
	}
#line 1286 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	source_item = NULL;
#line 1287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp51_ = src_path;
#line 1287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp52_ = gtk_tree_model_filter_convert_child_path_to_path ((GtkTreeModelFilter*) self, _tmp51_);
#line 1287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	filter_src_path = _tmp52_;
#line 1289 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp53_ = filter_src_path;
#line 1289 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp53_ != NULL) {
#line 6751 "SourceList.c"
		GtkTreePath* _tmp54_;
		GraniteWidgetsSourceListPatchItem* _tmp55_;
#line 1290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp54_ = filter_src_path;
#line 1290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp55_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, _tmp54_);
#line 1290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		source_item = _tmp55_;
#line 6762 "SourceList.c"
	}
#line 1292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp56_ = source_item;
#line 1292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp56_ == NULL) {
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (filter_src_path);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6788 "SourceList.c"
	}
#line 1301 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp57_ = sortable;
#line 1301 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp58_ = dest_item;
#line 1301 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp59_ = source_item;
#line 1301 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_sortable_compare (_tmp57_, _tmp58_, _tmp59_) >= 0) {
#line 6798 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* dest_item_prev = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp60_;
		gboolean _tmp61_ = FALSE;
		gboolean _tmp62_ = FALSE;
		GraniteWidgetsSourceListPatchItem* _tmp63_;
#line 1302 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (!gtk_tree_path_prev (dest)) {
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = TRUE;
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (filter_src_path);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (source_item);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (dest_item);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (sortable);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (parent);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (child_dest);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (src_path);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (model);
#line 1303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 6826 "SourceList.c"
		}
#line 1307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp60_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, dest);
#line 1307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_item_prev = _tmp60_;
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp63_ = dest_item_prev;
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp63_ != NULL) {
#line 6836 "SourceList.c"
			GraniteWidgetsSourceListPatchItem* _tmp64_;
			GraniteWidgetsSourceListPatchItem* _tmp65_;
#line 1310 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp64_ = dest_item_prev;
#line 1310 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp65_ = source_item;
#line 1310 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp62_ = _tmp64_ != _tmp65_;
#line 6845 "SourceList.c"
		} else {
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp62_ = FALSE;
#line 6849 "SourceList.c"
		}
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp62_) {
#line 6853 "SourceList.c"
			GraniteWidgetsSourceListPatchSortable* _tmp66_;
			GraniteWidgetsSourceListPatchItem* _tmp67_;
			GraniteWidgetsSourceListPatchItem* _tmp68_;
#line 1311 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp66_ = sortable;
#line 1311 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp67_ = dest_item_prev;
#line 1311 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp68_ = source_item;
#line 1311 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp61_ = granite_widgets_source_list_patch_sortable_compare (_tmp66_, _tmp67_, _tmp68_) <= 0;
#line 6865 "SourceList.c"
		} else {
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp61_ = FALSE;
#line 6869 "SourceList.c"
		}
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = _tmp61_;
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (dest_item_prev);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (filter_src_path);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (source_item);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (dest_item);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (sortable);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (parent);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (child_dest);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (src_path);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6893 "SourceList.c"
	}
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (filter_src_path);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (source_item);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (dest_item);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (sortable);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (parent);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (child_dest);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (src_path);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (model);
#line 1314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 6915 "SourceList.c"
}


/**
             * Override default implementation of TreeDragSource
             *
             * drag_data_delete is not overriden because the default implementation
             * does exactly what we need.
             */
static gboolean
granite_widgets_source_list_patch_data_model_real_drag_data_get (GtkTreeDragSource* base,
                                                                 GtkTreePath* path,
                                                                 GtkSelectionData* selection_data)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListPatchDragSource* drag_source_item = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	GraniteWidgetsSourceListPatchDragSource* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GraniteWidgetsSourceListPatchDragSource* _tmp3_;
#line 1324 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModel*) base;
#line 1324 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1324 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (selection_data != NULL, FALSE);
#line 1327 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (gtk_selection_data_get_target (selection_data) == gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW")) {
#line 1328 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_parent_iface->drag_data_get ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), path, selection_data);
#line 1328 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6949 "SourceList.c"
	}
#line 1331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, path);
#line 1331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE) ? ((GraniteWidgetsSourceListPatchDragSource*) _tmp0_) : NULL;
#line 1331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ == NULL) {
#line 1331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp0_);
#line 6959 "SourceList.c"
	}
#line 1331 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	drag_source_item = _tmp1_;
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = drag_source_item;
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ != NULL) {
#line 6967 "SourceList.c"
		GraniteWidgetsSourceListPatchDragSource* _tmp4_;
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = drag_source_item;
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_drag_source_draggable (_tmp4_);
#line 6973 "SourceList.c"
	} else {
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = FALSE;
#line 6977 "SourceList.c"
	}
#line 1332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_) {
#line 6981 "SourceList.c"
		GraniteWidgetsSourceListPatchDragSource* _tmp5_;
#line 1333 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = drag_source_item;
#line 1333 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_drag_source_prepare_selection_data (_tmp5_, selection_data);
#line 1334 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = TRUE;
#line 1334 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (drag_source_item);
#line 1334 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 6993 "SourceList.c"
	}
#line 1337 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 1337 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (drag_source_item);
#line 1337 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7001 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_real_row_draggable (GtkTreeDragSource* base,
                                                                 GtkTreePath* path)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
#line 1340 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModel*) base;
#line 1340 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1341 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_parent_iface->row_draggable ((GtkTreeDragSource*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_model_filter_get_type (), GtkTreeModelFilter), path)) {
#line 1342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 7024 "SourceList.c"
	}
#line 1344 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_get_item_from_path (self, path);
#line 1344 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp0_;
#line 1346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = item;
#line 1346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 7034 "SourceList.c"
		GraniteWidgetsSourceListPatchSortable* sortable_item = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp2_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp4_;
		GraniteWidgetsSourceListPatchSortable* _tmp5_;
		gboolean _tmp6_ = FALSE;
		GraniteWidgetsSourceListPatchSortable* _tmp7_;
		GraniteWidgetsSourceListPatchDragSource* drag_source_item = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp9_;
		GraniteWidgetsSourceListPatchDragSource* _tmp10_;
		gboolean _tmp11_ = FALSE;
		GraniteWidgetsSourceListPatchDragSource* _tmp12_;
#line 1348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = item;
#line 1348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_patch_item_get_parent (_tmp2_);
#line 1348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _tmp3_;
#line 1348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_SORTABLE) ? ((GraniteWidgetsSourceListPatchSortable*) _tmp4_) : NULL);
#line 1348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		sortable_item = _tmp5_;
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = sortable_item;
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 7061 "SourceList.c"
			GraniteWidgetsSourceListPatchSortable* _tmp8_;
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = sortable_item;
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = granite_widgets_source_list_patch_sortable_allow_dnd_sorting (_tmp8_);
#line 7067 "SourceList.c"
		} else {
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = FALSE;
#line 7071 "SourceList.c"
		}
#line 1350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp6_) {
#line 1351 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = TRUE;
#line 1351 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (sortable_item);
#line 1351 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (item);
#line 1351 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 7083 "SourceList.c"
		}
#line 1355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = item;
#line 1355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_SOURCE) ? ((GraniteWidgetsSourceListPatchDragSource*) _tmp9_) : NULL);
#line 1355 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		drag_source_item = _tmp10_;
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = drag_source_item;
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp12_ != NULL) {
#line 7095 "SourceList.c"
			GraniteWidgetsSourceListPatchDragSource* _tmp13_;
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = drag_source_item;
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = granite_widgets_source_list_patch_drag_source_draggable (_tmp13_);
#line 7101 "SourceList.c"
		} else {
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = FALSE;
#line 7105 "SourceList.c"
		}
#line 1357 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp11_) {
#line 1358 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = TRUE;
#line 1358 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (drag_source_item);
#line 1358 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (sortable_item);
#line 1358 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (item);
#line 1358 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 7119 "SourceList.c"
		}
#line 1346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (drag_source_item);
#line 1346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (sortable_item);
#line 7125 "SourceList.c"
	}
#line 1361 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 1361 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 1361 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7133 "SourceList.c"
}


static GraniteWidgetsSourceListPatchExpandableItem*
granite_widgets_source_list_patch_data_model_get_root (GraniteWidgetsSourceListPatchDataModel* self)
{
	GraniteWidgetsSourceListPatchExpandableItem* result;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
#line 730 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 730 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_root;
#line 730 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 730 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7150 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_set_root (GraniteWidgetsSourceListPatchDataModel* self,
                                                       GraniteWidgetsSourceListPatchExpandableItem* value)
{
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp12_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp13_;
#line 731 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 732 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_root;
#line 732 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_ != NULL) {
#line 7167 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
#line 733 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = self->priv->_root;
#line 733 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_remove_children_monitor (self, _tmp1_);
#line 7173 "SourceList.c"
		{
			GeeIterator* _item_it = NULL;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
			GeeCollection* _tmp3_;
			GeeCollection* _tmp4_;
			GeeCollection* _tmp5_;
			GeeIterator* _tmp6_;
			GeeIterator* _tmp7_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp2_ = self->priv->_root;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp3_ = granite_widgets_source_list_patch_expandable_item_get_children (_tmp2_);
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp4_ = _tmp3_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = _tmp4_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = gee_iterable_iterator ((GeeIterable*) _tmp5_);
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = _tmp6_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_tmp5_);
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_item_it = _tmp7_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			while (TRUE) {
#line 7200 "SourceList.c"
				GeeIterator* _tmp8_;
				GraniteWidgetsSourceListPatchItem* item = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				GraniteWidgetsSourceListPatchItem* _tmp11_;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp8_ = _item_it;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					break;
#line 7212 "SourceList.c"
				}
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp9_ = _item_it;
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				item = (GraniteWidgetsSourceListPatchItem*) _tmp10_;
#line 735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp11_ = item;
#line 735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_data_model_remove_item (self, _tmp11_);
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (item);
#line 7226 "SourceList.c"
			}
#line 734 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (_item_it);
#line 7230 "SourceList.c"
		}
	}
#line 738 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = _g_object_ref0 (value);
#line 738 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_root);
#line 738 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_root = _tmp12_;
#line 740 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp13_ = self->priv->_root;
#line 740 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_add_children_monitor (self, _tmp13_);
#line 7243 "SourceList.c"
	{
		GeeIterator* _item_it = NULL;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp14_;
		GeeCollection* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
		GeeIterator* _tmp18_;
		GeeIterator* _tmp19_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = self->priv->_root;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = granite_widgets_source_list_patch_expandable_item_get_children (_tmp14_);
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp16_ = _tmp15_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = _tmp16_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = gee_iterable_iterator ((GeeIterable*) _tmp17_);
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = _tmp18_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp17_);
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_item_it = _tmp19_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		while (TRUE) {
#line 7270 "SourceList.c"
			GeeIterator* _tmp20_;
			GraniteWidgetsSourceListPatchItem* item = NULL;
			GeeIterator* _tmp21_;
			gpointer _tmp22_;
			GraniteWidgetsSourceListPatchItem* _tmp23_;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp20_ = _item_it;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (!gee_iterator_next (_tmp20_)) {
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 7282 "SourceList.c"
			}
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = _item_it;
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp22_ = gee_iterator_get (_tmp21_);
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			item = (GraniteWidgetsSourceListPatchItem*) _tmp22_;
#line 742 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp23_ = item;
#line 742 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			granite_widgets_source_list_patch_data_model_add_item (self, _tmp23_);
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (item);
#line 7296 "SourceList.c"
		}
#line 741 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_item_it);
#line 7300 "SourceList.c"
	}
#line 731 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY]);
#line 7304 "SourceList.c"
}


static gint
_granite_widgets_source_list_patch_data_model_child_model_sort_func_gtk_tree_iter_compare_func (GtkTreeModel* model,
                                                                                                GtkTreeIter* a,
                                                                                                GtkTreeIter* b,
                                                                                                gpointer self)
{
	gint result;
	result = granite_widgets_source_list_patch_data_model_child_model_sort_func ((GraniteWidgetsSourceListPatchDataModel*) self, model, a, b);
#line 765 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7318 "SourceList.c"
}


static gboolean
_granite_widgets_source_list_patch_data_model_filter_visible_func_gtk_tree_model_filter_visible_func (GtkTreeModel* model,
                                                                                                      GtkTreeIter* iter,
                                                                                                      gpointer self)
{
	gboolean result;
	result = granite_widgets_source_list_patch_data_model_filter_visible_func ((GraniteWidgetsSourceListPatchDataModel*) self, model, iter);
#line 768 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7331 "SourceList.c"
}


static GObject *
granite_widgets_source_list_patch_data_model_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListPatchDataModel * self;
	GtkTreeStore* _tmp0_;
	GtkTreeStore* _tmp1_;
	GtkTreeStore* _tmp2_;
#line 760 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_patch_data_model_parent_class);
#line 760 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 760 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModel);
#line 761 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_tree_store_new ((gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_N_COLUMNS, granite_widgets_source_list_patch_data_model_column_type (GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_COLUMN_ITEM));
#line 761 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->child_tree);
#line 761 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->child_tree = _tmp0_;
#line 762 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->child_tree;
#line 762 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkTreeModelFilter*) self, "child-model", (GtkTreeModel*) _tmp1_, NULL);
#line 763 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkTreeModelFilter*) self, "virtual-root", NULL, NULL);
#line 765 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->child_tree;
#line 765 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_sortable_set_default_sort_func ((GtkTreeSortable*) _tmp2_, _granite_widgets_source_list_patch_data_model_child_model_sort_func_gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
#line 766 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_resort (self);
#line 768 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_model_filter_set_visible_func ((GtkTreeModelFilter*) self, _granite_widgets_source_list_patch_data_model_filter_visible_func_gtk_tree_model_filter_visible_func, g_object_ref (self), g_object_unref);
#line 760 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return obj;
#line 7374 "SourceList.c"
}


static inline gpointer
granite_widgets_source_list_patch_data_model_node_wrapper_get_instance_private (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchDataModelNodeWrapper_private_offset);
}


static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
#line 636 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
#line 7390 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModelNodeWrapper*
granite_widgets_source_list_patch_data_model_node_wrapper_construct (GType object_type,
                                                                     GtkTreeModel* model,
                                                                     GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper* self = NULL;
	GtkTreeIter _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
	GtkTreeRowReference* _tmp3_;
#line 673 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 673 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 673 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModelNodeWrapper*) g_type_create_instance (object_type);
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = *iter;
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gtk_tree_model_get_path (model, &_tmp0_);
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gtk_tree_row_reference_new (model, _tmp2_);
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreeRowReference_free0 (self->priv->row_reference);
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->row_reference = _tmp3_;
#line 674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (_tmp2_);
#line 673 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 7426 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModelNodeWrapper*
granite_widgets_source_list_patch_data_model_node_wrapper_new (GtkTreeModel* model,
                                                               GtkTreeIter* iter)
{
#line 673 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_data_model_node_wrapper_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, model, iter);
#line 7436 "SourceList.c"
}


static GtkTreeIter*
granite_widgets_source_list_patch_data_model_node_wrapper_get_iter (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self)
{
	GtkTreeIter* result;
	GtkTreeIter* rv = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 642 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 643 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	rv = NULL;
#line 645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_valid (self);
#line 645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 7457 "SourceList.c"
		GtkTreePath* _path = NULL;
		GtkTreePath* _tmp2_;
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
#line 646 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_path (self);
#line 646 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 646 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_path = _tmp3_;
#line 647 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _path;
#line 647 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp4_ != NULL) {
#line 7472 "SourceList.c"
			GtkTreeIter _iter = {0};
			GtkTreeRowReference* _tmp5_;
			GtkTreeModel* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreeIter _tmp8_ = {0};
			gboolean _tmp9_;
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = self->priv->row_reference;
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = gtk_tree_row_reference_get_model (_tmp5_);
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = _path;
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = gtk_tree_model_get_iter (_tmp6_, &_tmp8_, _tmp7_);
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_iter = _tmp8_;
#line 649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp9_) {
#line 7491 "SourceList.c"
				GtkTreeIter _tmp10_;
				GtkTreeIter* _tmp11_;
#line 650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = _iter;
#line 650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp11_ = __gtk_tree_iter_dup0 (&_tmp10_);
#line 650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_free0 (rv);
#line 650 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				rv = _tmp11_;
#line 7502 "SourceList.c"
			}
		}
#line 645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (_path);
#line 7507 "SourceList.c"
	}
#line 654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = rv;
#line 654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7513 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_patch_data_model_node_wrapper_get_path (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self)
{
	GtkTreePath* result;
	GtkTreePath* _tmp0_ = NULL;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_node_wrapper_get_valid (self);
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_) {
#line 7532 "SourceList.c"
		GtkTreeRowReference* _tmp3_;
		GtkTreePath* _tmp4_;
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = self->priv->row_reference;
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = gtk_tree_row_reference_get_path (_tmp3_);
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (_tmp0_);
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp4_;
#line 7543 "SourceList.c"
	} else {
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (_tmp0_);
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = NULL;
#line 7549 "SourceList.c"
	}
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 662 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7555 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_data_model_node_wrapper_get_valid (GraniteWidgetsSourceListPatchDataModelNodeWrapper* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	GtkTreeRowReference* _tmp1_;
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->row_reference;
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 7571 "SourceList.c"
		GtkTreeRowReference* _tmp2_;
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = self->priv->row_reference;
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = gtk_tree_row_reference_valid (_tmp2_);
#line 7577 "SourceList.c"
	} else {
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 7581 "SourceList.c"
	}
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 7587 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_node_wrapper_init (GValue* value)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	value->data[0].v_pointer = NULL;
#line 7596 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_node_wrapper_free_value (GValue* value)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (value->data[0].v_pointer) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_node_wrapper_unref (value->data[0].v_pointer);
#line 7607 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_value_node_wrapper_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (src_value->data[0].v_pointer) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_value->data[0].v_pointer = granite_widgets_source_list_patch_data_model_node_wrapper_ref (src_value->data[0].v_pointer);
#line 7620 "SourceList.c"
	} else {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7624 "SourceList.c"
	}
}


static gpointer
granite_widgets_source_list_patch_data_model_value_node_wrapper_peek_pointer (const GValue* value)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return value->data[0].v_pointer;
#line 7634 "SourceList.c"
}


static gchar*
granite_widgets_source_list_patch_data_model_value_node_wrapper_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (collect_values[0].v_pointer) {
#line 7646 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModelNodeWrapper * object;
		object = collect_values[0].v_pointer;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7653 "SourceList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7657 "SourceList.c"
		}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = granite_widgets_source_list_patch_data_model_node_wrapper_ref (object);
#line 7661 "SourceList.c"
	} else {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7665 "SourceList.c"
	}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return NULL;
#line 7669 "SourceList.c"
}


static gchar*
granite_widgets_source_list_patch_data_model_value_node_wrapper_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper ** object_p;
	object_p = collect_values[0].v_pointer;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!object_p) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7685 "SourceList.c"
	}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!value->data[0].v_pointer) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = NULL;
#line 7691 "SourceList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = value->data[0].v_pointer;
#line 7695 "SourceList.c"
	} else {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = granite_widgets_source_list_patch_data_model_node_wrapper_ref (value->data[0].v_pointer);
#line 7699 "SourceList.c"
	}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return NULL;
#line 7703 "SourceList.c"
}


static GParamSpec*
granite_widgets_source_list_patch_data_model_param_spec_node_wrapper (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	GraniteWidgetsSourceListPatchDataModelParamSpecNodeWrapper* spec;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return G_PARAM_SPEC (spec);
#line 7723 "SourceList.c"
}


static gpointer
granite_widgets_source_list_patch_data_model_value_get_node_wrapper (const GValue* value)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER), NULL);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return value->data[0].v_pointer;
#line 7734 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_set_node_wrapper (GValue* value,
                                                                     gpointer v_object)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper * old;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	old = value->data[0].v_pointer;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (v_object) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_node_wrapper_ref (value->data[0].v_pointer);
#line 7757 "SourceList.c"
	} else {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7761 "SourceList.c"
	}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (old) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_node_wrapper_unref (old);
#line 7767 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_value_take_node_wrapper (GValue* value,
                                                                      gpointer v_object)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper * old;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	old = value->data[0].v_pointer;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (v_object) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 7789 "SourceList.c"
	} else {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 7793 "SourceList.c"
	}
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (old) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_node_wrapper_unref (old);
#line 7799 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_node_wrapper_class_init (GraniteWidgetsSourceListPatchDataModelNodeWrapperClass * klass)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_node_wrapper_parent_class = g_type_class_peek_parent (klass);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchDataModelNodeWrapperClass *) klass)->finalize = granite_widgets_source_list_patch_data_model_node_wrapper_finalize;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchDataModelNodeWrapper_private_offset);
#line 7813 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_node_wrapper_instance_init (GraniteWidgetsSourceListPatchDataModelNodeWrapper * self)
{
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_data_model_node_wrapper_get_instance_private (self);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->ref_count = 1;
#line 7824 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_node_wrapper_finalize (GraniteWidgetsSourceListPatchDataModelNodeWrapper * obj)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper * self;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, GraniteWidgetsSourceListPatchDataModelNodeWrapper);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_destroy (self);
#line 636 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreeRowReference_free0 (self->priv->row_reference);
#line 7838 "SourceList.c"
}


/**
             * An object that references a particular row in a model. This class is a wrapper built around
             * Gtk.TreeRowReference, and exists with the purpose of ensuring we never use invalid tree paths
             * or iters in the model, since most of these errors provoke failures due to GTK+ assertions
             * or, even worse, unexpected behavior.
             */
static GType
granite_widgets_source_list_patch_data_model_node_wrapper_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_data_model_node_wrapper_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_data_model_node_wrapper_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_patch_data_model_value_node_wrapper_init, granite_widgets_source_list_patch_data_model_value_node_wrapper_free_value, granite_widgets_source_list_patch_data_model_value_node_wrapper_copy_value, granite_widgets_source_list_patch_data_model_value_node_wrapper_peek_pointer, "p", granite_widgets_source_list_patch_data_model_value_node_wrapper_collect_value, "p", granite_widgets_source_list_patch_data_model_value_node_wrapper_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchDataModelNodeWrapperClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_data_model_node_wrapper_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchDataModelNodeWrapper), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_data_model_node_wrapper_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_patch_data_model_node_wrapper_type_id;
		granite_widgets_source_list_patch_data_model_node_wrapper_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListPatchDataModelNodeWrapper", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GraniteWidgetsSourceListPatchDataModelNodeWrapper_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_data_model_node_wrapper_type_id, sizeof (GraniteWidgetsSourceListPatchDataModelNodeWrapperPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_data_model_node_wrapper_type_id__volatile, granite_widgets_source_list_patch_data_model_node_wrapper_type_id);
	}
	return granite_widgets_source_list_patch_data_model_node_wrapper_type_id__volatile;
}


static gpointer
granite_widgets_source_list_patch_data_model_node_wrapper_ref (gpointer instance)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper * self;
	self = instance;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return instance;
#line 7874 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_node_wrapper_unref (gpointer instance)
{
	GraniteWidgetsSourceListPatchDataModelNodeWrapper * self;
	self = instance;
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_NODE_WRAPPER_GET_CLASS (self)->finalize (self);
#line 631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7889 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_patch_data_model_item_monitor_get_instance_private (GraniteWidgetsSourceListPatchDataModelItemMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchDataModelItemMonitor_private_offset);
}


static void
_granite_widgets_source_list_patch_data_model_item_monitor_on_notify_g_object_notify (GObject* _sender,
                                                                                      GParamSpec* pspec,
                                                                                      gpointer self)
{
#line 691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_item_monitor_on_notify ((GraniteWidgetsSourceListPatchDataModelItemMonitor*) self, pspec);
#line 7908 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModelItemMonitor*
granite_widgets_source_list_patch_data_model_item_monitor_construct (GType object_type,
                                                                     GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor* self = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
#line 685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchDataModelItemMonitor*) g_type_create_instance (object_type);
#line 686 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (item);
#line 686 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->item);
#line 686 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->item = _tmp0_;
#line 687 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_after ((GObject*) item, "notify", (GCallback) _granite_widgets_source_list_patch_data_model_item_monitor_on_notify_g_object_notify, self);
#line 685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 7932 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModelItemMonitor*
granite_widgets_source_list_patch_data_model_item_monitor_new (GraniteWidgetsSourceListPatchItem* item)
{
#line 685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_data_model_item_monitor_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, item);
#line 7941 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_item_monitor_on_notify (GraniteWidgetsSourceListPatchDataModelItemMonitor* self,
                                                                     GParamSpec* prop)
{
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	const gchar* _tmp1_;
#line 694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (prop != NULL);
#line 695 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->item;
#line 695 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = prop->name;
#line 695 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL], 0, _tmp0_, _tmp1_);
#line 7961 "SourceList.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_STRING (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_STRING) (gpointer data1, gpointer arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (n_param_values == 3);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		data1 = closure->data;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		data2 = param_values->data[0].v_pointer;
#line 7987 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		data1 = param_values->data[0].v_pointer;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		data2 = closure->data;
#line 7993 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	callback = (GMarshalFunc_VOID__OBJECT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 7999 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_item_monitor_init (GValue* value)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	value->data[0].v_pointer = NULL;
#line 8008 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_item_monitor_free_value (GValue* value)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (value->data[0].v_pointer) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_item_monitor_unref (value->data[0].v_pointer);
#line 8019 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_value_item_monitor_copy_value (const GValue* src_value,
                                                                            GValue* dest_value)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (src_value->data[0].v_pointer) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_value->data[0].v_pointer = granite_widgets_source_list_patch_data_model_item_monitor_ref (src_value->data[0].v_pointer);
#line 8032 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8036 "SourceList.c"
	}
}


static gpointer
granite_widgets_source_list_patch_data_model_value_item_monitor_peek_pointer (const GValue* value)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return value->data[0].v_pointer;
#line 8046 "SourceList.c"
}


static gchar*
granite_widgets_source_list_patch_data_model_value_item_monitor_collect_value (GValue* value,
                                                                               guint n_collect_values,
                                                                               GTypeCValue* collect_values,
                                                                               guint collect_flags)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (collect_values[0].v_pointer) {
#line 8058 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModelItemMonitor * object;
		object = collect_values[0].v_pointer;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (object->parent_instance.g_class == NULL) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8065 "SourceList.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8069 "SourceList.c"
		}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = granite_widgets_source_list_patch_data_model_item_monitor_ref (object);
#line 8073 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8077 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return NULL;
#line 8081 "SourceList.c"
}


static gchar*
granite_widgets_source_list_patch_data_model_value_item_monitor_lcopy_value (const GValue* value,
                                                                             guint n_collect_values,
                                                                             GTypeCValue* collect_values,
                                                                             guint collect_flags)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!object_p) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8097 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!value->data[0].v_pointer) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = NULL;
#line 8103 "SourceList.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = value->data[0].v_pointer;
#line 8107 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*object_p = granite_widgets_source_list_patch_data_model_item_monitor_ref (value->data[0].v_pointer);
#line 8111 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return NULL;
#line 8115 "SourceList.c"
}


static GParamSpec*
granite_widgets_source_list_patch_data_model_param_spec_item_monitor (const gchar* name,
                                                                      const gchar* nick,
                                                                      const gchar* blurb,
                                                                      GType object_type,
                                                                      GParamFlags flags)
{
	GraniteWidgetsSourceListPatchDataModelParamSpecItemMonitor* spec;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (g_type_is_a (object_type, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return G_PARAM_SPEC (spec);
#line 8135 "SourceList.c"
}


static gpointer
granite_widgets_source_list_patch_data_model_value_get_item_monitor (const GValue* value)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR), NULL);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return value->data[0].v_pointer;
#line 8146 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_value_set_item_monitor (GValue* value,
                                                                     gpointer v_object)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor * old;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	old = value->data[0].v_pointer;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (v_object) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_item_monitor_ref (value->data[0].v_pointer);
#line 8169 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8173 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (old) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_item_monitor_unref (old);
#line 8179 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_value_take_item_monitor (GValue* value,
                                                                      gpointer v_object)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor * old;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	old = value->data[0].v_pointer;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (v_object) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = v_object;
#line 8201 "SourceList.c"
	} else {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		value->data[0].v_pointer = NULL;
#line 8205 "SourceList.c"
	}
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (old) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_item_monitor_unref (old);
#line 8211 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_item_monitor_class_init (GraniteWidgetsSourceListPatchDataModelItemMonitorClass * klass)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_item_monitor_parent_class = g_type_class_peek_parent (klass);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchDataModelItemMonitorClass *) klass)->finalize = granite_widgets_source_list_patch_data_model_item_monitor_finalize;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchDataModelItemMonitor_private_offset);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_item_monitor_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_CHANGED_SIGNAL] = g_signal_new ("changed", GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_STRING, G_TYPE_NONE, 2, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_TYPE_STRING);
#line 8227 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_item_monitor_instance_init (GraniteWidgetsSourceListPatchDataModelItemMonitor * self)
{
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_data_model_item_monitor_get_instance_private (self);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->ref_count = 1;
#line 8238 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_item_monitor_finalize (GraniteWidgetsSourceListPatchDataModelItemMonitor * obj)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor * self;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	guint _tmp1_;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, GraniteWidgetsSourceListPatchDataModelItemMonitor);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_destroy (self);
#line 691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->item;
#line 691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp1_, NULL, FALSE);
#line 691 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_data_model_item_monitor_on_notify_g_object_notify, self);
#line 683 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->item);
#line 8260 "SourceList.c"
}


/**
             * Helper object used to monitor item property changes.
             */
static GType
granite_widgets_source_list_patch_data_model_item_monitor_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_data_model_item_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_data_model_item_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { granite_widgets_source_list_patch_data_model_value_item_monitor_init, granite_widgets_source_list_patch_data_model_value_item_monitor_free_value, granite_widgets_source_list_patch_data_model_value_item_monitor_copy_value, granite_widgets_source_list_patch_data_model_value_item_monitor_peek_pointer, "p", granite_widgets_source_list_patch_data_model_value_item_monitor_collect_value, "p", granite_widgets_source_list_patch_data_model_value_item_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchDataModelItemMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_data_model_item_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchDataModelItemMonitor), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_data_model_item_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType granite_widgets_source_list_patch_data_model_item_monitor_type_id;
		granite_widgets_source_list_patch_data_model_item_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "GraniteWidgetsSourceListPatchDataModelItemMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		GraniteWidgetsSourceListPatchDataModelItemMonitor_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_data_model_item_monitor_type_id, sizeof (GraniteWidgetsSourceListPatchDataModelItemMonitorPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_data_model_item_monitor_type_id__volatile, granite_widgets_source_list_patch_data_model_item_monitor_type_id);
	}
	return granite_widgets_source_list_patch_data_model_item_monitor_type_id__volatile;
}


static gpointer
granite_widgets_source_list_patch_data_model_item_monitor_ref (gpointer instance)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor * self;
	self = instance;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_atomic_int_inc (&self->ref_count);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return instance;
#line 8293 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_item_monitor_unref (gpointer instance)
{
	GraniteWidgetsSourceListPatchDataModelItemMonitor * self;
	self = instance;
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_MONITOR_GET_CLASS (self)->finalize (self);
#line 681 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8308 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_data_model_class_init (GraniteWidgetsSourceListPatchDataModelClass * klass)
{
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_parent_class = g_type_class_peek_parent (klass);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchDataModel_private_offset);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_data_model_get_property;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_data_model_set_property;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_patch_data_model_constructor;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_data_model_finalize;
#line 8328 "SourceList.c"
	/**
	             * Root item.
	             *
	             * This item is not actually part of the model. It's only used as a proxy
	             * for adding and removing items.
	             */
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY, granite_widgets_source_list_patch_data_model_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY] = g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ITEM_UPDATED_SIGNAL] = g_signal_new ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 8339 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_interface_init (GtkTreeDragSourceIface * iface)
{
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_parent_iface = g_type_interface_peek_parent (iface);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iface->drag_data_get = (gboolean (*) (GtkTreeDragSource*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_patch_data_model_real_drag_data_get;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iface->row_draggable = (gboolean (*) (GtkTreeDragSource*, GtkTreePath*)) granite_widgets_source_list_patch_data_model_real_row_draggable;
#line 8352 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_gtk_tree_drag_dest_interface_init (GtkTreeDragDestIface * iface)
{
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_data_model_gtk_tree_drag_dest_parent_iface = g_type_interface_peek_parent (iface);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iface->drag_data_received = (gboolean (*) (GtkTreeDragDest*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_patch_data_model_real_drag_data_received;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iface->row_drop_possible = (gboolean (*) (GtkTreeDragDest*, GtkTreePath*, GtkSelectionData*)) granite_widgets_source_list_patch_data_model_real_row_drop_possible;
#line 8365 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_instance_init (GraniteWidgetsSourceListPatchDataModel * self)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_data_model_get_instance_private (self);
#line 749 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_NODE_WRAPPER, (GBoxedCopyFunc) granite_widgets_source_list_patch_data_model_node_wrapper_ref, (GDestroyNotify) granite_widgets_source_list_patch_data_model_node_wrapper_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 749 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->items = _tmp0_;
#line 751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gee_hash_map_new (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_TYPE_ITEM_MONITOR, (GBoxedCopyFunc) granite_widgets_source_list_patch_data_model_item_monitor_ref, (GDestroyNotify) granite_widgets_source_list_patch_data_model_item_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->monitors = _tmp1_;
#line 8384 "SourceList.c"
}


static void
granite_widgets_source_list_patch_data_model_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatchDataModel * self;
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModel);
#line 721 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_root);
#line 749 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->items);
#line 751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->monitors);
#line 753 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->child_tree);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_data_model_parent_class)->finalize (obj);
#line 8404 "SourceList.c"
}


/**
         * The model backing the SourceListPatch tree.
         *
         * It monitors item property changes, and handles children additions and removals. It also controls
         * the visibility of the items based on their "visible" property, and on their number of children,
         * if they happen to be categories. Its main purpose is to provide an easy and practical interface
         * for sorting, adding, removing and updating items, eliminating the need of repeatedly dealing with
         * the Gtk.TreeModel API directly.
         */
static GType
granite_widgets_source_list_patch_data_model_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_data_model_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_data_model_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchDataModelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_data_model_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchDataModel), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_data_model_instance_init, NULL };
		static const GInterfaceInfo gtk_tree_drag_source_info = { (GInterfaceInitFunc) granite_widgets_source_list_patch_data_model_gtk_tree_drag_source_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gtk_tree_drag_dest_info = { (GInterfaceInitFunc) granite_widgets_source_list_patch_data_model_gtk_tree_drag_dest_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType granite_widgets_source_list_patch_data_model_type_id;
		granite_widgets_source_list_patch_data_model_type_id = g_type_register_static (gtk_tree_model_filter_get_type (), "GraniteWidgetsSourceListPatchDataModel", &g_define_type_info, 0);
		g_type_add_interface_static (granite_widgets_source_list_patch_data_model_type_id, gtk_tree_drag_source_get_type (), &gtk_tree_drag_source_info);
		g_type_add_interface_static (granite_widgets_source_list_patch_data_model_type_id, gtk_tree_drag_dest_get_type (), &gtk_tree_drag_dest_info);
		GraniteWidgetsSourceListPatchDataModel_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_data_model_type_id, sizeof (GraniteWidgetsSourceListPatchDataModelPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_data_model_type_id__volatile, granite_widgets_source_list_patch_data_model_type_id);
	}
	return granite_widgets_source_list_patch_data_model_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_data_model_get_property (GObject * object,
                                                                 guint property_id,
                                                                 GValue * value,
                                                                 GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModel);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY:
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_data_model_get_root (self));
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8452 "SourceList.c"
		default:
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8458 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_data_model_set_property (GObject * object,
                                                                 guint property_id,
                                                                 const GValue * value,
                                                                 GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchDataModel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, GraniteWidgetsSourceListPatchDataModel);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_DATA_MODEL_ROOT_PROPERTY:
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_data_model_set_root (self, g_value_get_object (value));
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8479 "SourceList.c"
		default:
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 623 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8485 "SourceList.c"
	}
}


static GraniteWidgetsSourceListPatchCellRendererIcon*
granite_widgets_source_list_patch_cell_renderer_icon_construct (GType object_type)
{
	GraniteWidgetsSourceListPatchCellRendererIcon * self = NULL;
#line 1375 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererIcon*) g_object_new (object_type, NULL);
#line 1375 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 8498 "SourceList.c"
}


static GraniteWidgetsSourceListPatchCellRendererIcon*
granite_widgets_source_list_patch_cell_renderer_icon_new (void)
{
#line 1375 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_cell_renderer_icon_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON);
#line 8507 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_cell_renderer_icon_real_activate (GtkCellRenderer* base,
                                                                    GdkEvent* event,
                                                                    GtkWidget* widget,
                                                                    const gchar* path,
                                                                    GdkRectangle* background_area,
                                                                    GdkRectangle* cell_area,
                                                                    GtkCellRendererState flags)
{
	GraniteWidgetsSourceListPatchCellRendererIcon * self;
	gboolean result = FALSE;
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererIcon*) base;
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (background_area != NULL, FALSE);
#line 1384 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (cell_area != NULL, FALSE);
#line 1388 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_emit (self, granite_widgets_source_list_patch_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_ACTIVATED_SIGNAL], 0, path);
#line 1389 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = TRUE;
#line 1389 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 8540 "SourceList.c"
}


static GObject *
granite_widgets_source_list_patch_cell_renderer_icon_constructor (GType type,
                                                                  guint n_construct_properties,
                                                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListPatchCellRendererIcon * self;
#line 1379 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_patch_cell_renderer_icon_parent_class);
#line 1379 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1379 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON, GraniteWidgetsSourceListPatchCellRendererIcon);
#line 1380 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) self, "mode", GTK_CELL_RENDERER_MODE_ACTIVATABLE, NULL);
#line 1381 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRendererPixbuf*) self, "stock-size", (guint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_ICON_SIZE, NULL);
#line 1379 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return obj;
#line 8564 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_icon_class_init (GraniteWidgetsSourceListPatchCellRendererIconClass * klass)
{
#line 1370 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_cell_renderer_icon_parent_class = g_type_class_peek_parent (klass);
#line 1370 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->activate = (gboolean (*) (GtkCellRenderer*, GdkEvent*, GtkWidget*, const gchar*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_patch_cell_renderer_icon_real_activate;
#line 1370 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_patch_cell_renderer_icon_constructor;
#line 1370 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_cell_renderer_icon_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_ICON_ACTIVATED_SIGNAL] = g_signal_new ("activated", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 8579 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_icon_instance_init (GraniteWidgetsSourceListPatchCellRendererIcon * self)
{
}


/**
         * Class responsible for rendering Item.icon and Item.activatable. It also
         * notifies about clicks through the activated() signal.
         */
static GType
granite_widgets_source_list_patch_cell_renderer_icon_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_cell_renderer_icon_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_cell_renderer_icon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchCellRendererIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_cell_renderer_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchCellRendererIcon), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_cell_renderer_icon_instance_init, NULL };
		GType granite_widgets_source_list_patch_cell_renderer_icon_type_id;
		granite_widgets_source_list_patch_cell_renderer_icon_type_id = g_type_register_static (gtk_cell_renderer_pixbuf_get_type (), "GraniteWidgetsSourceListPatchCellRendererIcon", &g_define_type_info, 0);
		g_once_init_leave (&granite_widgets_source_list_patch_cell_renderer_icon_type_id__volatile, granite_widgets_source_list_patch_cell_renderer_icon_type_id);
	}
	return granite_widgets_source_list_patch_cell_renderer_icon_type_id__volatile;
}


static inline gpointer
granite_widgets_source_list_patch_cell_renderer_spacer_get_instance_private (GraniteWidgetsSourceListPatchCellRendererSpacer* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchCellRendererSpacer_private_offset);
}


static GtkSizeRequestMode
granite_widgets_source_list_patch_cell_renderer_spacer_real_get_request_mode (GtkCellRenderer* base)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	GtkSizeRequestMode result = 0;
#line 1404 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) base;
#line 1405 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 1405 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 8625 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_width (GtkCellRenderer* base,
                                                                                 GtkWidget* widget,
                                                                                 gint* min_size,
                                                                                 gint* natural_size)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	gint _vala_min_size = 0;
	gint _vala_natural_size = 0;
	guint _tmp0_;
	guint _tmp1_;
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) base;
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1409 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_get ((GtkCellRenderer*) self, "xpad", &_tmp0_, NULL);
#line 1409 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1409 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_natural_size = 2 * ((gint) _tmp1_);
#line 1409 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_min_size = _vala_natural_size;
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (min_size) {
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*min_size = _vala_min_size;
#line 8656 "SourceList.c"
	}
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (natural_size) {
#line 1408 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*natural_size = _vala_natural_size;
#line 8662 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                                            GtkWidget* widget,
                                                                                            gint width,
                                                                                            gint* min_height,
                                                                                            gint* natural_height)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	gint _vala_min_height = 0;
	gint _vala_natural_height = 0;
	guint _tmp0_;
	guint _tmp1_;
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) base;
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_get ((GtkCellRenderer*) self, "ypad", &_tmp0_, NULL);
#line 1415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_natural_height = 2 * ((gint) _tmp1_);
#line 1415 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_min_height = _vala_natural_height;
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (min_height) {
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*min_height = _vala_min_height;
#line 8695 "SourceList.c"
	}
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (natural_height) {
#line 1412 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*natural_height = _vala_natural_height;
#line 8701 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_real_render (GtkCellRenderer* base,
                                                                    cairo_t* context,
                                                                    GtkWidget* widget,
                                                                    GdkRectangle* bg_area,
                                                                    GdkRectangle* cell_area,
                                                                    GtkCellRendererState flags)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
#line 1418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) base;
#line 1418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (context != NULL);
#line 1418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (bg_area != NULL);
#line 1418 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (cell_area != NULL);
#line 8725 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_real_get_size (GtkCellRenderer* base,
                                                                      GtkWidget* widget,
                                                                      GdkRectangle* cell_area,
                                                                      gint* x_offset,
                                                                      gint* y_offset,
                                                                      gint* width,
                                                                      gint* height)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) base;
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (widget != NULL);
#line 1429 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_assert_not_reached ();
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (x_offset) {
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*x_offset = _vala_x_offset;
#line 8753 "SourceList.c"
	}
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (y_offset) {
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*y_offset = _vala_y_offset;
#line 8759 "SourceList.c"
	}
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (width) {
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*width = _vala_width;
#line 8765 "SourceList.c"
	}
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (height) {
#line 1425 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*height = _vala_height;
#line 8771 "SourceList.c"
	}
}


static GraniteWidgetsSourceListPatchCellRendererSpacer*
granite_widgets_source_list_patch_cell_renderer_spacer_construct (GType object_type)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self = NULL;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchCellRendererSpacer*) g_object_new (object_type, NULL);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 8784 "SourceList.c"
}


static GraniteWidgetsSourceListPatchCellRendererSpacer*
granite_widgets_source_list_patch_cell_renderer_spacer_new (void)
{
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_cell_renderer_spacer_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER);
#line 8793 "SourceList.c"
}


static gint
granite_widgets_source_list_patch_cell_renderer_spacer_get_level (GraniteWidgetsSourceListPatchCellRendererSpacer* self)
{
	gint result;
	gint _tmp0_;
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_level;
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 8810 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_set_level (GraniteWidgetsSourceListPatchCellRendererSpacer* self,
                                                                  gint value)
{
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_cell_renderer_spacer_get_level (self) != value) {
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_level = value;
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY]);
#line 8826 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_class_init (GraniteWidgetsSourceListPatchCellRendererSpacerClass * klass)
{
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_cell_renderer_spacer_parent_class = g_type_class_peek_parent (klass);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchCellRendererSpacer_private_offset);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer*)) granite_widgets_source_list_patch_cell_renderer_spacer_real_get_request_mode;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint*, gint*)) granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_width;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint, gint*, gint*)) granite_widgets_source_list_patch_cell_renderer_spacer_real_get_preferred_height_for_width;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) granite_widgets_source_list_patch_cell_renderer_spacer_real_render;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer*, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) granite_widgets_source_list_patch_cell_renderer_spacer_real_get_size;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_cell_renderer_spacer_get_property;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_cell_renderer_spacer_set_property;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_cell_renderer_spacer_finalize;
#line 8854 "SourceList.c"
	/**
	             * Indentation level represented by this cell renderer
	             */
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY, granite_widgets_source_list_patch_cell_renderer_spacer_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY] = g_param_spec_int ("level", "level", "level", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8860 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_instance_init (GraniteWidgetsSourceListPatchCellRendererSpacer * self)
{
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_cell_renderer_spacer_get_instance_private (self);
#line 1402 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->_level = -1;
#line 8871 "SourceList.c"
}


static void
granite_widgets_source_list_patch_cell_renderer_spacer_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacer);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_cell_renderer_spacer_parent_class)->finalize (obj);
#line 8883 "SourceList.c"
}


/**
         * A cell renderer that only adds space.
         */
static GType
granite_widgets_source_list_patch_cell_renderer_spacer_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_cell_renderer_spacer_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_cell_renderer_spacer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchCellRendererSpacerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_cell_renderer_spacer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchCellRendererSpacer), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_cell_renderer_spacer_instance_init, NULL };
		GType granite_widgets_source_list_patch_cell_renderer_spacer_type_id;
		granite_widgets_source_list_patch_cell_renderer_spacer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "GraniteWidgetsSourceListPatchCellRendererSpacer", &g_define_type_info, 0);
		GraniteWidgetsSourceListPatchCellRendererSpacer_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_cell_renderer_spacer_type_id, sizeof (GraniteWidgetsSourceListPatchCellRendererSpacerPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_cell_renderer_spacer_type_id__volatile, granite_widgets_source_list_patch_cell_renderer_spacer_type_id);
	}
	return granite_widgets_source_list_patch_cell_renderer_spacer_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_cell_renderer_spacer_get_property (GObject * object,
                                                                           guint property_id,
                                                                           GValue * value,
                                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacer);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY:
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_int (value, granite_widgets_source_list_patch_cell_renderer_spacer_get_level (self));
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8921 "SourceList.c"
		default:
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8927 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_cell_renderer_spacer_set_property (GObject * object,
                                                                           guint property_id,
                                                                           const GValue * value,
                                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, GraniteWidgetsSourceListPatchCellRendererSpacer);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_CELL_RENDERER_SPACER_LEVEL_PROPERTY:
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_cell_renderer_spacer_set_level (self, g_value_get_int (value));
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8948 "SourceList.c"
		default:
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1398 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 8954 "SourceList.c"
	}
}


static inline gpointer
granite_widgets_source_list_patch_tree_get_instance_private (GraniteWidgetsSourceListPatchTree* self)
{
	return G_STRUCT_MEMBER_P (self, GraniteWidgetsSourceListPatchTree_private_offset);
}


static GType
granite_widgets_source_list_patch_tree_column_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_tree_column_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_tree_column_type_id__volatile)) {
		static const GEnumValue values[] = {{GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM, "GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM", "item"}, {GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_N_COLS, "GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_N_COLS", "n-cols"}, {0, NULL, NULL}};
		GType granite_widgets_source_list_patch_tree_column_type_id;
		granite_widgets_source_list_patch_tree_column_type_id = g_enum_register_static ("GraniteWidgetsSourceListPatchTreeColumn", values);
		g_once_init_leave (&granite_widgets_source_list_patch_tree_column_type_id__volatile, granite_widgets_source_list_patch_tree_column_type_id);
	}
	return granite_widgets_source_list_patch_tree_column_type_id__volatile;
}


static GraniteWidgetsSourceListPatchTree*
granite_widgets_source_list_patch_tree_construct (GType object_type,
                                                  GraniteWidgetsSourceListPatchDataModel* data_model)
{
	GraniteWidgetsSourceListPatchTree * self = NULL;
#line 1511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (data_model != NULL, NULL);
#line 1512 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) g_object_new (object_type, "data-model", data_model, NULL);
#line 1511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self;
#line 8991 "SourceList.c"
}


static GraniteWidgetsSourceListPatchTree*
granite_widgets_source_list_patch_tree_new (GraniteWidgetsSourceListPatchDataModel* data_model)
{
#line 1511 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return granite_widgets_source_list_patch_tree_construct (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, data_model);
#line 9000 "SourceList.c"
}


static gpointer
_gtk_target_list_ref0 (gpointer self)
{
#line 1648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return self ? gtk_target_list_ref (self) : NULL;
#line 9009 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_real_drag_motion (GtkWidget* base,
                                                         GdkDragContext* context,
                                                         gint x,
                                                         gint y,
                                                         guint time)
{
	GraniteWidgetsSourceListPatchTree * self;
	gboolean result = FALSE;
	GtkTreePath* suggested_path = NULL;
	GtkTreePath* current_path = NULL;
	GtkTreeViewDropPosition suggested_pos = 0;
	GtkTreeViewDropPosition current_pos = 0;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreeViewDropPosition _tmp1_ = 0;
	gboolean _tmp2_;
#line 1606 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 1606 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1608 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->drag_motion ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), context, x, y, time)) {
#line 1609 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1609 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 9039 "SourceList.c"
	}
#line 1614 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, x, y, &_tmp0_, &_tmp1_);
#line 1614 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (suggested_path);
#line 1614 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	suggested_path = _tmp0_;
#line 1614 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	suggested_pos = _tmp1_;
#line 1614 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_) {
#line 9051 "SourceList.c"
		GtkTreePath* _tmp3_ = NULL;
		GtkTreeViewDropPosition _tmp4_ = 0;
		gboolean _tmp5_ = FALSE;
		GtkTreePath* _tmp6_;
#line 1618 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp3_, &_tmp4_);
#line 1618 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (current_path);
#line 1618 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		current_path = _tmp3_;
#line 1618 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		current_pos = _tmp4_;
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = current_path;
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp6_ != NULL) {
#line 9068 "SourceList.c"
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = suggested_path;
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = current_path;
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = gtk_tree_path_compare (_tmp7_, _tmp8_) == 0;
#line 9077 "SourceList.c"
		} else {
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = FALSE;
#line 9081 "SourceList.c"
		}
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 9085 "SourceList.c"
			GtkWidget* source_widget = NULL;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp10_;
			gboolean dragging_treemodel_row = FALSE;
			GtkWidget* _tmp11_;
			gboolean _tmp12_;
#line 1624 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = gtk_drag_get_source_widget (context);
#line 1624 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1624 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			source_widget = _tmp10_;
#line 1625 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = source_widget;
#line 1625 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dragging_treemodel_row = _tmp11_ == G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget);
#line 1627 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = dragging_treemodel_row;
#line 1627 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp12_) {
#line 9106 "SourceList.c"
				GtkTreeViewDropPosition _tmp13_;
#line 1630 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp13_ = current_pos;
#line 1630 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp13_ != GTK_TREE_VIEW_DROP_BEFORE) {
#line 9112 "SourceList.c"
					GtkTreeViewDropPosition _tmp14_;
#line 1631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp14_ = current_pos;
#line 1631 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp14_ == GTK_TREE_VIEW_DROP_INTO_OR_BEFORE) {
#line 9118 "SourceList.c"
						GtkTreePath* _tmp15_;
#line 1632 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp15_ = current_path;
#line 1632 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp15_, GTK_TREE_VIEW_DROP_BEFORE);
#line 9124 "SourceList.c"
					} else {
#line 1634 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
#line 9128 "SourceList.c"
					}
				}
			} else {
				GtkTreeViewDropPosition _tmp16_;
				GraniteWidgetsSourceListPatchDragDest* dest = NULL;
				GraniteWidgetsSourceListPatchDataModel* _tmp20_;
				GtkTreePath* _tmp21_;
				GraniteWidgetsSourceListPatchItem* _tmp22_;
				GraniteWidgetsSourceListPatchDragDest* _tmp23_;
				GraniteWidgetsSourceListPatchDragDest* _tmp24_;
#line 1639 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp16_ = current_pos;
#line 1639 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp16_ == GTK_TREE_VIEW_DROP_BEFORE) {
#line 9143 "SourceList.c"
					GtkTreePath* _tmp17_;
#line 1640 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp17_ = current_path;
#line 1640 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp17_, GTK_TREE_VIEW_DROP_INTO_OR_BEFORE);
#line 9149 "SourceList.c"
				} else {
					GtkTreeViewDropPosition _tmp18_;
#line 1641 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp18_ = current_pos;
#line 1641 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp18_ == GTK_TREE_VIEW_DROP_AFTER) {
#line 9156 "SourceList.c"
						GtkTreePath* _tmp19_;
#line 1642 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp19_ = current_path;
#line 1642 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, _tmp19_, GTK_TREE_VIEW_DROP_INTO_OR_AFTER);
#line 9162 "SourceList.c"
					}
				}
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp20_ = self->priv->_data_model;
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp21_ = current_path;
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp22_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp20_, _tmp21_);
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp23_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp22_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST) ? ((GraniteWidgetsSourceListPatchDragDest*) _tmp22_) : NULL;
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp23_ == NULL) {
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_g_object_unref0 (_tmp22_);
#line 9177 "SourceList.c"
				}
#line 1645 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				dest = _tmp23_;
#line 1647 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp24_ = dest;
#line 1647 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp24_ != NULL) {
#line 9185 "SourceList.c"
					GtkTargetList* target_list = NULL;
					GtkTargetList* _tmp25_;
					GtkTargetList* _tmp26_;
					GdkAtom target = 0U;
					GtkTargetList* _tmp27_;
					GdkAtom _tmp28_;
#line 1648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp25_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
#line 1648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp26_ = _gtk_target_list_ref0 (_tmp25_);
#line 1648 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					target_list = _tmp26_;
#line 1649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp27_ = target_list;
#line 1649 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					target = gtk_drag_dest_find_target ((GtkWidget*) self, context, _tmp27_);
#line 1653 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					g_object_set_data_full ((GObject*) context, "suggested-dnd-action", (gpointer) ((gintptr) ((gint) gdk_drag_context_get_suggested_action (context))), NULL);
#line 1654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp28_ = target;
#line 1654 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					gtk_drag_get_data ((GtkWidget*) self, context, _tmp28_, (guint32) time);
#line 1647 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_gtk_target_list_unref0 (target_list);
#line 9210 "SourceList.c"
				} else {
#line 1657 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
#line 9214 "SourceList.c"
				}
#line 1627 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (dest);
#line 9218 "SourceList.c"
			}
#line 1620 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (source_widget);
#line 9222 "SourceList.c"
		}
	} else {
#line 1663 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_AFTER);
#line 1664 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1664 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (current_path);
#line 1664 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (suggested_path);
#line 1664 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 9235 "SourceList.c"
	}
#line 1667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = TRUE;
#line 1667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (current_path);
#line 1667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (suggested_path);
#line 1667 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 9245 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_real_drag_data_received (GtkWidget* base,
                                                                GdkDragContext* context,
                                                                gint x,
                                                                gint y,
                                                                GtkSelectionData* selection_data,
                                                                guint info,
                                                                guint time)
{
	GraniteWidgetsSourceListPatchTree * self;
	GtkTargetList* target_list = NULL;
	GtkTargetList* _tmp0_;
	GtkTargetList* _tmp1_;
	GdkAtom target = 0U;
	GtkTargetList* _tmp2_;
	GdkAtom _tmp3_;
	GtkTreePath* path = NULL;
	GtkTreeViewDropPosition pos = 0;
	gconstpointer _tmp4_;
#line 1670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 1670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (context != NULL);
#line 1670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (selection_data != NULL);
#line 1674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_drag_dest_get_target_list ((GtkWidget*) self);
#line 1674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _gtk_target_list_ref0 (_tmp0_);
#line 1674 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	target_list = _tmp1_;
#line 1675 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = target_list;
#line 1675 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	target = gtk_drag_dest_find_target ((GtkWidget*) self, context, _tmp2_);
#line 1677 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = target;
#line 1677 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ == gdk_atom_intern_static_string ("GTK_TREE_MODEL_ROW")) {
#line 1678 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->drag_data_received ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), context, x, y, selection_data, info, time);
#line 1679 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_gtk_target_list_unref0 (target_list);
#line 1679 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return;
#line 9294 "SourceList.c"
	}
#line 1685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = g_object_get_data ((GObject*) context, "suggested-dnd-action");
#line 1685 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (((gint) ((gintptr) _tmp4_)) != 0) {
#line 9300 "SourceList.c"
		GtkTreePath* _tmp5_ = NULL;
		GtkTreeViewDropPosition _tmp6_ = 0;
		GtkTreePath* _tmp7_;
#line 1686 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set_data_full ((GObject*) context, "suggested-dnd-action", (gpointer) ((gintptr) 0), NULL);
#line 1688 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_get_drag_dest_row ((GtkTreeView*) self, &_tmp5_, &_tmp6_);
#line 1688 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 1688 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp5_;
#line 1688 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		pos = _tmp6_;
#line 1690 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = path;
#line 1690 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 9318 "SourceList.c"
			GraniteWidgetsSourceListPatchDragDest* dest = NULL;
			GraniteWidgetsSourceListPatchDataModel* _tmp8_;
			GtkTreePath* _tmp9_;
			GraniteWidgetsSourceListPatchItem* _tmp10_;
			GraniteWidgetsSourceListPatchDragDest* _tmp11_;
			gboolean _tmp12_ = FALSE;
			GraniteWidgetsSourceListPatchDragDest* _tmp13_;
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = self->priv->_data_model;
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = path;
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp8_, _tmp9_);
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST) ? ((GraniteWidgetsSourceListPatchDragDest*) _tmp10_) : NULL;
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp11_ == NULL) {
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_tmp10_);
#line 9338 "SourceList.c"
			}
#line 1692 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			dest = _tmp11_;
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = dest;
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp13_ == NULL) {
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp12_ = TRUE;
#line 9348 "SourceList.c"
			} else {
				GraniteWidgetsSourceListPatchDragDest* _tmp14_;
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp14_ = dest;
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp12_ = !granite_widgets_source_list_patch_drag_dest_data_drop_possible (_tmp14_, context, selection_data);
#line 9355 "SourceList.c"
			}
#line 1694 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp12_) {
#line 1697 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_tree_view_set_drag_dest_row ((GtkTreeView*) self, NULL, GTK_TREE_VIEW_DROP_BEFORE);
#line 1698 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gdk_drag_status (context, 0, (guint32) time);
#line 1699 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (dest);
#line 1699 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1699 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_gtk_target_list_unref0 (target_list);
#line 1699 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				return;
#line 9371 "SourceList.c"
			}
#line 1690 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (dest);
#line 9375 "SourceList.c"
		}
#line 1703 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gdk_drag_status (context, gdk_drag_context_get_suggested_action (context), (guint32) time);
#line 9379 "SourceList.c"
	} else {
		GtkTreePath* _tmp15_ = NULL;
		GtkTreeViewDropPosition _tmp16_ = 0;
		gboolean _tmp17_;
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = gtk_tree_view_get_dest_row_at_pos ((GtkTreeView*) self, x, y, &_tmp15_, &_tmp16_);
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp15_;
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		pos = _tmp16_;
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp17_) {
#line 9394 "SourceList.c"
			GraniteWidgetsSourceListPatchDragDest* drag_dest = NULL;
			GraniteWidgetsSourceListPatchDataModel* _tmp18_;
			GtkTreePath* _tmp19_;
			GraniteWidgetsSourceListPatchItem* _tmp20_;
			GraniteWidgetsSourceListPatchDragDest* _tmp21_;
			GraniteWidgetsSourceListPatchDragDest* _tmp22_;
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp18_ = self->priv->_data_model;
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp19_ = path;
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp20_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp18_, _tmp19_);
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH_DRAG_DEST) ? ((GraniteWidgetsSourceListPatchDragDest*) _tmp20_) : NULL;
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp21_ == NULL) {
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_tmp20_);
#line 9413 "SourceList.c"
			}
#line 1711 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			drag_dest = _tmp21_;
#line 1713 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp22_ = drag_dest;
#line 1713 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp22_ != NULL) {
#line 9421 "SourceList.c"
				GdkDragAction action = 0;
				GraniteWidgetsSourceListPatchDragDest* _tmp23_;
				GdkDragAction _tmp24_;
				GdkDragAction _tmp25_;
#line 1714 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp23_ = drag_dest;
#line 1714 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				action = granite_widgets_source_list_patch_drag_dest_data_received (_tmp23_, context, selection_data);
#line 1715 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp24_ = action;
#line 1715 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp25_ = action;
#line 1715 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_drag_finish (context, _tmp24_ != 0, _tmp25_ == GDK_ACTION_MOVE, (guint32) time);
#line 1716 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (drag_dest);
#line 1716 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 1716 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_gtk_target_list_unref0 (target_list);
#line 1716 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				return;
#line 9444 "SourceList.c"
			}
#line 1705 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (drag_dest);
#line 9448 "SourceList.c"
		}
#line 1721 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_drag_finish (context, FALSE, FALSE, (guint32) time);
#line 9452 "SourceList.c"
	}
#line 1670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 1670 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_gtk_target_list_unref0 (target_list);
#line 9458 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_configure_drag_source (GraniteWidgetsSourceListPatchTree* self,
                                                              GtkTargetEntry* src_entries,
                                                              int src_entries_length1)
{
	GtkTargetEntry* entries = NULL;
	gint _tmp0_ = 0;
	GtkTargetEntry* _tmp1_;
	gint entries_length1;
	gint _entries_size_;
#line 1725 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1727 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_append_row_target_entry (src_entries, src_entries_length1, &_tmp0_);
#line 1727 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries = _tmp1_;
#line 1727 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries_length1 = _tmp0_;
#line 1727 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1729 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_unset_rows_drag_source ((GtkTreeView*) self);
#line 1730 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_enable_model_drag_source ((GtkTreeView*) self, GDK_BUTTON1_MASK, entries, entries_length1, GDK_ACTION_MOVE);
#line 1725 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries = (g_free (entries), NULL);
#line 9488 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_configure_drag_dest (GraniteWidgetsSourceListPatchTree* self,
                                                            GtkTargetEntry* dest_entries,
                                                            int dest_entries_length1,
                                                            GdkDragAction actions)
{
	GtkTargetEntry* entries = NULL;
	gint _tmp0_ = 0;
	GtkTargetEntry* _tmp1_;
	gint entries_length1;
	gint _entries_size_;
#line 1733 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_append_row_target_entry (dest_entries, dest_entries_length1, &_tmp0_);
#line 1735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries = _tmp1_;
#line 1735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries_length1 = _tmp0_;
#line 1735 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1737 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_unset_rows_drag_dest ((GtkTreeView*) self);
#line 1740 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_enable_model_drag_dest ((GtkTreeView*) self, entries, entries_length1, GDK_ACTION_MOVE | actions);
#line 1733 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries = (g_free (entries), NULL);
#line 9519 "SourceList.c"
}


static void
_vala_array_add1 (GtkTargetEntry* * array,
                  int* length,
                  int* size,
                  const GtkTargetEntry* value)
{
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if ((*length) == (*size)) {
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 9535 "SourceList.c"
	}
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	(*array)[(*length)++] = *value;
#line 9539 "SourceList.c"
}


static void
_vala_array_add2 (GtkTargetEntry* * array,
                  int* length,
                  int* size,
                  const GtkTargetEntry* value)
{
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if ((*length) == (*size)) {
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*array = g_renew (GtkTargetEntry, *array, *size);
#line 9555 "SourceList.c"
	}
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	(*array)[(*length)++] = *value;
#line 9559 "SourceList.c"
}


static GtkTargetEntry*
granite_widgets_source_list_patch_tree_append_row_target_entry (GtkTargetEntry* orig,
                                                                int orig_length1,
                                                                int* result_length1)
{
	GtkTargetEntry* result = NULL;
#line 1744 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	static const GtkTargetEntry row_target_entry = {"GTK_TREE_MODEL_ROW", (guint) GTK_TARGET_SAME_WIDGET, (guint) 0};
#line 9571 "SourceList.c"
	GtkTargetEntry* entries = NULL;
	GtkTargetEntry* _tmp0_;
	gint entries_length1;
	gint _entries_size_;
	GtkTargetEntry* _tmp1_;
	gint _tmp1__length1;
	GtkTargetEntry* _tmp4_;
	gint _tmp4__length1;
#line 1747 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = g_new0 (GtkTargetEntry, 0);
#line 1747 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries = _tmp0_;
#line 1747 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	entries_length1 = 0;
#line 1747 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_entries_size_ = entries_length1;
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = entries;
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1__length1 = entries_length1;
#line 1748 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_array_add1 (&entries, &entries_length1, &_entries_size_, &row_target_entry);
#line 1750 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (orig != NULL) {
#line 9596 "SourceList.c"
		{
			GtkTargetEntry* target_entry_collection = NULL;
			gint target_entry_collection_length1 = 0;
			gint _target_entry_collection_size_ = 0;
			gint target_entry_it = 0;
#line 1751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			target_entry_collection = orig;
#line 1751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			target_entry_collection_length1 = orig_length1;
#line 1751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			for (target_entry_it = 0; target_entry_it < orig_length1; target_entry_it = target_entry_it + 1) {
#line 9608 "SourceList.c"
				GtkTargetEntry target_entry = {0};
#line 1751 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				target_entry = target_entry_collection[target_entry_it];
#line 9612 "SourceList.c"
				{
					GtkTargetEntry* _tmp2_;
					gint _tmp2__length1;
					GtkTargetEntry _tmp3_;
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp2_ = entries;
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp2__length1 = entries_length1;
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp3_ = target_entry;
#line 1752 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_vala_array_add2 (&entries, &entries_length1, &_entries_size_, &_tmp3_);
#line 9625 "SourceList.c"
				}
			}
		}
	}
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = entries;
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4__length1 = entries_length1;
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (result_length1) {
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		*result_length1 = _tmp4__length1;
#line 9638 "SourceList.c"
	}
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp4_;
#line 1755 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 9644 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_on_model_item_updated_granite_widgets_source_list_patch_data_model_item_updated (GraniteWidgetsSourceListPatchDataModel* _sender,
                                                                                                                         GraniteWidgetsSourceListPatchItem* item,
                                                                                                                         gpointer self)
{
#line 1759 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_model_item_updated ((GraniteWidgetsSourceListPatchTree*) self, item);
#line 9655 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_enable_item_property_monitor (GraniteWidgetsSourceListPatchTree* self)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 1758 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1759 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1759 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (_tmp0_, "item-updated", (GCallback) _granite_widgets_source_list_patch_tree_on_model_item_updated_granite_widgets_source_list_patch_data_model_item_updated, self, G_CONNECT_AFTER);
#line 9669 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_disable_item_property_monitor (GraniteWidgetsSourceListPatchTree* self)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	guint _tmp1_;
#line 1762 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1763 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1763 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_parse_name ("item-updated", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, &_tmp1_, NULL, FALSE);
#line 1763 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_tree_on_model_item_updated_granite_widgets_source_list_patch_data_model_item_updated, self);
#line 9686 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_on_model_item_updated (GraniteWidgetsSourceListPatchTree* self,
                                                              GraniteWidgetsSourceListPatchItem* item)
{
	GraniteWidgetsSourceListPatchExpandableItem* expandable_item = NULL;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp0_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp1_;
#line 1766 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1766 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 1769 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (item, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) item) : NULL);
#line 1769 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	expandable_item = _tmp0_;
#line 1770 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = expandable_item;
#line 1770 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 9709 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* _tmp2_;
#line 1771 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = expandable_item;
#line 1771 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_update_expansion (self, _tmp2_);
#line 9715 "SourceList.c"
	}
#line 1766 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (expandable_item);
#line 9719 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_spacer_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                         GtkCellRenderer* cell,
                                                                                         GtkTreeModel* tree_model,
                                                                                         GtkTreeIter* iter,
                                                                                         gpointer self)
{
#line 1815 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_spacer_cell_data_func (cell_layout, cell, tree_model, iter);
#line 9732 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_add_spacer_cell_for_level (GraniteWidgetsSourceListPatchTree* self,
                                                                  gint level,
                                                                  gboolean check_previous)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp2_;
#line 1774 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1774 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_if_fail (level > 0, "level > 0");
#line 1777 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->spacer_cells;
#line 1777 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_ == NULL) {
#line 9751 "SourceList.c"
		GeeHashMap* _tmp1_;
#line 1778 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1778 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->spacer_cells);
#line 1778 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->spacer_cells = _tmp1_;
#line 9759 "SourceList.c"
	}
#line 1780 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->spacer_cells;
#line 1780 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) level))) {
#line 9765 "SourceList.c"
		GraniteWidgetsSourceListPatchCellRendererSpacer* spacer_cell = NULL;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp3_;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp4_;
		GeeHashMap* _tmp5_;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp6_;
		guint cell_xpadding = 0U;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp11_;
		guint _tmp12_;
		GtkTreeViewColumn* item_column = NULL;
		GtkTreeViewColumn* _tmp13_;
		GtkTreeViewColumn* _tmp14_;
		GtkTreeViewColumn* _tmp15_;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp16_;
		GtkTreeViewColumn* _tmp17_;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp18_;
#line 1781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = granite_widgets_source_list_patch_cell_renderer_spacer_new ();
#line 1781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_ref_sink (_tmp3_);
#line 1781 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		spacer_cell = _tmp3_;
#line 1782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = spacer_cell;
#line 1782 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_cell_renderer_spacer_set_level (_tmp4_, level);
#line 1783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = self->priv->spacer_cells;
#line 1783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = spacer_cell;
#line 1783 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) level), _tmp6_);
#line 1793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		switch (level) {
#line 1793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			case 1:
#line 9801 "SourceList.c"
			{
				gint left_padding = 0;
				gint _tmp7_ = 0;
				gint _tmp8_;
#line 1796 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEFT_PADDING, &_tmp7_, NULL);
#line 1796 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				left_padding = _tmp7_;
#line 1797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp8_ = left_padding;
#line 1797 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				cell_xpadding = (guint) (_tmp8_ / 2);
#line 1798 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 9816 "SourceList.c"
			}
#line 1793 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			case 2:
#line 9820 "SourceList.c"
			{
#line 1801 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				cell_xpadding = (guint) 0;
#line 1802 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 9826 "SourceList.c"
			}
			default:
			{
				gint level_indentation = 0;
				gint _tmp9_ = 0;
				gint _tmp10_;
#line 1806 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEVEL_INDENTATION, &_tmp9_, NULL);
#line 1806 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				level_indentation = _tmp9_;
#line 1807 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = level_indentation;
#line 1807 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				cell_xpadding = (guint) (_tmp10_ / 2);
#line 1808 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 9843 "SourceList.c"
			}
		}
#line 1811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp11_ = spacer_cell;
#line 1811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = cell_xpadding;
#line 1811 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set ((GtkCellRenderer*) _tmp11_, "xpad", _tmp12_, NULL);
#line 1813 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 1813 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 1813 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item_column = _tmp14_;
#line 1814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = item_column;
#line 1814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp16_ = spacer_cell;
#line 1814 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp15_, (GtkCellRenderer*) _tmp16_, FALSE);
#line 1815 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = item_column;
#line 1815 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = spacer_cell;
#line 1815 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp17_, (GtkCellRenderer*) _tmp18_, _granite_widgets_source_list_patch_tree_spacer_cell_data_func_gtk_cell_layout_data_func, NULL, NULL);
#line 1818 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (check_previous) {
#line 9872 "SourceList.c"
			{
				gint i = 0;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				i = level - 1;
#line 9877 "SourceList.c"
				{
					gboolean _tmp19_ = FALSE;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp19_ = TRUE;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					while (TRUE) {
#line 9884 "SourceList.c"
						gint _tmp21_;
						gint _tmp22_;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (!_tmp19_) {
#line 9889 "SourceList.c"
							gint _tmp20_;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp20_ = i;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							i = _tmp20_ - 1;
#line 9895 "SourceList.c"
						}
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp19_ = FALSE;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp21_ = i;
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (!(_tmp21_ > 0)) {
#line 1819 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							break;
#line 9905 "SourceList.c"
						}
#line 1820 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp22_ = i;
#line 1820 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						granite_widgets_source_list_patch_tree_add_spacer_cell_for_level (self, _tmp22_, FALSE);
#line 9911 "SourceList.c"
					}
				}
			}
		}
#line 1780 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (item_column);
#line 1780 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (spacer_cell);
#line 9920 "SourceList.c"
	}
}


/**
             * Evaluates whether the item at the specified path can be selected or not.
             */
static gboolean
granite_widgets_source_list_patch_tree_select_func (GraniteWidgetsSourceListPatchTree* self,
                                                    GtkTreeSelection* selection,
                                                    GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    gboolean path_currently_selected)
{
	gboolean result = FALSE;
	gboolean selectable = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 1828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (selection != NULL, FALSE);
#line 1828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 1828 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 1831 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	selectable = FALSE;
#line 1832 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1832 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp0_, path);
#line 1832 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp1_;
#line 1834 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = item;
#line 1834 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 9961 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = item;
#line 1835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_item_get_selectable (_tmp3_);
#line 1835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1835 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		selectable = _tmp5_;
#line 9973 "SourceList.c"
	}
#line 1838 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = selectable;
#line 1838 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 1838 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 9981 "SourceList.c"
}


static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 9990 "SourceList.c"
}


static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 9999 "SourceList.c"
}


static GtkTreePath*
granite_widgets_source_list_patch_tree_get_selected_path (GraniteWidgetsSourceListPatchTree* self)
{
	GtkTreePath* result = NULL;
	GtkTreePath* selected_path = NULL;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp0_;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp2_;
#line 1841 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1842 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	selected_path = NULL;
#line 1843 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1843 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1843 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	selection = _tmp1_;
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = selection;
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10026 "SourceList.c"
		GtkTreeModel* model = NULL;
		GList* selected_rows = NULL;
		GtkTreeSelection* _tmp3_;
		GtkTreeModel* _tmp4_ = NULL;
		GList* _tmp5_;
		GtkTreeModel* _tmp6_;
		GList* _tmp7_;
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = selection;
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = gtk_tree_selection_get_selected_rows (_tmp3_, &_tmp4_);
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = _g_object_ref0 (_tmp4_);
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		model = _tmp6_;
#line 1847 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		selected_rows = _tmp5_;
#line 1848 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = selected_rows;
#line 1848 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (g_list_length (_tmp7_) == ((guint) 1)) {
#line 10050 "SourceList.c"
			GList* _tmp8_;
			gconstpointer _tmp9_;
			GtkTreePath* _tmp10_;
#line 1849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = selected_rows;
#line 1849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = g_list_nth_data (_tmp8_, (guint) 0);
#line 1849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) _tmp9_);
#line 1849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (selected_path);
#line 1849 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			selected_path = _tmp10_;
#line 10064 "SourceList.c"
		}
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		(selected_rows == NULL) ? NULL : (selected_rows = (_g_list_free___vala_GtkTreePath_free0_ (selected_rows), NULL));
#line 1845 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (model);
#line 10070 "SourceList.c"
	}
#line 1852 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = selected_path;
#line 1852 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (selection);
#line 1852 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 10078 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_set_selected (GraniteWidgetsSourceListPatchTree* self,
                                                     GraniteWidgetsSourceListPatchItem* item,
                                                     gboolean scroll_to_item)
{
#line 1855 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1856 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (item == NULL) {
#line 10091 "SourceList.c"
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp0_;
		GtkTreeSelection* _tmp1_;
		GtkTreeSelection* _tmp2_;
#line 1857 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1857 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1857 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		selection = _tmp1_;
#line 1858 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = selection;
#line 1858 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp2_ != NULL) {
#line 10106 "SourceList.c"
			GtkTreeSelection* _tmp3_;
#line 1859 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp3_ = selection;
#line 1859 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_selection_unselect_all (_tmp3_);
#line 10112 "SourceList.c"
		}
#line 1870 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->selected);
#line 1870 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->selected = NULL;
#line 1871 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_patch_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ITEM_SELECTED_SIGNAL], 0, NULL);
#line 1856 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (selection);
#line 10122 "SourceList.c"
	} else {
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1872 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_item_get_selectable (item);
#line 1872 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1872 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 10132 "SourceList.c"
			GtkTreePath* to_select = NULL;
			GraniteWidgetsSourceListPatchDataModel* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
#line 1873 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (scroll_to_item) {
#line 1874 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_tree_scroll_to_item (self, item, FALSE, (gfloat) 0);
#line 10141 "SourceList.c"
			}
#line 1876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = self->priv->_data_model;
#line 1876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp6_, item);
#line 1876 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			to_select = _tmp7_;
#line 1877 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = to_select;
#line 1877 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp8_ != NULL) {
#line 10153 "SourceList.c"
				GtkTreePath* _tmp9_;
				GtkTreeViewColumn* _tmp10_;
				GtkCellRendererText* _tmp11_;
#line 1878 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp9_ = to_select;
#line 1878 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 1878 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp11_ = self->priv->text_cell;
#line 1878 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp9_, _tmp10_, (GtkCellRenderer*) _tmp11_, FALSE);
#line 10165 "SourceList.c"
			}
#line 1872 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			__vala_GtkTreePath_free0 (to_select);
#line 10169 "SourceList.c"
		}
	}
}


static void
granite_widgets_source_list_patch_tree_real_cursor_changed (GtkTreeView* base)
{
	GraniteWidgetsSourceListPatchTree * self;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_ = NULL;
	GtkTreePath* _tmp2_;
	GraniteWidgetsSourceListPatchItem* new_item = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp6_;
	gboolean _tmp7_ = FALSE;
	GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 1882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 1883 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_tree_get_selected_path (self);
#line 1883 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp0_;
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = path;
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10197 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModel* _tmp3_;
		GtkTreePath* _tmp4_;
		GraniteWidgetsSourceListPatchItem* _tmp5_;
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = self->priv->_data_model;
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = path;
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp3_, _tmp4_);
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp1_);
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _tmp5_;
#line 10211 "SourceList.c"
	} else {
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp1_);
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = NULL;
#line 10217 "SourceList.c"
	}
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = _g_object_ref0 (_tmp1_);
#line 1884 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	new_item = _tmp6_;
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = new_item;
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp8_ != NULL) {
#line 10227 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp9_;
		GraniteWidgetsSourceListPatchItem* _tmp10_;
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = new_item;
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp10_ = self->priv->selected;
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = _tmp9_ != _tmp10_;
#line 10236 "SourceList.c"
	} else {
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = FALSE;
#line 10240 "SourceList.c"
	}
#line 1897 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp7_) {
#line 10244 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp11_;
		GraniteWidgetsSourceListPatchItem* _tmp12_;
		GraniteWidgetsSourceListPatchItem* _tmp13_;
#line 1898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp11_ = new_item;
#line 1898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 1898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->selected);
#line 1898 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->selected = _tmp12_;
#line 1899 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = new_item;
#line 1899 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (self, granite_widgets_source_list_patch_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ITEM_SELECTED_SIGNAL], 0, _tmp13_);
#line 10260 "SourceList.c"
	}
#line 1882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (new_item);
#line 1882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (_tmp1_);
#line 1882 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 10268 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_scroll_to_item (GraniteWidgetsSourceListPatchTree* self,
                                                       GraniteWidgetsSourceListPatchItem* item,
                                                       gboolean use_align,
                                                       gfloat row_align)
{
	gboolean result = FALSE;
	gboolean scrolled = FALSE;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
#line 1903 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1903 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1904 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	scrolled = FALSE;
#line 1906 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1906 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp0_, item);
#line 1906 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp1_;
#line 1907 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = path;
#line 1907 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10300 "SourceList.c"
		GtkTreePath* _tmp3_;
#line 1908 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = path;
#line 1908 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_scroll_to_cell ((GtkTreeView*) self, _tmp3_, NULL, use_align, row_align, (gfloat) 0);
#line 1909 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		scrolled = TRUE;
#line 10308 "SourceList.c"
	}
#line 1912 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = scrolled;
#line 1912 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 1912 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 10316 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_start_editing_item (GraniteWidgetsSourceListPatchTree* self,
                                                           GraniteWidgetsSourceListPatchItem* item)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp8_;
	GtkTreePath* _tmp9_;
	GtkTreePath* _tmp10_;
	gboolean _tmp17_;
	gboolean _tmp18_;
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_item_get_editable (item);
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (_tmp1_, "item.editable", FALSE);
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_item_get_selectable (item);
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 1915 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_return_val_if_fail (_tmp3_, "item.selectable", FALSE);
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = granite_widgets_source_list_patch_tree_get_editing (self);
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = _tmp5_;
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp6_) {
#line 10360 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp7_;
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = self->priv->edited;
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = item == _tmp7_;
#line 10366 "SourceList.c"
	} else {
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = FALSE;
#line 10370 "SourceList.c"
	}
#line 1916 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_) {
#line 1917 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 1917 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 10378 "SourceList.c"
	}
#line 1919 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = self->priv->_data_model;
#line 1919 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp8_, item);
#line 1919 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp9_;
#line 1920 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = path;
#line 1920 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp10_ != NULL) {
#line 10390 "SourceList.c"
		GtkCellRendererText* _tmp11_;
		GtkTreePath* _tmp12_;
		GtkTreeViewColumn* _tmp13_;
		GtkCellRendererText* _tmp14_;
#line 1921 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->edited = item;
#line 1922 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp11_ = self->priv->text_cell;
#line 1922 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set (_tmp11_, "editable", TRUE, NULL);
#line 1923 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = path;
#line 1923 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 1923 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = self->priv->text_cell;
#line 1923 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp12_, _tmp13_, (GtkCellRenderer*) _tmp14_, TRUE);
#line 10409 "SourceList.c"
	} else {
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 1925 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = granite_widgets_source_list_patch_item_get_name (item);
#line 1925 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp16_ = _tmp15_;
#line 1925 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_warning ("SourceList.vala:1925: Could not edit \"%s\": path not found", _tmp16_);
#line 10419 "SourceList.c"
	}
#line 1928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp17_ = granite_widgets_source_list_patch_tree_get_editing (self);
#line 1928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp18_ = _tmp17_;
#line 1928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp18_;
#line 1928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 1928 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 10431 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_stop_editing (GraniteWidgetsSourceListPatchTree* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1931 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_get_editing (self);
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_) {
#line 10449 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp3_;
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = self->priv->edited;
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 10455 "SourceList.c"
	} else {
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 10459 "SourceList.c"
	}
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 10463 "SourceList.c"
		GtkTreePath* path = NULL;
		GraniteWidgetsSourceListPatchDataModel* _tmp4_;
		GraniteWidgetsSourceListPatchItem* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreePath* _tmp7_;
#line 1933 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = self->priv->_data_model;
#line 1933 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = self->priv->edited;
#line 1933 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp4_, _tmp5_);
#line 1933 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp6_;
#line 1937 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = path;
#line 1937 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp7_ != NULL) {
#line 10481 "SourceList.c"
			GtkTreePath* _tmp8_;
			GtkTreeViewColumn* _tmp9_;
			GtkCellRendererText* _tmp10_;
#line 1938 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = path;
#line 1938 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 1938 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = self->priv->text_cell;
#line 1938 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_view_set_cursor_on_cell ((GtkTreeView*) self, _tmp8_, _tmp9_, (GtkCellRenderer*) _tmp10_, FALSE);
#line 10493 "SourceList.c"
		}
#line 1932 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 10497 "SourceList.c"
	}
}


static void
_granite_widgets_source_list_patch_tree_on_editing_done_gtk_cell_editable_editing_done (GtkCellEditable* _sender,
                                                                                        gpointer self)
{
#line 1945 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_editing_done ((GraniteWidgetsSourceListPatchTree*) self);
#line 10508 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_on_editing_started (GraniteWidgetsSourceListPatchTree* self,
                                                           GtkCellEditable* editable,
                                                           const gchar* path)
{
	GtkEntry* _tmp0_;
	GtkEntry* _tmp1_;
#line 1942 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1942 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (editable != NULL);
#line 1942 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 1943 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (editable, gtk_entry_get_type ()) ? ((GtkEntry*) editable) : NULL);
#line 1943 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->editable_entry);
#line 1943 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->editable_entry = _tmp0_;
#line 1944 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->editable_entry;
#line 1944 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 10535 "SourceList.c"
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
#line 1945 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = self->priv->editable_entry;
#line 1945 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_connect_object ((GtkCellEditable*) _tmp2_, "editing-done", (GCallback) _granite_widgets_source_list_patch_tree_on_editing_done_gtk_cell_editable_editing_done, self, 0);
#line 1946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = self->priv->editable_entry;
#line 1946 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set (_tmp3_, "editable", TRUE, NULL);
#line 10546 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_tree_on_editing_canceled (GraniteWidgetsSourceListPatchTree* self)
{
	GtkEntry* _tmp0_;
	GtkCellRendererText* _tmp4_;
#line 1950 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1951 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->editable_entry;
#line 1951 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_ != NULL) {
#line 10562 "SourceList.c"
		GtkEntry* _tmp1_;
		GtkEntry* _tmp2_;
		guint _tmp3_;
#line 1952 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = self->priv->editable_entry;
#line 1952 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set (_tmp1_, "editable", FALSE, NULL);
#line 1953 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = self->priv->editable_entry;
#line 1953 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_parse_name ("editing-done", gtk_cell_editable_get_type (), &_tmp3_, NULL, FALSE);
#line 1953 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_handlers_disconnect_matched ((GtkCellEditable*) _tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _granite_widgets_source_list_patch_tree_on_editing_done_gtk_cell_editable_editing_done, self);
#line 10576 "SourceList.c"
	}
#line 1956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = self->priv->text_cell;
#line 1956 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp4_, "editable", FALSE, NULL);
#line 1957 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->edited = NULL;
#line 10584 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_on_editing_done (GraniteWidgetsSourceListPatchTree* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 1960 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->edited;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10600 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = self->priv->edited;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_item_get_editable (_tmp3_);
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _tmp5_;
#line 10612 "SourceList.c"
	} else {
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = FALSE;
#line 10616 "SourceList.c"
	}
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 10620 "SourceList.c"
		GtkEntry* _tmp6_;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = self->priv->editable_entry;
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp6_ != NULL;
#line 10626 "SourceList.c"
	} else {
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 10630 "SourceList.c"
	}
#line 1961 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 10634 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
#line 1962 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = self->priv->edited;
#line 1962 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = self->priv->editable_entry;
#line 1962 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 1962 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (_tmp7_, granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_EDITED_SIGNAL], 0, _tmp9_);
#line 10646 "SourceList.c"
	}
#line 1965 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_editing_canceled (self);
#line 10650 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_on_activatable_activated (GraniteWidgetsSourceListPatchTree* self,
                                                                 const gchar* item_path_str)
{
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
#line 1968 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1968 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item_path_str != NULL);
#line 1969 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_tree_get_item_from_path_string (self, item_path_str);
#line 1969 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp0_;
#line 1970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = item;
#line 1970 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 10673 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 1971 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = item;
#line 1971 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_signal_emit (_tmp2_, granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTION_ACTIVATED_SIGNAL], 0);
#line 10679 "SourceList.c"
	}
#line 1968 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 10683 "SourceList.c"
}


static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_tree_get_item_from_path_string (GraniteWidgetsSourceListPatchTree* self,
                                                                  const gchar* item_path_str)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GtkTreePath* item_path = NULL;
	GtkTreePath* _tmp0_;
	GraniteWidgetsSourceListPatchDataModel* _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 1974 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1974 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item_path_str != NULL, NULL);
#line 1975 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_tree_path_new_from_string (item_path_str);
#line 1975 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item_path = _tmp0_;
#line 1976 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->_data_model;
#line 1976 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp1_, item_path);
#line 1976 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 1976 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (item_path);
#line 1976 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 10714 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_toggle_expansion (GraniteWidgetsSourceListPatchTree* self,
                                                         GraniteWidgetsSourceListPatchExpandableItem* item)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1979 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1979 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 1980 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_expandable_item_get_collapsible (item);
#line 1980 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1980 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 10735 "SourceList.c"
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 1981 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_expandable_item_get_expanded (item);
#line 1981 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = _tmp2_;
#line 1981 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_expandable_item_set_expanded (item, !_tmp3_);
#line 1982 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = TRUE;
#line 1982 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 10748 "SourceList.c"
	}
#line 1984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 1984 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 10754 "SourceList.c"
}


/**
             * Updates the tree to reflect the ''expanded'' property of expandable_item.
             */
static void
granite_widgets_source_list_patch_tree_update_expansion (GraniteWidgetsSourceListPatchTree* self,
                                                         GraniteWidgetsSourceListPatchExpandableItem* expandable_item)
{
	GtkTreePath* path = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp2_;
#line 1990 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1990 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (expandable_item != NULL);
#line 1991 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1991 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_data_model_get_item_path (_tmp0_, (GraniteWidgetsSourceListPatchItem*) expandable_item);
#line 1991 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp1_;
#line 1993 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = path;
#line 1993 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 10783 "SourceList.c"
		GtkTreePath* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1997 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = path;
#line 1997 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_add_spacer_cell_for_level (self, gtk_tree_path_get_depth (_tmp3_) + 1, TRUE);
#line 1999 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = granite_widgets_source_list_patch_expandable_item_get_expanded (expandable_item);
#line 1999 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = _tmp4_;
#line 1999 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_) {
#line 10797 "SourceList.c"
			GtkTreePath* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GraniteWidgetsSourceListPatchItem* _tmp8_;
#line 2000 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = path;
#line 2000 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_view_expand_row ((GtkTreeView*) self, _tmp6_, FALSE);
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = self->priv->selected;
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp8_ != NULL) {
#line 10809 "SourceList.c"
				GraniteWidgetsSourceListPatchItem* _tmp9_;
				GraniteWidgetsSourceListPatchExpandableItem* _tmp10_;
				GraniteWidgetsSourceListPatchExpandableItem* _tmp11_;
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp9_ = self->priv->selected;
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = granite_widgets_source_list_patch_item_get_parent (_tmp9_);
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp11_ = _tmp10_;
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp7_ = _tmp11_ == expandable_item;
#line 10821 "SourceList.c"
			} else {
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp7_ = FALSE;
#line 10825 "SourceList.c"
			}
#line 2008 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp7_) {
#line 10829 "SourceList.c"
				GraniteWidgetsSourceListPatchItem* _tmp12_;
#line 2009 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp12_ = self->priv->selected;
#line 2009 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_tree_set_selected (self, _tmp12_, TRUE);
#line 10835 "SourceList.c"
			}
			{
				GeeIterator* _child_item_it = NULL;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeCollection* _tmp15_;
				GeeIterator* _tmp16_;
				GeeIterator* _tmp17_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp13_ = granite_widgets_source_list_patch_expandable_item_get_children (expandable_item);
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp14_ = _tmp13_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp15_ = _tmp14_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp16_ = gee_iterable_iterator ((GeeIterable*) _tmp15_);
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp17_ = _tmp16_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_tmp15_);
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_child_item_it = _tmp17_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				while (TRUE) {
#line 10860 "SourceList.c"
					GeeIterator* _tmp18_;
					GraniteWidgetsSourceListPatchItem* child_item = NULL;
					GeeIterator* _tmp19_;
					gpointer _tmp20_;
					GraniteWidgetsSourceListPatchExpandableItem* child_expandable_item = NULL;
					GraniteWidgetsSourceListPatchItem* _tmp21_;
					GraniteWidgetsSourceListPatchExpandableItem* _tmp22_;
					GraniteWidgetsSourceListPatchExpandableItem* _tmp23_;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp18_ = _child_item_it;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (!gee_iterator_next (_tmp18_)) {
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						break;
#line 10875 "SourceList.c"
					}
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp19_ = _child_item_it;
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp20_ = gee_iterator_get (_tmp19_);
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					child_item = (GraniteWidgetsSourceListPatchItem*) _tmp20_;
#line 2015 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp21_ = child_item;
#line 2015 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp21_) : NULL);
#line 2015 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					child_expandable_item = _tmp22_;
#line 2016 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp23_ = child_expandable_item;
#line 2016 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp23_ != NULL) {
#line 10893 "SourceList.c"
						GraniteWidgetsSourceListPatchExpandableItem* _tmp24_;
#line 2017 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp24_ = child_expandable_item;
#line 2017 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						granite_widgets_source_list_patch_tree_update_expansion (self, _tmp24_);
#line 10899 "SourceList.c"
					}
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_g_object_unref0 (child_expandable_item);
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_g_object_unref0 (child_item);
#line 10905 "SourceList.c"
				}
#line 2014 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_child_item_it);
#line 10909 "SourceList.c"
			}
		} else {
			GtkTreePath* _tmp25_;
#line 2020 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp25_ = path;
#line 2020 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_tree_view_collapse_row ((GtkTreeView*) self, _tmp25_);
#line 10917 "SourceList.c"
		}
	}
#line 1990 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 10922 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_real_row_expanded (GtkTreeView* base,
                                                          GtkTreeIter* iter,
                                                          GtkTreePath* path)
{
	GraniteWidgetsSourceListPatchTree * self;
	GraniteWidgetsSourceListPatchExpandableItem* item = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
#line 2025 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2025 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2025 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *iter;
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_data_model_get_item (_tmp0_, &_tmp1_);
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp2_) : NULL;
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ == NULL) {
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 10955 "SourceList.c"
	}
#line 2026 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp3_;
#line 2027 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 2029 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_disable_item_property_monitor (self);
#line 2030 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expanded (item, TRUE);
#line 2031 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_enable_item_property_monitor (self);
#line 2025 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 10969 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_real_row_collapsed (GtkTreeView* base,
                                                           GtkTreeIter* iter,
                                                           GtkTreePath* path)
{
	GraniteWidgetsSourceListPatchTree * self;
	GraniteWidgetsSourceListPatchExpandableItem* item = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
	GraniteWidgetsSourceListPatchExpandableItem* _tmp3_;
#line 2034 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2034 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2034 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *iter;
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_data_model_get_item (_tmp0_, &_tmp1_);
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp2_) : NULL;
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp3_ == NULL) {
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (_tmp2_);
#line 11002 "SourceList.c"
	}
#line 2035 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp3_;
#line 2036 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (item != NULL);
#line 2038 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_disable_item_property_monitor (self);
#line 2039 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_expandable_item_set_expanded (item, FALSE);
#line 2040 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_enable_item_property_monitor (self);
#line 2034 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 11016 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_real_row_activated (GtkTreeView* base,
                                                           GtkTreePath* path,
                                                           GtkTreeViewColumn* column)
{
	GraniteWidgetsSourceListPatchTree * self;
	GtkTreeViewColumn* _tmp0_;
#line 2043 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2043 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (path != NULL);
#line 2043 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (column != NULL);
#line 2044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 2044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (column == _tmp0_) {
#line 11037 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* item = NULL;
		GraniteWidgetsSourceListPatchDataModel* _tmp1_;
		GraniteWidgetsSourceListPatchItem* _tmp2_;
		GraniteWidgetsSourceListPatchItem* _tmp3_;
#line 2045 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = self->priv->_data_model;
#line 2045 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp1_, path);
#line 2045 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item = _tmp2_;
#line 2046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = item;
#line 2046 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp3_ != NULL) {
#line 11052 "SourceList.c"
			GraniteWidgetsSourceListPatchItem* _tmp4_;
#line 2047 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp4_ = item;
#line 2047 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_signal_emit (_tmp4_, granite_widgets_source_list_patch_item_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_ACTIVATED_SIGNAL], 0);
#line 11058 "SourceList.c"
		}
#line 2044 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (item);
#line 11062 "SourceList.c"
	}
}


static gboolean
granite_widgets_source_list_patch_tree_real_key_release_event (GtkWidget* base,
                                                               GdkEventKey* event)
{
	GraniteWidgetsSourceListPatchTree * self;
	gboolean result = FALSE;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
#line 2051 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2051 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2052 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_tree_get_selected_item (self);
#line 2052 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2052 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_ != NULL) {
#line 11085 "SourceList.c"
		guint _tmp2_;
#line 2053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = event->keyval;
#line 2053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		switch (_tmp2_) {
#line 2053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			case GDK_KEY_F2:
#line 11093 "SourceList.c"
			{
				GdkModifierType modifiers = 0;
				gboolean _tmp3_ = FALSE;
				GdkModifierType _tmp4_;
				GdkModifierType _tmp5_;
#line 2055 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				modifiers = gtk_accelerator_get_default_mod_mask ();
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp4_ = event->state;
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp5_ = modifiers;
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if ((_tmp4_ & _tmp5_) == 0) {
#line 11107 "SourceList.c"
					GraniteWidgetsSourceListPatchItem* _tmp6_;
					GraniteWidgetsSourceListPatchItem* _tmp7_;
					gboolean _tmp8_;
					gboolean _tmp9_;
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp6_ = granite_widgets_source_list_patch_tree_get_selected_item (self);
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp7_ = _tmp6_;
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp8_ = granite_widgets_source_list_patch_item_get_editable (_tmp7_);
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp9_ = _tmp8_;
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp3_ = _tmp9_;
#line 11122 "SourceList.c"
				} else {
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp3_ = FALSE;
#line 11126 "SourceList.c"
				}
#line 2057 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp3_) {
#line 11130 "SourceList.c"
					GraniteWidgetsSourceListPatchItem* _tmp10_;
					GraniteWidgetsSourceListPatchItem* _tmp11_;
#line 2058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp10_ = granite_widgets_source_list_patch_tree_get_selected_item (self);
#line 2058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp11_ = _tmp10_;
#line 2058 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					granite_widgets_source_list_patch_tree_start_editing_item (self, _tmp11_);
#line 11139 "SourceList.c"
				}
#line 2059 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				break;
#line 11143 "SourceList.c"
			}
			default:
#line 2053 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			break;
#line 11148 "SourceList.c"
		}
	}
#line 2063 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->key_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2063 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 11155 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_real_button_release_event (GtkWidget* base,
                                                                  GdkEventButton* event)
{
	GraniteWidgetsSourceListPatchTree * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 2066 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2066 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = self->priv->unselectable_item_clicked;
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp1_) {
#line 11175 "SourceList.c"
		GdkWindow* _tmp2_;
		GdkWindow* _tmp3_;
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = event->window;
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _tmp2_ == _tmp3_;
#line 11184 "SourceList.c"
	} else {
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = FALSE;
#line 11188 "SourceList.c"
	}
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_) {
#line 11192 "SourceList.c"
		GtkTreePath* path = NULL;
		GtkTreeViewColumn* column = NULL;
		gint x = 0;
		gdouble _tmp4_;
		gint y = 0;
		gdouble _tmp5_;
		gint cell_x = 0;
		gint cell_y = 0;
		gint _tmp6_;
		gint _tmp7_;
		GtkTreePath* _tmp8_ = NULL;
		GtkTreeViewColumn* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gboolean _tmp12_;
		GtkTreeViewColumn* _tmp13_;
#line 2068 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->unselectable_item_clicked = FALSE;
#line 2072 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = event->x;
#line 2072 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		x = (gint) _tmp4_;
#line 2072 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = event->y;
#line 2072 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		y = (gint) _tmp5_;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = x;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = y;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp6_, _tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		path = _tmp8_;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (column);
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = _g_object_ref0 (_tmp9_);
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		column = _tmp13_;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		cell_x = _tmp10_;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		cell_y = _tmp11_;
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp12_) {
#line 11241 "SourceList.c"
			GraniteWidgetsSourceListPatchExpandableItem* item = NULL;
			GraniteWidgetsSourceListPatchDataModel* _tmp14_;
			GtkTreePath* _tmp15_;
			GraniteWidgetsSourceListPatchItem* _tmp16_;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp17_;
			GraniteWidgetsSourceListPatchExpandableItem* _tmp18_;
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = self->priv->_data_model;
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp15_ = path;
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp14_, _tmp15_);
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp16_) : NULL;
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp17_ == NULL) {
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (_tmp16_);
#line 11260 "SourceList.c"
			}
#line 2075 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			item = _tmp17_;
#line 2077 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp18_ = item;
#line 2077 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp18_ != NULL) {
#line 11268 "SourceList.c"
				gboolean _tmp19_ = FALSE;
				GraniteWidgetsSourceListPatchExpandableItem* _tmp20_;
				gboolean _tmp21_;
				gboolean _tmp22_;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp20_ = item;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp21_ = granite_widgets_source_list_patch_item_get_selectable ((GraniteWidgetsSourceListPatchItem*) _tmp20_);
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp22_ = _tmp21_;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (!_tmp22_) {
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp19_ = TRUE;
#line 11283 "SourceList.c"
				} else {
					GraniteWidgetsSourceListPatchDataModel* _tmp23_;
					GraniteWidgetsSourceListPatchExpandableItem* _tmp24_;
					GtkTreePath* _tmp25_;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp23_ = self->priv->_data_model;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp24_ = item;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp25_ = path;
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp19_ = granite_widgets_source_list_patch_data_model_is_category (_tmp23_, (GraniteWidgetsSourceListPatchItem*) _tmp24_, NULL, _tmp25_);
#line 11296 "SourceList.c"
				}
#line 2078 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp19_) {
#line 11300 "SourceList.c"
					GraniteWidgetsSourceListPatchExpandableItem* _tmp26_;
#line 2079 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp26_ = item;
#line 2079 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					granite_widgets_source_list_patch_tree_toggle_expansion (self, _tmp26_);
#line 11306 "SourceList.c"
				}
			}
#line 2074 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (item);
#line 11311 "SourceList.c"
		}
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (column);
#line 2067 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		__vala_GtkTreePath_free0 (path);
#line 11317 "SourceList.c"
	}
#line 2084 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2084 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 11323 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_real_button_press_event (GtkWidget* base,
                                                                GdkEventButton* event)
{
	GraniteWidgetsSourceListPatchTree * self;
	gboolean result = FALSE;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GtkTreePath* path = NULL;
	GtkTreeViewColumn* column = NULL;
	gint x = 0;
	gdouble _tmp2_;
	gint y = 0;
	gdouble _tmp3_;
	gint cell_x = 0;
	gint cell_y = 0;
	gint _tmp4_;
	gint _tmp5_;
	GtkTreePath* _tmp6_ = NULL;
	GtkTreeViewColumn* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gboolean _tmp10_;
	GtkTreeViewColumn* _tmp11_;
#line 2087 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2087 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = event->window;
#line 2088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = gtk_tree_view_get_bin_window ((GtkTreeView*) self);
#line 2088 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp0_ != _tmp1_) {
#line 2089 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2089 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 11365 "SourceList.c"
	}
#line 2093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = event->x;
#line 2093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	x = (gint) _tmp2_;
#line 2093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = event->y;
#line 2093 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	y = (gint) _tmp3_;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = x;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = y;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, _tmp4_, _tmp5_, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp6_;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (column);
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp11_ = _g_object_ref0 (_tmp7_);
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	column = _tmp11_;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	cell_x = _tmp8_;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	cell_y = _tmp9_;
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp10_) {
#line 11397 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* item = NULL;
		GraniteWidgetsSourceListPatchDataModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GraniteWidgetsSourceListPatchItem* _tmp14_;
		GdkRectangle start_cell_area = {0};
		GtkTreePath* _tmp15_;
		GtkTreeViewColumn* _tmp16_;
		GdkRectangle _tmp17_ = {0};
		gint _tmp18_;
		GdkRectangle _tmp19_;
		gint _tmp20_;
		gboolean _tmp21_ = FALSE;
		GraniteWidgetsSourceListPatchItem* _tmp22_;
#line 2096 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp12_ = self->priv->_data_model;
#line 2096 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = path;
#line 2096 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = granite_widgets_source_list_patch_data_model_get_item_from_path (_tmp12_, _tmp13_);
#line 2096 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item = _tmp14_;
#line 2100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = path;
#line 2100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp16_ = gtk_tree_view_get_column ((GtkTreeView*) self, 0);
#line 2100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_tree_view_get_cell_area ((GtkTreeView*) self, _tmp15_, _tmp16_, &_tmp17_);
#line 2100 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		start_cell_area = _tmp17_;
#line 2101 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = cell_x;
#line 2101 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = start_cell_area;
#line 2101 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp20_ = _tmp19_.x;
#line 2101 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		cell_x = _tmp18_ - _tmp20_;
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp22_ = item;
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp22_ != NULL) {
#line 11439 "SourceList.c"
			GtkTreeViewColumn* _tmp23_;
			GtkTreeViewColumn* _tmp24_;
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp23_ = column;
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp24_ = gtk_tree_view_get_column ((GtkTreeView*) self, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = _tmp23_ == _tmp24_;
#line 11448 "SourceList.c"
		} else {
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = FALSE;
#line 11452 "SourceList.c"
		}
#line 2103 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp21_) {
#line 11456 "SourceList.c"
			guint _tmp25_;
#line 2105 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			granite_widgets_source_list_patch_tree_stop_editing (self);
#line 2107 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp25_ = event->button;
#line 2107 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp25_ == ((guint) GDK_BUTTON_SECONDARY)) {
#line 11464 "SourceList.c"
				GraniteWidgetsSourceListPatchItem* _tmp26_;
#line 2108 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp26_ = item;
#line 2108 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				granite_widgets_source_list_patch_tree_popup_context_menu (self, _tmp26_, event);
#line 2109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				result = TRUE;
#line 2109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (item);
#line 2109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (column);
#line 2109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				__vala_GtkTreePath_free0 (path);
#line 2109 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				return result;
#line 11480 "SourceList.c"
			} else {
				guint _tmp27_;
#line 2110 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp27_ = event->button;
#line 2110 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				if (_tmp27_ == ((guint) GDK_BUTTON_PRIMARY)) {
#line 11487 "SourceList.c"
					gboolean is_expandable = FALSE;
					GraniteWidgetsSourceListPatchItem* _tmp28_;
					gboolean _tmp29_ = FALSE;
					gboolean _tmp30_;
					gboolean is_category = FALSE;
					GdkEventType _tmp34_;
#line 2112 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp28_ = item;
#line 2112 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					is_expandable = G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM);
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp30_ = is_expandable;
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp30_) {
#line 11502 "SourceList.c"
						GraniteWidgetsSourceListPatchDataModel* _tmp31_;
						GraniteWidgetsSourceListPatchItem* _tmp32_;
						GtkTreePath* _tmp33_;
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp31_ = self->priv->_data_model;
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp32_ = item;
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp33_ = path;
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp29_ = granite_widgets_source_list_patch_data_model_is_category (_tmp31_, _tmp32_, NULL, _tmp33_);
#line 11514 "SourceList.c"
					} else {
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp29_ = FALSE;
#line 11518 "SourceList.c"
					}
#line 2113 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					is_category = _tmp29_;
#line 2115 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					_tmp34_ = event->type;
#line 2115 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
					if (_tmp34_ == GDK_BUTTON_PRESS) {
#line 11526 "SourceList.c"
						gboolean _tmp35_;
#line 2116 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp35_ = is_expandable;
#line 2116 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp35_) {
#line 11532 "SourceList.c"
							gboolean _tmp36_ = FALSE;
							gboolean _tmp37_;
							gboolean _tmp46_ = FALSE;
							gboolean _tmp47_ = FALSE;
							gboolean _tmp48_;
#line 2122 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp37_ = is_category;
#line 2122 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							if (_tmp37_) {
#line 2122 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp36_ = TRUE;
#line 11544 "SourceList.c"
							} else {
								gboolean _tmp38_ = FALSE;
								GraniteWidgetsSourceListPatchItem* _tmp39_;
								gboolean _tmp40_;
								gboolean _tmp41_;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp39_ = item;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp40_ = granite_widgets_source_list_patch_item_get_selectable (_tmp39_);
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp41_ = _tmp40_;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								if (!_tmp41_) {
#line 11558 "SourceList.c"
									GtkTreeViewColumn* _tmp42_;
									GtkTreePath* _tmp43_;
									GraniteWidgetsSourceListPatchCellRendererIcon* _tmp44_;
									gint _tmp45_;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp42_ = column;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp43_ = path;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp44_ = self->priv->activatable_cell;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp45_ = cell_x;
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp38_ = !granite_widgets_source_list_patch_tree_over_cell (self, _tmp42_, _tmp43_, (GtkCellRenderer*) _tmp44_, _tmp45_);
#line 11573 "SourceList.c"
								} else {
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
									_tmp38_ = FALSE;
#line 11577 "SourceList.c"
								}
#line 2123 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp36_ = _tmp38_;
#line 11581 "SourceList.c"
							}
#line 2122 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							self->priv->unselectable_item_clicked = _tmp36_;
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp48_ = self->priv->unselectable_item_clicked;
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							if (!_tmp48_) {
#line 11589 "SourceList.c"
								GtkTreeViewColumn* _tmp49_;
								GtkTreePath* _tmp50_;
								gint _tmp51_;
#line 2126 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp49_ = column;
#line 2126 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp50_ = path;
#line 2126 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp51_ = cell_x;
#line 2126 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp47_ = granite_widgets_source_list_patch_tree_over_primary_expander (self, _tmp49_, _tmp50_, _tmp51_);
#line 11601 "SourceList.c"
							} else {
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp47_ = FALSE;
#line 11605 "SourceList.c"
							}
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							if (_tmp47_) {
#line 11609 "SourceList.c"
								GraniteWidgetsSourceListPatchItem* _tmp52_;
#line 2127 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp52_ = item;
#line 2127 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp46_ = granite_widgets_source_list_patch_tree_toggle_expansion (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp52_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp52_) : NULL);
#line 11615 "SourceList.c"
							} else {
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_tmp46_ = FALSE;
#line 11619 "SourceList.c"
							}
#line 2125 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							if (_tmp46_) {
#line 2128 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								result = TRUE;
#line 2128 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_g_object_unref0 (item);
#line 2128 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								_g_object_unref0 (column);
#line 2128 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								__vala_GtkTreePath_free0 (path);
#line 2128 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
								return result;
#line 11633 "SourceList.c"
							}
						}
					} else {
						gboolean _tmp53_ = FALSE;
						gboolean _tmp54_ = FALSE;
						gboolean _tmp55_ = FALSE;
						gboolean _tmp56_ = FALSE;
						gboolean _tmp57_ = FALSE;
						GdkEventType _tmp58_;
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						_tmp58_ = event->type;
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp58_ == GDK_2BUTTON_PRESS) {
#line 11647 "SourceList.c"
							gboolean _tmp59_;
#line 2131 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp59_ = is_category;
#line 2131 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp57_ = !_tmp59_;
#line 11653 "SourceList.c"
						} else {
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp57_ = FALSE;
#line 11657 "SourceList.c"
						}
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp57_) {
#line 11661 "SourceList.c"
							GraniteWidgetsSourceListPatchItem* _tmp60_;
							gboolean _tmp61_;
							gboolean _tmp62_;
#line 2132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp60_ = item;
#line 2132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp61_ = granite_widgets_source_list_patch_item_get_editable (_tmp60_);
#line 2132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp62_ = _tmp61_;
#line 2132 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp56_ = _tmp62_;
#line 11673 "SourceList.c"
						} else {
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp56_ = FALSE;
#line 11677 "SourceList.c"
						}
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp56_) {
#line 11681 "SourceList.c"
							GraniteWidgetsSourceListPatchItem* _tmp63_;
							gboolean _tmp64_;
							gboolean _tmp65_;
#line 2133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp63_ = item;
#line 2133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp64_ = granite_widgets_source_list_patch_item_get_selectable (_tmp63_);
#line 2133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp65_ = _tmp64_;
#line 2133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp55_ = _tmp65_;
#line 11693 "SourceList.c"
						} else {
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp55_ = FALSE;
#line 11697 "SourceList.c"
						}
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp55_) {
#line 11701 "SourceList.c"
							GtkTreeViewColumn* _tmp66_;
							GtkTreePath* _tmp67_;
							GtkCellRendererText* _tmp68_;
							gint _tmp69_;
#line 2134 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp66_ = column;
#line 2134 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp67_ = path;
#line 2134 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp68_ = self->priv->text_cell;
#line 2134 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp69_ = cell_x;
#line 2134 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp54_ = granite_widgets_source_list_patch_tree_over_cell (self, _tmp66_, _tmp67_, (GtkCellRenderer*) _tmp68_, _tmp69_);
#line 11716 "SourceList.c"
						} else {
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp54_ = FALSE;
#line 11720 "SourceList.c"
						}
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp54_) {
#line 11724 "SourceList.c"
							GraniteWidgetsSourceListPatchItem* _tmp70_;
#line 2135 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp70_ = item;
#line 2135 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp53_ = granite_widgets_source_list_patch_tree_start_editing_item (self, _tmp70_);
#line 11730 "SourceList.c"
						} else {
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_tmp53_ = FALSE;
#line 11734 "SourceList.c"
						}
#line 2130 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
						if (_tmp53_) {
#line 2138 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							result = TRUE;
#line 2138 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_g_object_unref0 (item);
#line 2138 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							_g_object_unref0 (column);
#line 2138 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							__vala_GtkTreePath_free0 (path);
#line 2138 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
							return result;
#line 11748 "SourceList.c"
						}
					}
				}
			}
		}
#line 2095 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (item);
#line 11756 "SourceList.c"
	}
#line 2144 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = GTK_WIDGET_CLASS (granite_widgets_source_list_patch_tree_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 2144 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (column);
#line 2144 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2144 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 11766 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_over_primary_expander (GraniteWidgetsSourceListPatchTree* self,
                                                              GtkTreeViewColumn* col,
                                                              GtkTreePath* path,
                                                              gint x)
{
	gboolean result = FALSE;
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeModel* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GraniteWidgetsCellRendererExpander* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeIter _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTreeModel* _tmp11_;
	GtkTreeModel* _tmp12_;
	GtkTreeIter _tmp13_;
	gint indentation_level = 0;
	GraniteWidgetsSourceListPatchCellRendererSpacer* last_spacer_cell = NULL;
	GeeHashMap* _tmp14_;
	gint _tmp15_;
	gpointer _tmp16_;
	GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp17_;
#line 2147 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2147 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (col != NULL, FALSE);
#line 2147 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 2149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 2149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gtk_tree_model_get_iter (_tmp1_, &_tmp2_, path);
#line 2149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	iter = _tmp2_;
#line 2149 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!_tmp3_) {
#line 2150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 2150 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 11818 "SourceList.c"
	}
#line 2153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = self->priv->primary_expander_cell;
#line 2153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = _tmp5_;
#line 2153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = iter;
#line 2153 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_expander_cell_data_func (self, (GtkCellLayout*) col, (GtkCellRenderer*) _tmp4_, _tmp6_, &_tmp7_);
#line 2155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = self->priv->primary_expander_cell;
#line 2155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = gtk_cell_renderer_get_visible ((GtkCellRenderer*) _tmp8_);
#line 2155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = _tmp9_;
#line 2155 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (!_tmp10_) {
#line 2156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 2156 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 11842 "SourceList.c"
	}
#line 2159 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp11_ = gtk_tree_view_get_model ((GtkTreeView*) self);
#line 2159 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = _tmp11_;
#line 2159 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp13_ = iter;
#line 2159 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (gtk_tree_model_iter_n_children (_tmp12_, &_tmp13_) < 1) {
#line 2160 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		result = FALSE;
#line 2160 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		return result;
#line 11856 "SourceList.c"
	}
#line 2168 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	indentation_level = gtk_tree_path_get_depth (path);
#line 2169 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp14_ = self->priv->spacer_cells;
#line 2169 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp15_ = indentation_level;
#line 2169 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp16_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, (gpointer) ((gintptr) _tmp15_));
#line 2169 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	last_spacer_cell = (GraniteWidgetsSourceListPatchCellRendererSpacer*) _tmp16_;
#line 2171 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp17_ = last_spacer_cell;
#line 2171 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp17_ != NULL) {
#line 11872 "SourceList.c"
		gint cell_x = 0;
		gint cell_width = 0;
		GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp18_;
		gint _tmp19_ = 0;
		gint _tmp20_ = 0;
		gboolean _tmp21_;
#line 2174 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = last_spacer_cell;
#line 2174 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp21_ = gtk_tree_view_column_cell_get_position (col, (GtkCellRenderer*) _tmp18_, &_tmp19_, &_tmp20_);
#line 2174 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		cell_x = _tmp19_;
#line 2174 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		cell_width = _tmp20_;
#line 2174 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp21_) {
#line 11889 "SourceList.c"
			gint expander_width = 0;
			GraniteWidgetsCellRendererExpander* _tmp22_;
			gint indentation_offset = 0;
			gint _tmp23_;
			gint _tmp24_;
			gboolean _tmp25_ = FALSE;
			gint _tmp26_;
#line 2176 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp22_ = self->priv->primary_expander_cell;
#line 2176 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			expander_width = granite_widgets_source_list_patch_tree_get_cell_width (self, (GtkCellRenderer*) _tmp22_) + 1;
#line 2179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp23_ = cell_x;
#line 2179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp24_ = cell_width;
#line 2179 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			indentation_offset = _tmp23_ + _tmp24_;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp26_ = indentation_offset;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (x >= _tmp26_) {
#line 11911 "SourceList.c"
				gint _tmp27_;
				gint _tmp28_;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp27_ = indentation_offset;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp28_ = expander_width;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp25_ = x <= (_tmp27_ + _tmp28_);
#line 11920 "SourceList.c"
			} else {
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp25_ = FALSE;
#line 11924 "SourceList.c"
			}
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = _tmp25_;
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (last_spacer_cell);
#line 2180 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 11932 "SourceList.c"
		}
	}
#line 2187 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 2187 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (last_spacer_cell);
#line 2187 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 11941 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_over_cell (GraniteWidgetsSourceListPatchTree* self,
                                                  GtkTreeViewColumn* col,
                                                  GtkTreePath* path,
                                                  GtkCellRenderer* cell,
                                                  gint x)
{
	gboolean result = FALSE;
	gint cell_x = 0;
	gint cell_width = 0;
	gboolean found = FALSE;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
#line 2190 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2190 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (col != NULL, FALSE);
#line 2190 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 2190 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (cell != NULL, FALSE);
#line 2192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = gtk_tree_view_column_cell_get_position (col, cell, &_tmp0_, &_tmp1_);
#line 2192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	cell_x = _tmp0_;
#line 2192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	cell_width = _tmp1_;
#line 2192 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	found = _tmp2_;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = found;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_) {
#line 11982 "SourceList.c"
		gint _tmp6_;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = cell_x;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = x > _tmp6_;
#line 11988 "SourceList.c"
	} else {
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = FALSE;
#line 11992 "SourceList.c"
	}
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_) {
#line 11996 "SourceList.c"
		gint _tmp7_;
		gint _tmp8_;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = cell_x;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = cell_width;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = x < (_tmp7_ + _tmp8_);
#line 12005 "SourceList.c"
	} else {
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = FALSE;
#line 12009 "SourceList.c"
	}
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp3_;
#line 2193 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12015 "SourceList.c"
}


static gint
granite_widgets_source_list_patch_tree_get_cell_width (GraniteWidgetsSourceListPatchTree* self,
                                                       GtkCellRenderer* cell_renderer)
{
	gint result = 0;
	GtkRequisition min_req = {0};
	GtkRequisition _tmp0_ = {0};
	GtkRequisition _tmp1_;
	gint _tmp2_;
#line 2196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 2196 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (cell_renderer != NULL, 0);
#line 2198 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_renderer_get_preferred_size (cell_renderer, (GtkWidget*) self, &_tmp0_, NULL);
#line 2198 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	min_req = _tmp0_;
#line 2199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = min_req;
#line 2199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_.width;
#line 2199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2199 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12044 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_real_popup_menu (GtkWidget* base)
{
	GraniteWidgetsSourceListPatchTree * self;
	gboolean result = FALSE;
#line 2202 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = (GraniteWidgetsSourceListPatchTree*) base;
#line 2203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = granite_widgets_source_list_patch_tree_popup_context_menu (self, NULL, NULL);
#line 2203 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12059 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_popup_context_menu (GraniteWidgetsSourceListPatchTree* self,
                                                           GraniteWidgetsSourceListPatchItem* item,
                                                           GdkEventButton* event)
{
	gboolean result = FALSE;
#line 2206 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2207 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (item == NULL) {
#line 12073 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp0_;
		GraniteWidgetsSourceListPatchItem* _tmp1_;
#line 2208 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = granite_widgets_source_list_patch_tree_get_selected_item (self);
#line 2208 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp1_ = _tmp0_;
#line 2208 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		item = _tmp1_;
#line 12082 "SourceList.c"
	}
#line 2210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (item != NULL) {
#line 12086 "SourceList.c"
		GtkMenu* menu = NULL;
		GtkMenu* _tmp2_;
		GtkMenu* _tmp3_;
#line 2211 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp2_ = granite_widgets_source_list_patch_item_get_context_menu (item);
#line 2211 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		menu = _tmp2_;
#line 2212 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = menu;
#line 2212 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp3_ != NULL) {
#line 12098 "SourceList.c"
			GtkMenu* _tmp4_;
			GtkMenu* _tmp5_;
#line 2213 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp4_ = menu;
#line 2213 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_object_set (_tmp4_, "attach-widget", (GtkWidget*) self, NULL);
#line 2214 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp5_ = menu;
#line 2214 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_menu_popup_at_pointer (_tmp5_, (GdkEvent*) event);
#line 2215 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (event == NULL) {
#line 12111 "SourceList.c"
				GtkMenu* _tmp6_;
#line 2216 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp6_ = menu;
#line 2216 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				gtk_menu_shell_select_first ((GtkMenuShell*) _tmp6_, FALSE);
#line 12117 "SourceList.c"
			}
#line 2219 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			result = TRUE;
#line 2219 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (menu);
#line 2219 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			return result;
#line 12125 "SourceList.c"
		}
#line 2210 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (menu);
#line 12129 "SourceList.c"
	}
#line 2223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = FALSE;
#line 2223 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12135 "SourceList.c"
}


static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_tree_get_item_from_model (GtkTreeModel* model,
                                                            GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchItem* result = NULL;
	GraniteWidgetsSourceListPatchDataModel* data_model = NULL;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
	GtkTreeIter _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
#line 2226 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (model != NULL, NULL);
#line 2226 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (iter != NULL, NULL);
#line 2227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (model, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL) ? ((GraniteWidgetsSourceListPatchDataModel*) model) : NULL);
#line 2227 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	data_model = _tmp0_;
#line 2228 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (data_model != NULL, "data_model != null");
#line 2229 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = *iter;
#line 2229 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = granite_widgets_source_list_patch_data_model_get_item (data_model, &_tmp1_);
#line 2229 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 2229 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (data_model);
#line 2229 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12168 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_spacer_cell_data_func (GtkCellLayout* layout,
                                                              GtkCellRenderer* renderer,
                                                              GtkTreeModel* model,
                                                              GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchCellRendererSpacer* spacer = NULL;
	GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp0_;
	GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp1_;
	GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GtkTreePath* path = NULL;
	GtkTreeIter _tmp5_;
	GtkTreePath* _tmp6_;
	gint level = 0;
	GtkTreePath* _tmp7_;
	GraniteWidgetsSourceListPatchCellRendererSpacer* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2235 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_SPACER) ? ((GraniteWidgetsSourceListPatchCellRendererSpacer*) renderer) : NULL);
#line 2235 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	spacer = _tmp0_;
#line 2236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = spacer;
#line 2236 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "spacer != null");
#line 2237 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = spacer;
#line 2237 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_patch_cell_renderer_spacer_get_level (_tmp2_);
#line 2237 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = _tmp3_;
#line 2237 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp4_ > 0, "spacer.level > 0");
#line 2239 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = *iter;
#line 2239 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = gtk_tree_model_get_path (model, &_tmp5_);
#line 2239 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	path = _tmp6_;
#line 2241 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	level = -1;
#line 2242 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = path;
#line 2242 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp7_ != NULL) {
#line 12229 "SourceList.c"
		GtkTreePath* _tmp8_;
#line 2243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = path;
#line 2243 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		level = gtk_tree_path_get_depth (_tmp8_);
#line 12235 "SourceList.c"
	}
#line 2245 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = spacer;
#line 2245 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = granite_widgets_source_list_patch_cell_renderer_spacer_get_level (_tmp9_);
#line 2245 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp11_ = _tmp10_;
#line 2245 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = level;
#line 2245 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_renderer_set_visible (renderer, _tmp11_ <= _tmp12_);
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	__vala_GtkTreePath_free0 (path);
#line 2232 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (spacer);
#line 12251 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_name_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                            GtkCellLayout* layout,
                                                            GtkCellRenderer* renderer,
                                                            GtkTreeModel* model,
                                                            GtkTreeIter* iter)
{
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GString* text = NULL;
	GString* _tmp2_;
	PangoWeight weight = 0;
	gboolean use_markup = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeIter _tmp3_;
	GraniteWidgetsSourceListPatchItem* _tmp4_;
	GraniteWidgetsSourceListPatchItem* _tmp5_;
	GtkCellRendererText* _tmp23_;
	PangoWeight _tmp24_;
	gboolean _tmp25_;
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2251 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, gtk_cell_renderer_text_get_type ()) ? ((GtkCellRendererText*) renderer) : NULL);
#line 2251 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	text_renderer = _tmp0_;
#line 2252 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = text_renderer;
#line 2252 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "text_renderer != null");
#line 2254 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = g_string_new ("");
#line 2254 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	text = _tmp2_;
#line 2255 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	weight = PANGO_WEIGHT_NORMAL;
#line 2256 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	use_markup = FALSE;
#line 2258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = *iter;
#line 2258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = granite_widgets_source_list_patch_tree_get_item_from_model (model, &_tmp3_);
#line 2258 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp4_;
#line 2259 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = item;
#line 2259 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_ != NULL) {
#line 12312 "SourceList.c"
		GraniteWidgetsSourceListPatchItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gboolean _tmp17_ = FALSE;
		GraniteWidgetsSourceListPatchItem* _tmp18_;
		gboolean _tmp19_;
#line 2260 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = item;
#line 2260 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = granite_widgets_source_list_patch_item_get_markup (_tmp6_);
#line 2260 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = _tmp7_;
#line 2260 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp8_ != NULL) {
#line 12327 "SourceList.c"
			GString* _tmp9_;
			GraniteWidgetsSourceListPatchItem* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 2261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = text;
#line 2261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = item;
#line 2261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = granite_widgets_source_list_patch_item_get_markup (_tmp10_);
#line 2261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = _tmp11_;
#line 2261 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_string_append (_tmp9_, _tmp12_);
#line 2262 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			use_markup = TRUE;
#line 12344 "SourceList.c"
		} else {
			GString* _tmp13_;
			GraniteWidgetsSourceListPatchItem* _tmp14_;
			const gchar* _tmp15_;
			const gchar* _tmp16_;
#line 2264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = text;
#line 2264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = item;
#line 2264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp15_ = granite_widgets_source_list_patch_item_get_name (_tmp14_);
#line 2264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = _tmp15_;
#line 2264 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_string_append (_tmp13_, _tmp16_);
#line 12360 "SourceList.c"
		}
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp18_ = item;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = _tmp18_->use_pango_style;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp19_) {
#line 12368 "SourceList.c"
			GraniteWidgetsSourceListPatchDataModel* _tmp20_;
			GraniteWidgetsSourceListPatchItem* _tmp21_;
			GtkTreeIter _tmp22_;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp20_ = self->priv->_data_model;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp21_ = item;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp22_ = *iter;
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = granite_widgets_source_list_patch_data_model_is_category (_tmp20_, _tmp21_, &_tmp22_, NULL);
#line 12380 "SourceList.c"
		} else {
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = FALSE;
#line 12384 "SourceList.c"
		}
#line 2267 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp17_) {
#line 2268 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			weight = PANGO_WEIGHT_BOLD;
#line 12390 "SourceList.c"
		}
	}
#line 2272 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp23_ = text_renderer;
#line 2272 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp24_ = weight;
#line 2272 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp23_, "weight", (gint) _tmp24_, NULL);
#line 2274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp25_ = use_markup;
#line 2274 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp25_) {
#line 12403 "SourceList.c"
		GtkCellRendererText* _tmp26_;
		GString* _tmp27_;
		const gchar* _tmp28_;
#line 2275 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp26_ = text_renderer;
#line 2275 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp27_ = text;
#line 2275 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp28_ = _tmp27_->str;
#line 2275 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set (_tmp26_, "markup", _tmp28_, NULL);
#line 12415 "SourceList.c"
	} else {
		GtkCellRendererText* _tmp29_;
		GString* _tmp30_;
		const gchar* _tmp31_;
#line 2277 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp29_ = text_renderer;
#line 2277 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp30_ = text;
#line 2277 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp31_ = _tmp30_->str;
#line 2277 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_set (_tmp29_, "text", _tmp31_, NULL);
#line 12428 "SourceList.c"
	}
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_string_free0 (text);
#line 2248 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (text_renderer);
#line 12436 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_badge_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                             GtkCellLayout* layout,
                                                             GtkCellRenderer* renderer,
                                                             GtkTreeModel* model,
                                                             GtkTreeIter* iter)
{
	GraniteWidgetsCellRendererBadge* badge_renderer = NULL;
	GraniteWidgetsCellRendererBadge* _tmp0_;
	GraniteWidgetsCellRendererBadge* _tmp1_;
	gchar* text = NULL;
	gchar* _tmp2_;
	gboolean visible = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeIter _tmp3_;
	GraniteWidgetsSourceListPatchItem* _tmp4_;
	GraniteWidgetsSourceListPatchItem* _tmp5_;
	GraniteWidgetsCellRendererBadge* _tmp20_;
	gboolean _tmp21_;
	GraniteWidgetsCellRendererBadge* _tmp22_;
	const gchar* _tmp23_;
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_TYPE_CELL_RENDERER_BADGE) ? ((GraniteWidgetsCellRendererBadge*) renderer) : NULL);
#line 2284 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	badge_renderer = _tmp0_;
#line 2285 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = badge_renderer;
#line 2285 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "badge_renderer != null");
#line 2287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = g_strdup ("");
#line 2287 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	text = _tmp2_;
#line 2288 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	visible = FALSE;
#line 2290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = *iter;
#line 2290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = granite_widgets_source_list_patch_tree_get_item_from_model (model, &_tmp3_);
#line 2290 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp4_;
#line 2291 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = item;
#line 2291 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp5_ != NULL) {
#line 12495 "SourceList.c"
		gboolean _tmp6_ = FALSE;
		GraniteWidgetsSourceListPatchItem* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gboolean _tmp15_;
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp7_ = item;
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp8_ = granite_widgets_source_list_patch_item_get_badge (_tmp7_);
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp9_ = _tmp8_;
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp9_ != NULL) {
#line 12509 "SourceList.c"
			GraniteWidgetsSourceListPatchItem* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = item;
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = granite_widgets_source_list_patch_item_get_badge (_tmp10_);
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = _tmp11_;
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp13_ = string_strip (_tmp12_);
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp14_ = _tmp13_;
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = g_strcmp0 (_tmp14_, "") != 0;
#line 2293 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (_tmp14_);
#line 12529 "SourceList.c"
		} else {
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp6_ = FALSE;
#line 12533 "SourceList.c"
		}
#line 2292 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		visible = _tmp6_;
#line 2295 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = visible;
#line 2295 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp15_) {
#line 12541 "SourceList.c"
			GraniteWidgetsSourceListPatchItem* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = item;
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = granite_widgets_source_list_patch_item_get_badge (_tmp16_);
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp18_ = _tmp17_;
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp19_ = g_strdup (_tmp18_);
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_free0 (text);
#line 2296 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			text = _tmp19_;
#line 12558 "SourceList.c"
		}
	}
#line 2299 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp20_ = badge_renderer;
#line 2299 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp21_ = visible;
#line 2299 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp20_, _tmp21_);
#line 2300 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp22_ = badge_renderer;
#line 2300 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp23_ = text;
#line 2300 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_cell_renderer_badge_set_text (_tmp22_, _tmp23_);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_free0 (text);
#line 2281 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (badge_renderer);
#line 12579 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_icon_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                            GtkCellLayout* layout,
                                                            GtkCellRenderer* renderer,
                                                            GtkTreeModel* model,
                                                            GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchCellRendererIcon* icon_renderer = NULL;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp0_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp1_;
	GIcon* icon = NULL;
	gboolean visible = FALSE;
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeIter _tmp2_;
	GraniteWidgetsSourceListPatchItem* _tmp3_;
	GraniteWidgetsSourceListPatchItem* _tmp4_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp20_;
	gboolean _tmp21_;
	GIcon* _tmp22_ = NULL;
	gboolean _tmp23_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp25_;
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2306 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (renderer, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_CELL_RENDERER_ICON) ? ((GraniteWidgetsSourceListPatchCellRendererIcon*) renderer) : NULL);
#line 2306 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	icon_renderer = _tmp0_;
#line 2307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = icon_renderer;
#line 2307 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_vala_assert (_tmp1_ != NULL, "icon_renderer != null");
#line 2309 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	icon = NULL;
#line 2311 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	visible = TRUE;
#line 2313 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = *iter;
#line 2313 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = granite_widgets_source_list_patch_tree_get_item_from_model (model, &_tmp2_);
#line 2313 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp3_;
#line 2314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = item;
#line 2314 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp4_ != NULL) {
#line 12638 "SourceList.c"
		GraniteWidgetsSourceListPatchCellRendererIcon* _tmp5_;
		GraniteWidgetsSourceListPatchCellRendererIcon* _tmp6_;
#line 2315 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = icon_renderer;
#line 2315 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp6_ = self->priv->icon_cell;
#line 2315 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_ == _tmp6_) {
#line 12647 "SourceList.c"
			GraniteWidgetsSourceListPatchItem* _tmp7_;
			GIcon* _tmp8_;
			GIcon* _tmp9_;
			GIcon* _tmp10_;
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp7_ = item;
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = granite_widgets_source_list_patch_item_get_icon (_tmp7_);
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp9_ = _tmp8_;
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp10_ = _g_object_ref0 (_tmp9_);
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_g_object_unref0 (icon);
#line 2316 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			icon = _tmp10_;
#line 12664 "SourceList.c"
		} else {
			GraniteWidgetsSourceListPatchCellRendererIcon* _tmp11_;
			GraniteWidgetsSourceListPatchCellRendererIcon* _tmp12_;
#line 2317 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp11_ = icon_renderer;
#line 2317 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp12_ = self->priv->activatable_cell;
#line 2317 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp11_ == _tmp12_) {
#line 12674 "SourceList.c"
				GraniteWidgetsSourceListPatchItem* _tmp13_;
				GIcon* _tmp14_;
				GIcon* _tmp15_;
				GIcon* _tmp16_;
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp13_ = item;
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp14_ = granite_widgets_source_list_patch_item_get_activatable (_tmp13_);
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp15_ = _tmp14_;
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp16_ = _g_object_ref0 (_tmp15_);
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_g_object_unref0 (icon);
#line 2318 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				icon = _tmp16_;
#line 12691 "SourceList.c"
			} else {
#line 2320 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				g_assert_not_reached ();
#line 12695 "SourceList.c"
			}
		}
	}
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp18_ = visible;
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp18_) {
#line 12703 "SourceList.c"
		GIcon* _tmp19_;
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp19_ = icon;
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = _tmp19_ != NULL;
#line 12709 "SourceList.c"
	} else {
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp17_ = FALSE;
#line 12713 "SourceList.c"
	}
#line 2323 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	visible = _tmp17_;
#line 2325 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp20_ = icon_renderer;
#line 2325 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp21_ = visible;
#line 2325 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_renderer_set_visible ((GtkCellRenderer*) _tmp20_, _tmp21_);
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp23_ = visible;
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp23_) {
#line 12727 "SourceList.c"
		GIcon* _tmp24_;
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp24_ = icon;
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp22_ = _tmp24_;
#line 12733 "SourceList.c"
	} else {
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp22_ = NULL;
#line 12737 "SourceList.c"
	}
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp25_ = icon_renderer;
#line 2326 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRendererPixbuf*) _tmp25_, "gicon", _tmp22_, NULL);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (icon);
#line 2303 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (icon_renderer);
#line 12749 "SourceList.c"
}


/**
             * Controls expander visibility.
             */
static void
granite_widgets_source_list_patch_tree_expander_cell_data_func (GraniteWidgetsSourceListPatchTree* self,
                                                                GtkCellLayout* layout,
                                                                GtkCellRenderer* renderer,
                                                                GtkTreeModel* model,
                                                                GtkTreeIter* iter)
{
	GraniteWidgetsSourceListPatchItem* item = NULL;
	GtkTreeIter _tmp0_;
	GraniteWidgetsSourceListPatchItem* _tmp1_;
	GraniteWidgetsSourceListPatchItem* _tmp2_;
	GraniteWidgetsCellRendererExpander* _tmp12_;
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (layout != NULL);
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (renderer != NULL);
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (model != NULL);
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (iter != NULL);
#line 2335 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = *iter;
#line 2335 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = granite_widgets_source_list_patch_tree_get_item_from_model (model, &_tmp0_);
#line 2335 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item = _tmp1_;
#line 2336 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = item;
#line 2336 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (_tmp2_ != NULL) {
#line 12788 "SourceList.c"
		GraniteWidgetsSourceListPatchExpandableItem* expandable_item = NULL;
		GraniteWidgetsSourceListPatchItem* _tmp3_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp4_;
		GraniteWidgetsSourceListPatchExpandableItem* _tmp5_;
#line 2340 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp3_ = item;
#line 2340 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM) ? ((GraniteWidgetsSourceListPatchExpandableItem*) _tmp3_) : NULL);
#line 2340 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		expandable_item = _tmp4_;
#line 2341 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp5_ = expandable_item;
#line 2341 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (_tmp5_ != NULL) {
#line 12803 "SourceList.c"
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_object_get (renderer, "is-expander", &_tmp7_, NULL);
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp8_ = _tmp7_;
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			if (_tmp8_) {
#line 12813 "SourceList.c"
				GraniteWidgetsSourceListPatchExpandableItem* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp9_ = expandable_item;
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp10_ = granite_widgets_source_list_patch_expandable_item_get_collapsible (_tmp9_);
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp11_ = _tmp10_;
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp6_ = _tmp11_;
#line 12825 "SourceList.c"
			} else {
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
				_tmp6_ = FALSE;
#line 12829 "SourceList.c"
			}
#line 2342 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_object_set (renderer, "is-expander", _tmp6_, NULL);
#line 12833 "SourceList.c"
		}
#line 2336 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (expandable_item);
#line 12837 "SourceList.c"
	}
#line 2345 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = self->priv->primary_expander_cell;
#line 2345 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (renderer == G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
#line 12843 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModel* _tmp13_;
		GtkTreeIter _tmp14_;
#line 2346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp13_ = self->priv->_data_model;
#line 2346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp14_ = *iter;
#line 2346 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		gtk_cell_renderer_set_visible (renderer, !granite_widgets_source_list_patch_data_model_is_iter_at_root_level (_tmp13_, &_tmp14_));
#line 12852 "SourceList.c"
	} else {
		GraniteWidgetsCellRendererExpander* _tmp15_;
#line 2347 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp15_ = self->priv->secondary_expander_cell;
#line 2347 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		if (renderer == G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_cell_renderer_get_type (), GtkCellRenderer)) {
#line 12859 "SourceList.c"
			GraniteWidgetsSourceListPatchDataModel* _tmp16_;
			GraniteWidgetsSourceListPatchItem* _tmp17_;
			GtkTreeIter _tmp18_;
#line 2348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp16_ = self->priv->_data_model;
#line 2348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp17_ = item;
#line 2348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			_tmp18_ = *iter;
#line 2348 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			gtk_cell_renderer_set_visible (renderer, granite_widgets_source_list_patch_data_model_is_category (_tmp16_, _tmp17_, &_tmp18_, NULL));
#line 12871 "SourceList.c"
		} else {
#line 2350 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
			g_assert_not_reached ();
#line 12875 "SourceList.c"
		}
	}
#line 2332 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item);
#line 12880 "SourceList.c"
}


static GraniteWidgetsSourceListPatchDataModel*
granite_widgets_source_list_patch_tree_get_data_model (GraniteWidgetsSourceListPatchTree* self)
{
	GraniteWidgetsSourceListPatchDataModel* result;
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->_data_model;
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12897 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_set_data_model (GraniteWidgetsSourceListPatchTree* self,
                                                       GraniteWidgetsSourceListPatchDataModel* value)
{
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	if (granite_widgets_source_list_patch_tree_get_data_model (self) != value) {
#line 12909 "SourceList.c"
		GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		_g_object_unref0 (self->priv->_data_model);
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		self->priv->_data_model = _tmp0_;
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY]);
#line 12919 "SourceList.c"
	}
}


static GraniteWidgetsSourceListPatchItem*
granite_widgets_source_list_patch_tree_get_selected_item (GraniteWidgetsSourceListPatchTree* self)
{
	GraniteWidgetsSourceListPatchItem* result;
	GraniteWidgetsSourceListPatchItem* _tmp0_;
#line 1447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->selected;
#line 1447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp0_;
#line 1447 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12937 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_set_selected_item (GraniteWidgetsSourceListPatchTree* self,
                                                          GraniteWidgetsSourceListPatchItem* value)
{
#line 1448 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1448 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_set_selected (self, value, TRUE);
#line 1448 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY]);
#line 12951 "SourceList.c"
}


static gboolean
granite_widgets_source_list_patch_tree_get_editing (GraniteWidgetsSourceListPatchTree* self)
{
	gboolean result;
	GtkCellRendererText* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_get ((GtkCellRenderer*) _tmp0_, "editing", &_tmp1_, NULL);
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 1452 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12974 "SourceList.c"
}


static PangoEllipsizeMode
granite_widgets_source_list_patch_tree_get_ellipsize_mode (GraniteWidgetsSourceListPatchTree* self)
{
	PangoEllipsizeMode result;
	GtkCellRendererText* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_get (_tmp0_, "ellipsize", &_tmp1_, NULL);
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = _tmp1_;
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	result = _tmp2_;
#line 1456 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 12997 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_set_ellipsize_mode (GraniteWidgetsSourceListPatchTree* self,
                                                           PangoEllipsizeMode value)
{
	GtkCellRendererText* _tmp0_;
#line 1457 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_return_if_fail (self != NULL);
#line 1457 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = self->priv->text_cell;
#line 1457 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp0_, "ellipsize", value, NULL);
#line 1457 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_notify_by_pspec ((GObject *) self, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY]);
#line 13014 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_expander_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                           GtkCellRenderer* cell,
                                                                                           GtkTreeModel* tree_model,
                                                                                           GtkTreeIter* iter,
                                                                                           gpointer self)
{
#line 1547 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_expander_cell_data_func ((GraniteWidgetsSourceListPatchTree*) self, cell_layout, cell, tree_model, iter);
#line 13027 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_on_activatable_activated_granite_widgets_source_list_patch_cell_renderer_icon_activated (GraniteWidgetsSourceListPatchCellRendererIcon* _sender,
                                                                                                                                 const gchar* path,
                                                                                                                                 gpointer self)
{
#line 1551 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_activatable_activated ((GraniteWidgetsSourceListPatchTree*) self, path);
#line 13038 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_icon_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                       GtkCellRenderer* cell,
                                                                                       GtkTreeModel* tree_model,
                                                                                       GtkTreeIter* iter,
                                                                                       gpointer self)
{
#line 1553 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_icon_cell_data_func ((GraniteWidgetsSourceListPatchTree*) self, cell_layout, cell, tree_model, iter);
#line 13051 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_badge_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                        GtkCellRenderer* cell,
                                                                                        GtkTreeModel* tree_model,
                                                                                        GtkTreeIter* iter,
                                                                                        gpointer self)
{
#line 1559 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_badge_cell_data_func ((GraniteWidgetsSourceListPatchTree*) self, cell_layout, cell, tree_model, iter);
#line 13064 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_on_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                              GtkCellEditable* editable,
                                                                                              const gchar* path,
                                                                                              gpointer self)
{
#line 1564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_editing_started ((GraniteWidgetsSourceListPatchTree*) self, editable, path);
#line 13076 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                                gpointer self)
{
#line 1565 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_on_editing_canceled ((GraniteWidgetsSourceListPatchTree*) self);
#line 13086 "SourceList.c"
}


static void
_granite_widgets_source_list_patch_tree_name_cell_data_func_gtk_cell_layout_data_func (GtkCellLayout* cell_layout,
                                                                                       GtkCellRenderer* cell,
                                                                                       GtkTreeModel* tree_model,
                                                                                       GtkTreeIter* iter,
                                                                                       gpointer self)
{
#line 1569 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_name_cell_data_func ((GraniteWidgetsSourceListPatchTree*) self, cell_layout, cell, tree_model, iter);
#line 13099 "SourceList.c"
}


static gboolean
_granite_widgets_source_list_patch_tree_select_func_gtk_tree_selection_func (GtkTreeSelection* selection,
                                                                             GtkTreeModel* model,
                                                                             GtkTreePath* path,
                                                                             gboolean path_currently_selected,
                                                                             gpointer self)
{
	gboolean result;
	result = granite_widgets_source_list_patch_tree_select_func ((GraniteWidgetsSourceListPatchTree*) self, selection, model, path, path_currently_selected);
#line 1589 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return result;
#line 13114 "SourceList.c"
}


static GObject *
granite_widgets_source_list_patch_tree_constructor (GType type,
                                                    guint n_construct_properties,
                                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	GraniteWidgetsSourceListPatchTree * self;
	GtkCssProvider* _tmp0_;
	GtkCssProvider* _tmp1_;
	GraniteWidgetsSourceListPatchDataModel* _tmp2_;
	GtkTreeViewColumn* item_column = NULL;
	GtkTreeViewColumn* _tmp3_;
	GtkTreeViewColumn* _tmp4_;
	GtkTreeViewColumn* _tmp5_;
	GraniteWidgetsCellRendererExpander* _tmp6_;
	GraniteWidgetsCellRendererExpander* _tmp7_;
	GraniteWidgetsCellRendererExpander* _tmp8_;
	GtkTreeViewColumn* _tmp9_;
	GraniteWidgetsCellRendererExpander* _tmp10_;
	GtkTreeViewColumn* _tmp11_;
	GraniteWidgetsCellRendererExpander* _tmp12_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp13_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp14_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp15_;
	GtkTreeViewColumn* _tmp16_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp17_;
	GtkTreeViewColumn* _tmp18_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp19_;
	GraniteWidgetsCellRendererBadge* _tmp20_;
	GraniteWidgetsCellRendererBadge* _tmp21_;
	GraniteWidgetsCellRendererBadge* _tmp22_;
	GtkTreeViewColumn* _tmp23_;
	GraniteWidgetsCellRendererBadge* _tmp24_;
	GtkTreeViewColumn* _tmp25_;
	GraniteWidgetsCellRendererBadge* _tmp26_;
	GtkCellRendererText* _tmp27_;
	GtkCellRendererText* _tmp28_;
	GtkCellRendererText* _tmp29_;
	GtkCellRendererText* _tmp30_;
	GtkCellRendererText* _tmp31_;
	GtkCellRendererText* _tmp32_;
	GtkCellRendererText* _tmp33_;
	GtkTreeViewColumn* _tmp34_;
	GtkCellRendererText* _tmp35_;
	GtkTreeViewColumn* _tmp36_;
	GtkCellRendererText* _tmp37_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp38_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp39_;
	GtkTreeViewColumn* _tmp40_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp41_;
	GtkTreeViewColumn* _tmp42_;
	GraniteWidgetsSourceListPatchCellRendererIcon* _tmp43_;
	GraniteWidgetsCellRendererExpander* _tmp44_;
	gint expander_spacing = 0;
	gint _tmp45_ = 0;
	GraniteWidgetsCellRendererExpander* _tmp46_;
	gint _tmp47_;
	GtkTreeViewColumn* _tmp48_;
	GraniteWidgetsCellRendererExpander* _tmp49_;
	GtkTreeViewColumn* _tmp50_;
	GraniteWidgetsCellRendererExpander* _tmp51_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp52_;
	GtkTreeSelection* _tmp53_;
	GtkTreeSelection* _tmp54_;
	GtkTreeSelection* _tmp55_;
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	parent_class = G_OBJECT_CLASS (granite_widgets_source_list_patch_tree_parent_class);
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTree);
#line 1516 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_utils_set_theming ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DEFAULT_STYLESHEET, GRANITE_STYLE_CLASS_SOURCE_LIST, GTK_STYLE_PROVIDER_PRIORITY_FALLBACK);
#line 1516 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1516 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (_tmp1_);
#line 1519 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = self->priv->_data_model;
#line 1519 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_set_model ((GtkTreeView*) self, (GtkTreeModel*) _tmp2_);
#line 1521 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 1521 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_FILL);
#line 1522 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkWidget*) self, "expand", TRUE, NULL);
#line 1524 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_set_enable_search ((GtkTreeView*) self, FALSE);
#line 1525 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_set_headers_visible ((GtkTreeView*) self, FALSE);
#line 1526 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkTreeView*) self, "enable-grid-lines", GTK_TREE_VIEW_GRID_LINES_NONE, NULL);
#line 1529 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_set_expander_column ((GtkTreeView*) self, NULL);
#line 1530 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_set_show_expanders ((GtkTreeView*) self, FALSE);
#line 1532 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = gtk_tree_view_column_new ();
#line 1532 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp3_);
#line 1532 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	item_column = _tmp3_;
#line 1533 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = item_column;
#line 1533 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_column_set_expand (_tmp4_, TRUE);
#line 1535 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = item_column;
#line 1535 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_view_insert_column ((GtkTreeView*) self, _tmp5_, (gint) GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_COLUMN_ITEM);
#line 1543 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp6_ = granite_widgets_cell_renderer_expander_new ();
#line 1543 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp6_);
#line 1543 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->secondary_expander_cell);
#line 1543 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->secondary_expander_cell = _tmp6_;
#line 1544 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp7_ = self->priv->secondary_expander_cell;
#line 1544 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_cell_renderer_expander_set_is_category_expander (_tmp7_, TRUE);
#line 1545 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp8_ = self->priv->secondary_expander_cell;
#line 1545 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp8_, "xpad", (guint) 10, NULL);
#line 1546 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp9_ = item_column;
#line 1546 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp10_ = self->priv->secondary_expander_cell;
#line 1546 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp9_, (GtkCellRenderer*) _tmp10_, FALSE);
#line 1547 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp11_ = item_column;
#line 1547 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp12_ = self->priv->secondary_expander_cell;
#line 1547 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp11_, (GtkCellRenderer*) _tmp12_, _granite_widgets_source_list_patch_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1549 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp13_ = granite_widgets_source_list_patch_cell_renderer_icon_new ();
#line 1549 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp13_);
#line 1549 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->activatable_cell);
#line 1549 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->activatable_cell = _tmp13_;
#line 1550 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp14_ = self->priv->activatable_cell;
#line 1550 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp14_, "xpad", (guint) 6, NULL);
#line 1551 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp15_ = self->priv->activatable_cell;
#line 1551 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object (_tmp15_, "activated", (GCallback) _granite_widgets_source_list_patch_tree_on_activatable_activated_granite_widgets_source_list_patch_cell_renderer_icon_activated, self, 0);
#line 1552 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp16_ = item_column;
#line 1552 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp17_ = self->priv->activatable_cell;
#line 1552 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp16_, (GtkCellRenderer*) _tmp17_, FALSE);
#line 1553 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp18_ = item_column;
#line 1553 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp19_ = self->priv->activatable_cell;
#line 1553 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp18_, (GtkCellRenderer*) _tmp19_, _granite_widgets_source_list_patch_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1555 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp20_ = granite_widgets_cell_renderer_badge_new ();
#line 1555 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp20_);
#line 1555 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->badge_cell);
#line 1555 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->badge_cell = _tmp20_;
#line 1556 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp21_ = self->priv->badge_cell;
#line 1556 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp21_, "xpad", (guint) 1, NULL);
#line 1557 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp22_ = self->priv->badge_cell;
#line 1557 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp22_, "xalign", (gfloat) 1, NULL);
#line 1558 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp23_ = item_column;
#line 1558 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp24_ = self->priv->badge_cell;
#line 1558 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp23_, (GtkCellRenderer*) _tmp24_, FALSE);
#line 1559 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp25_ = item_column;
#line 1559 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp26_ = self->priv->badge_cell;
#line 1559 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp25_, (GtkCellRenderer*) _tmp26_, _granite_widgets_source_list_patch_tree_badge_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1561 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp27_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 1561 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp27_);
#line 1561 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->text_cell);
#line 1561 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->text_cell = _tmp27_;
#line 1562 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp28_ = self->priv->text_cell;
#line 1562 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp28_, "editable-set", TRUE, NULL);
#line 1563 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp29_ = self->priv->text_cell;
#line 1563 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp29_, "editable", FALSE, NULL);
#line 1564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp30_ = self->priv->text_cell;
#line 1564 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp30_, "editing-started", (GCallback) _granite_widgets_source_list_patch_tree_on_editing_started_gtk_cell_renderer_editing_started, self, 0);
#line 1565 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp31_ = self->priv->text_cell;
#line 1565 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp31_, "editing-canceled", (GCallback) _granite_widgets_source_list_patch_tree_on_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
#line 1566 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp32_ = self->priv->text_cell;
#line 1566 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set (_tmp32_, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 1567 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp33_ = self->priv->text_cell;
#line 1567 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp33_, "xalign", (gfloat) 0, NULL);
#line 1568 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp34_ = item_column;
#line 1568 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp35_ = self->priv->text_cell;
#line 1568 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp34_, (GtkCellRenderer*) _tmp35_, TRUE);
#line 1569 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp36_ = item_column;
#line 1569 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp37_ = self->priv->text_cell;
#line 1569 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp36_, (GtkCellRenderer*) _tmp37_, _granite_widgets_source_list_patch_tree_name_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1571 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp38_ = granite_widgets_source_list_patch_cell_renderer_icon_new ();
#line 1571 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp38_);
#line 1571 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->icon_cell);
#line 1571 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->icon_cell = _tmp38_;
#line 1572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp39_ = self->priv->icon_cell;
#line 1572 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp39_, "xpad", (guint) 2, NULL);
#line 1573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp40_ = item_column;
#line 1573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp41_ = self->priv->icon_cell;
#line 1573 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp40_, (GtkCellRenderer*) _tmp41_, FALSE);
#line 1574 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp42_ = item_column;
#line 1574 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp43_ = self->priv->icon_cell;
#line 1574 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp42_, (GtkCellRenderer*) _tmp43_, _granite_widgets_source_list_patch_tree_icon_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1577 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp44_ = granite_widgets_cell_renderer_expander_new ();
#line 1577 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_ref_sink (_tmp44_);
#line 1577 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->primary_expander_cell);
#line 1577 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->primary_expander_cell = _tmp44_;
#line 1580 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_style_get ((GtkWidget*) self, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_EXPANDER_SPACING, &_tmp45_, NULL);
#line 1580 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	expander_spacing = _tmp45_;
#line 1581 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp46_ = self->priv->primary_expander_cell;
#line 1581 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp47_ = expander_spacing;
#line 1581 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_set ((GtkCellRenderer*) _tmp46_, "xpad", (guint) (_tmp47_ / 2), NULL);
#line 1583 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp48_ = item_column;
#line 1583 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp49_ = self->priv->primary_expander_cell;
#line 1583 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_pack_end ((GtkCellLayout*) _tmp48_, (GtkCellRenderer*) _tmp49_, FALSE);
#line 1584 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp50_ = item_column;
#line 1584 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp51_ = self->priv->primary_expander_cell;
#line 1584 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) _tmp50_, (GtkCellRenderer*) _tmp51_, _granite_widgets_source_list_patch_tree_expander_cell_data_func_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 1587 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp52_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 1587 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp53_ = _g_object_ref0 (_tmp52_);
#line 1587 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	selection = _tmp53_;
#line 1588 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp54_ = selection;
#line 1588 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_selection_set_mode (_tmp54_, GTK_SELECTION_BROWSE);
#line 1589 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp55_ = selection;
#line 1589 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_tree_selection_set_select_function (_tmp55_, _granite_widgets_source_list_patch_tree_select_func_gtk_tree_selection_func, g_object_ref (self), g_object_unref);
#line 1592 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_enable_item_property_monitor (self);
#line 1595 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_add_spacer_cell_for_level (self, 1, TRUE);
#line 1598 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_source (self, NULL, 0);
#line 1599 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_configure_drag_dest (self, NULL, 0, 0);
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (selection);
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (item_column);
#line 1515 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	return obj;
#line 13441 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_class_init (GraniteWidgetsSourceListPatchTreeClass * klass)
{
	GParamSpecInt* _tmp0_;
	GParamSpecInt* _tmp1_;
	GParamSpecInt* _tmp2_;
	GParamSpecInt* _tmp3_;
	GParamSpecInt* _tmp4_;
	GParamSpecInt* _tmp5_;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_parent_class = g_type_class_peek_parent (klass);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatchTree_private_offset);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->drag_motion = (gboolean (*) (GtkWidget*, GdkDragContext*, gint, gint, guint)) granite_widgets_source_list_patch_tree_real_drag_motion;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->drag_data_received = (void (*) (GtkWidget*, GdkDragContext*, gint, gint, GtkSelectionData*, guint, guint)) granite_widgets_source_list_patch_tree_real_drag_data_received;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkTreeViewClass *) klass)->cursor_changed = (void (*) (GtkTreeView*)) granite_widgets_source_list_patch_tree_real_cursor_changed;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_expanded = (void (*) (GtkTreeView*, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_patch_tree_real_row_expanded;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_collapsed = (void (*) (GtkTreeView*, GtkTreeIter*, GtkTreePath*)) granite_widgets_source_list_patch_tree_real_row_collapsed;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkTreeViewClass *) klass)->row_activated = (void (*) (GtkTreeView*, GtkTreePath*, GtkTreeViewColumn*)) granite_widgets_source_list_patch_tree_real_row_activated;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->key_release_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) granite_widgets_source_list_patch_tree_real_key_release_event;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) granite_widgets_source_list_patch_tree_real_button_release_event;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) granite_widgets_source_list_patch_tree_real_button_press_event;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GtkWidgetClass *) klass)->popup_menu = (gboolean (*) (GtkWidget*)) granite_widgets_source_list_patch_tree_real_popup_menu;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_tree_get_property;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_tree_set_property;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_patch_tree_constructor;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_tree_finalize;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY] = g_param_spec_object ("data-model", "data-model", "data-model", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_DATA_MODEL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY] = g_param_spec_object ("selected-item", "selected-item", "selected-item", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_EDITING_PROPERTY, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_EDITING_PROPERTY] = g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY, granite_widgets_source_list_patch_tree_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ITEM_SELECTED_SIGNAL] = g_signal_new ("item-selected", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 1492 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEVEL_INDENTATION, "Level Indentation", "Space to add at the beginning of every indentation level. Must be an e" \
"ven number.", 1, 50, 6, G_PARAM_READABLE);
#line 1492 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp1_ = _tmp0_;
#line 1492 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp1_);
#line 1492 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_param_spec_unref0 (_tmp1_);
#line 1498 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp2_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_LEFT_PADDING, "Left Padding", "Padding added to the left side of the tree. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
#line 1498 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp3_ = _tmp2_;
#line 1498 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp3_);
#line 1498 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_param_spec_unref0 (_tmp3_);
#line 1504 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp4_ = g_param_spec_int (GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_STYLE_PROP_EXPANDER_SPACING, "Expander Spacing", "Space added between an item and its expander. Must be an even number.", 1, 50, 4, G_PARAM_READABLE);
#line 1504 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp5_ = _tmp4_;
#line 1504 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	gtk_widget_class_install_style_property (GTK_WIDGET_CLASS (klass), (GParamSpec*) _tmp5_);
#line 1504 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_param_spec_unref0 (_tmp5_);
#line 13520 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_instance_init (GraniteWidgetsSourceListPatchTree * self)
{
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_tree_get_instance_private (self);
#line 1476 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->unselectable_item_clicked = FALSE;
#line 13531 "SourceList.c"
}


static void
granite_widgets_source_list_patch_tree_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatchTree * self;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTree);
#line 1603 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_tree_disable_item_property_monitor (self);
#line 1442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->_data_model);
#line 1465 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->selected);
#line 1468 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->editable_entry);
#line 1469 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->text_cell);
#line 1470 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->icon_cell);
#line 1471 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->activatable_cell);
#line 1472 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->badge_cell);
#line 1473 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->primary_expander_cell);
#line 1474 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->secondary_expander_cell);
#line 1475 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->spacer_cells);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_tree_parent_class)->finalize (obj);
#line 13565 "SourceList.c"
}


/**
         * The tree that actually displays the items.
         *
         * All the user interaction happens here.
         */
static GType
granite_widgets_source_list_patch_tree_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_tree_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_tree_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchTreeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_tree_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatchTree), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_tree_instance_init, NULL };
		GType granite_widgets_source_list_patch_tree_type_id;
		granite_widgets_source_list_patch_tree_type_id = g_type_register_static (gtk_tree_view_get_type (), "GraniteWidgetsSourceListPatchTree", &g_define_type_info, 0);
		GraniteWidgetsSourceListPatchTree_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_tree_type_id, sizeof (GraniteWidgetsSourceListPatchTreePrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_tree_type_id__volatile, granite_widgets_source_list_patch_tree_type_id);
	}
	return granite_widgets_source_list_patch_tree_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_tree_get_property (GObject * object,
                                                           guint property_id,
                                                           GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTree);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_tree_get_data_model (self));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_tree_get_selected_item (self));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_EDITING_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_tree_get_editing (self));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_enum (value, granite_widgets_source_list_patch_tree_get_ellipsize_mode (self));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13623 "SourceList.c"
		default:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13629 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_tree_set_property (GObject * object,
                                                           guint property_id,
                                                           const GValue * value,
                                                           GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatchTree * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_TREE, GraniteWidgetsSourceListPatchTree);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_DATA_MODEL_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_set_data_model (self, g_value_get_object (value));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_SELECTED_ITEM_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_set_selected_item (self, g_value_get_object (value));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_TREE_ELLIPSIZE_MODE_PROPERTY:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_tree_set_ellipsize_mode (self, g_value_get_enum (value));
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13662 "SourceList.c"
		default:
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 1440 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13668 "SourceList.c"
	}
}


static void
granite_widgets_source_list_patch_class_init (GraniteWidgetsSourceListPatchClass * klass)
{
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_parent_class = g_type_class_peek_parent (klass);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_type_class_adjust_private_offset (klass, &GraniteWidgetsSourceListPatch_private_offset);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	((GraniteWidgetsSourceListPatchClass *) klass)->item_selected = granite_widgets_source_list_patch_real_item_selected;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_granite_widgets_source_list_patch_get_property;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_granite_widgets_source_list_patch_set_property;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->constructor = granite_widgets_source_list_patch_constructor;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (klass)->finalize = granite_widgets_source_list_patch_finalize;
#line 13690 "SourceList.c"
	/**
	         * Root-level expandable item.
	         *
	         * This item contains the first-level source list items. It //only serves as an item container//.
	         * It is used to add and remove items to/from the widget.
	         *
	         * Internally, it allows the source list to connect to its {@link Granite.Widgets.SourceListPatch.ExpandableItem.child_added}
	         * and {@link Granite.Widgets.SourceListPatch.ExpandableItem.child_removed} signals in order to monitor
	         * new children additions/removals.
	         *
	         * @since 0.2
	         */
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY] = g_param_spec_object ("root", "root", "root", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_EXPANDABLE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13705 "SourceList.c"
	/**
	         * The current selected item.
	         *
	         * Setting it to //null// un-selects the previously selected item, if there was any.
	         * {@link Granite.Widgets.SourceListPatch.ExpandableItem.expand_with_parents} is called on the
	         * item's parent to make sure it's possible to select it.
	         *
	         * @since 0.2
	         */
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY] = g_param_spec_object ("selected", "selected", "selected", GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13717 "SourceList.c"
	/**
	         * Text ellipsize mode.
	         *
	         * @since 0.2
	         */
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13725 "SourceList.c"
	/**
	         * Whether an item is being edited.
	         *
	         * @see Granite.Widgets.SourceListPatch.start_editing_item
	         * @since 0.2
	         */
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GRANITE_WIDGETS_SOURCE_LIST_PATCH_EDITING_PROPERTY, granite_widgets_source_list_patch_properties[GRANITE_WIDGETS_SOURCE_LIST_PATCH_EDITING_PROPERTY] = g_param_spec_boolean ("editing", "editing", "editing", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 13734 "SourceList.c"
	/**
	         * Emitted when the source list selection changes.
	         *
	         * @param item Selected item; //null// if nothing is selected.
	         * @since 0.2
	         */
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	granite_widgets_source_list_patch_signals[GRANITE_WIDGETS_SOURCE_LIST_PATCH_ITEM_SELECTED_SIGNAL] = g_signal_new ("item-selected", GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (GraniteWidgetsSourceListPatchClass, item_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GRANITE_WIDGETS_SOURCE_LIST_PATCH_TYPE_ITEM);
#line 13743 "SourceList.c"
}


static void
granite_widgets_source_list_patch_instance_init (GraniteWidgetsSourceListPatch * self)
{
	GraniteWidgetsSourceListPatchDataModel* _tmp0_;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv = granite_widgets_source_list_patch_get_instance_private (self);
#line 2442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_tmp0_ = granite_widgets_source_list_patch_data_model_new ();
#line 2442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self->priv->data_model = _tmp0_;
#line 13757 "SourceList.c"
}


static void
granite_widgets_source_list_patch_finalize (GObject * obj)
{
	GraniteWidgetsSourceListPatch * self;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatch);
#line 2441 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->tree);
#line 2442 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	_g_object_unref0 (self->priv->data_model);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	G_OBJECT_CLASS (granite_widgets_source_list_patch_parent_class)->finalize (obj);
#line 13773 "SourceList.c"
}


GType
granite_widgets_source_list_patch_get_type (void)
{
	static volatile gsize granite_widgets_source_list_patch_type_id__volatile = 0;
	if (g_once_init_enter (&granite_widgets_source_list_patch_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GraniteWidgetsSourceListPatchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) granite_widgets_source_list_patch_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GraniteWidgetsSourceListPatch), 0, (GInstanceInitFunc) granite_widgets_source_list_patch_instance_init, NULL };
		GType granite_widgets_source_list_patch_type_id;
		granite_widgets_source_list_patch_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "GraniteWidgetsSourceListPatch", &g_define_type_info, 0);
		GraniteWidgetsSourceListPatch_private_offset = g_type_add_instance_private (granite_widgets_source_list_patch_type_id, sizeof (GraniteWidgetsSourceListPatchPrivate));
		g_once_init_leave (&granite_widgets_source_list_patch_type_id__volatile, granite_widgets_source_list_patch_type_id);
	}
	return granite_widgets_source_list_patch_type_id__volatile;
}


static void
_vala_granite_widgets_source_list_patch_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatch);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_get_root (self));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_object (value, granite_widgets_source_list_patch_get_selected (self));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_enum (value, granite_widgets_source_list_patch_get_ellipsize_mode (self));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_EDITING_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		g_value_set_boolean (value, granite_widgets_source_list_patch_get_editing (self));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13826 "SourceList.c"
		default:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13832 "SourceList.c"
	}
}


static void
_vala_granite_widgets_source_list_patch_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec)
{
	GraniteWidgetsSourceListPatch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GRANITE_WIDGETS_TYPE_SOURCE_LIST_PATCH, GraniteWidgetsSourceListPatch);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
	switch (property_id) {
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ROOT_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_set_root (self, g_value_get_object (value));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_SELECTED_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_set_selected (self, g_value_get_object (value));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		case GRANITE_WIDGETS_SOURCE_LIST_PATCH_ELLIPSIZE_MODE_PROPERTY:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		granite_widgets_source_list_patch_set_ellipsize_mode (self, g_value_get_enum (value));
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13865 "SourceList.c"
		default:
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 133 "/builddir/build/BUILD/Notes-up-2.0.0/src/GranitePatches/SourceList.vala"
		break;
#line 13871 "SourceList.c"
	}
}



